package com.blackledge.david.html.hme;

import java.awt.Color;

import com.tivo.hme.bananas.BEvent;
import com.tivo.hme.bananas.BHighlights;
import com.tivo.hme.bananas.BSkin.Element;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.sdk.Resource;

public class FormCheck extends BView {

	private Object form;
	private String name;
	private Object action;
	private BView label;
	private boolean isCheck;

	public FormCheck(boolean isCheck, Object object, String name, BView parent, int x, int y, int width, int height) {
		super(parent, x, y, getWidth(width, ((WebBrowserApp)parent.getBApp()).getTheme(), isCheck), getHeight(height, ((WebBrowserApp)parent.getBApp()).getTheme(), isCheck));
		this.name = name;
		this.isCheck = isCheck;
		init(object);
	}
	
	public static int getWidth(int width, WebBrowserTheme theme, boolean isCheck) {
		if (isCheck) {
			return width+theme.getFormOffsets(WebBrowserTheme.FORM.CHECKBOX)[1];
		} else {
			return width+theme.getFormOffsets(WebBrowserTheme.FORM.RADIO)[1];
		}
	}
	
	public static int getHeight(int height, WebBrowserTheme theme, boolean isCheck) {
		if (isCheck) {
			return height+theme.getFormOffsets(WebBrowserTheme.FORM.CHECKBOX)[0];
		} else {
			return height+theme.getFormOffsets(WebBrowserTheme.FORM.RADIO)[0];
		}
	}
	

	private void init(Object form) {
		this.form = form;
		
//		Resource r = getBApp().getSkin().get(H_KEYBOARD).getResource();
		Object r;
		if(isCheck) {
			r = ((WebBrowserApp)getBApp()).getTheme().getFormResource(WebBrowserTheme.FORM.CHECKBOX);
		} else {
			r = ((WebBrowserApp)getBApp()).getTheme().getFormResource(WebBrowserTheme.FORM.RADIO);
		}
		
		setResource(r, RSRC_HALIGN_CENTER| RSRC_VALIGN_CENTER|RSRC_IMAGE_VFIT);

		setFocusable(true);
		int[] offsets;
		if(isCheck) {
			offsets = ((WebBrowserApp)getBApp()).getTheme().getFormOffsets(WebBrowserTheme.FORM.CHECKBOX);
		} else {
			offsets = ((WebBrowserApp)getBApp()).getTheme().getFormOffsets(WebBrowserTheme.FORM.RADIO);
		}
		getHighlights().setWhisperingArrow(BHighlights.H_RIGHT,
				BHighlights.A_RIGHT+offsets[2],
				BHighlights.A_CENTER, "right");
		getHighlights().setWhisperingArrow(BHighlights.H_LEFT,
				BHighlights.A_LEFT+offsets[3],  
				BHighlights.A_CENTER, "left");
		getHighlights().setWhisperingArrow(BHighlights.H_UP,
				 BHighlights.A_CENTER, 
				 BHighlights.A_TOP+offsets[4], "up");
		getHighlights().setWhisperingArrow(BHighlights.H_DOWN,
				 BHighlights.A_CENTER, 
				 BHighlights.A_BOTTOM+offsets[5], "down");
	}
	

	 void updateCheck(String type, boolean checked, Color labelColor,
			String fontString) {
		 createLabel();

			if(labelColor == null) labelColor = Color.black;
		if (type.equals("checkbox")) {
			int[] offsets = ((WebBrowserApp)getBApp()).getTheme().getFormDetailOffsets(WebBrowserTheme.FORM.CHECKBOX, checked);
			label.setResource(((WebBrowserApp)getBApp()).getTheme().getFormDetailResource(WebBrowserTheme.FORM.CHECKBOX, checked), offsets[4] | RSRC_IMAGE_BESTFIT);
//			label.setResource(label.createText(fontString, labelColor,
//					checked ? "X" : "_"));
		} else {
			int[] offsets = ((WebBrowserApp)getBApp()).getTheme().getFormDetailOffsets(WebBrowserTheme.FORM.RADIO, checked);
			label.setResource(((WebBrowserApp)getBApp()).getTheme().getFormDetailResource(WebBrowserTheme.FORM.RADIO, checked), offsets[4] | RSRC_IMAGE_BESTFIT);
//			label.setResource(label.createText(fontString, labelColor,
//					checked ? " * ":"   "));
		}
	}

	private void createLabel() {
		if(label == null)	{
			// this is no longer a label, but a detail resource, so we use the detail offsets
			// only we aren't re-adjusting it every time it goes checked vs. unchecked.
			// TODO ...we could, though.
			int[] offsets;
			if (isCheck) {
				offsets = ((WebBrowserApp)getBApp()).getTheme().getFormDetailOffsets(WebBrowserTheme.FORM.CHECKBOX);
			} else {
				offsets = ((WebBrowserApp)getBApp()).getTheme().getFormDetailOffsets(WebBrowserTheme.FORM.RADIO);
			}
			label = new BView(this, offsets[0], offsets[1], this.getWidth()+offsets[2], this.getHeight()+offsets[3]);
		}
	} 


	public Object getForm() {
		return form;
	}

	public String getName() {
		return name;
	}
	
	@Override
	public boolean handleKeyPress(int code, long rawcode) {
		if(code == KEY_SELECT) {
			postEvent(new BEvent.Action(this, getAction()));
			return true;
		} else {
			return super.handleKeyPress(code, rawcode);
		}
	}
	
	private Object getAction() {
		return this.action;
	}
	
	public void setAction(Object action) {
		this.action = action;
	}

}
