package com.blackledge.david.html.hme;

import java.awt.Color;
import java.awt.Rectangle;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.CookieHandler;
import java.net.CookieManager;
import java.net.CookieStore;
import java.net.HttpCookie;
import java.net.HttpURLConnection;
import java.net.InetAddress;
import java.net.MalformedURLException;
import java.net.URISyntaxException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.net.UnknownHostException;
import java.text.DateFormat;
import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.jsoup.Connection;
import org.jsoup.UnsupportedMimeTypeException;
import org.jsoup.Connection.Method;
import org.jsoup.Connection.Response;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import com.blackledge.david.html.HTMLStyleChunk;
import com.blackledge.david.html.ThreadLocalCookieStore;
import com.blackledge.david.html.hme.host.HMEItem;
import com.blackledge.david.tivo.V49BApplication;
import com.blackledge.david.tivo.V49IHmeProtocol;
import com.blackledge.david.tivo.widgets.typo.TyPo;
import com.blackledge.david.tivo.widgets.typo.TyPoScreen;
import com.blackledge.david.tivo.widgets.typo.WordList;
import com.blackledge.david.tivo.widgets.typo.TyPo.Keyboard;

import com.tivo.core.ds.TeDict;
import com.tivo.core.ds.TeIterator;
import com.tivo.hme.bananas.BScreen;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.interfaces.IContext;
import com.tivo.hme.sdk.HmeEvent;
import com.tivo.hme.sdk.HmeEvent.DeviceInfo;
import com.tivo.hme.sdk.HmeEvent.FontInfo;
import com.tivo.hme.sdk.HmeEvent.Key;
import com.tivo.hme.sdk.HmeEvent.ResolutionInfo;
import com.tivo.hme.sdk.Resolution;
import com.tivo.hme.sdk.Resource;
import com.tivo.hme.sdk.View;

/**
 * <h1>"Enter Webz" - the first ever Web Browser for the TiVo DVR.</h1> <h2>
 * THUMB tacks page controls</h2>
 * <TABLE border=1>
 * <TR>
 * <TH>Thumbs Up</TH>
 * <TD>for "Last Visited" or "(temp)" entries, saves as a THUMB tack</TD>
 * </TR>
 * <TR>
 * <TH>Thumbs Down OR clear</TH>
 * <TD>Delete THUMB tack</TD>
 * </TR>
 * <TR>
 * <TH>enter OR info</TH>
 * <TD>Edit Title</TD>
 * </TR>
 * <TR>
 * <TH>Select OR right OR FF</TH>
 * <TD>Load Link or App</TD>
 * </TR>
 * <TR>
 * <TH>left or RW</TH>
 * <TD>Back. If this is the starting page, quits the app.</TD>
 * </TR>
 * <TR>
 * <TH>Pause</TH>
 * <TD>Quit App</TD>
 * </TR>
 * </TABLE>
 * <h2>Web page controls</h2>
 * <TABLE border=1>
 * <TR>
 * <TH>Thumbs Up</TH>
 * <TD>THUMB tack page (saves session cookies, too)</TD>
 * </TR>
 * <TR>
 * <TH>Thumbs Down</TH>
 * <TD>remove THUMB tack</TD>
 * </TR>
 * <TR>
 * <TH>Play</TH>
 * <TD>Open THUMBS tacks page</TD>
 * </TR>
 * <TR>
 * <TH>RW</TH>
 * <TD>Back. If this is the starting page, quits the app.</TD>
 * </TR>
 * <TR>
 * <TH>1-9</TH>
 * <TD>Change font size</TD>
 * </TR>
 * <TR>
 * <TH>0</TH>
 * <TD>reset to default font size</TD>
 * </TR>
 * <TR>
 * <TH>ASPECT</TH>
 * <TD>change "brightness"</TD>
 * </TR>
 * <TR>
 * <TH>ENTER</TH>
 * <TD>turn off/on table layout (looks better, but takes time & memory and some
 * things end up off screen)</TD>
 * </TR>
 * <TR>
 * <TH>left/right</TH>
 * <TD>select link or form field</TD>
 * </TR>
 * <TR>
 * <TH>up/down</TH>
 * <TD>select link or form field, scroll up/down at edge</TD>
 * </TR>
 * <TR>
 * <TH>channel up/down</TH>
 * <TD>scroll a page up/down</TD>
 * </TR>
 * <TR>
 * <TH>Pause</TH>
 * <TD>Quit App</TD>
 * </TR>
 * <TR>
 * <TH><a href="#">link</a>: Select OR FF</TH>
 * <TD>Load Link</TD>
 * </TR>
 * <TR>
 * <TH><input type="submit" value="submit button">/img button/<button>html
 * button</button>: Select</TH>
 * <TD>Submit form</TD>
 * </TR>
 * <TR>
 * <TH><select><option>select field</option><option>option 2</option></select>:
 * Select</TH>
 * <TD>Open selections list</TD>
 * </TR>
 * <TR>
 * <TH>(selections list): Select OR right</TH>
 * <TD>select entry</TD>
 * </TR>
 * <TR>
 * <TH>(selections list): up/down ; channel up/down ; ADV</TH>
 * <TD>navigate list (single, page, ends)</TD>
 * </TR>
 * <TR>
 * <TH>(selections list): anything else</TH>
 * <TD>cancel selection</TD>
 * </TR>
 * <TR>
 * <TH><input type="checkbox" checked>/<input type="radio" checked>(check/radio
 * field): Select</TH>
 * <TD>check/uncheck field</TD>
 * </TR>
 * <TR>
 * <TH><input type="text" size=4 value="text">/<textarea rows=2
 * cols=8>textarea</textarea>: Select</TH>
 * <TD>Open keyboard</TD>
 * </TR>
 * <TR>
 * <TH>(text field): 0-9</TH>
 * <TD>type a number</TD>
 * </TR>
 * <TR>
 * <TH>(text field): REC</TH>
 * <TD>type a period (".")</TD>
 * </TR>
 * <TR>
 * <TH>(text field): ADV</TH>
 * <TD>type a dash ("-")</TD>
 * </TR>
 * <TR>
 * <TH>(text field): REPLAY</TH>
 * <TD>type a comma (",")</TD>
 * </TR>
 * <TR>
 * <TH>(text field): FF</TH>
 * <TD>type a space</TD>
 * </TR>
 * <TR>
 * <TH>(text field): RW</TH>
 * <TD>delete last character</TD>
 * </TR>
 * <TR>
 * <TH>(text field): CLEAR</TH>
 * <TD>clear field</TD>
 * </TR>
 * </TABLE>
 * <h2>TiVo App (hme://) URLs</h2> Enter Webz supports custom urls of the form
 * <code>hme://hostname:port/path</code> to launch other TiVo Apps.<BR>
 * <var>hostname</var> can be an ip address or a registered domain name that
 * points to the IP address. It processes the URL like this:
 * <OL>
 * <LI>translate the <var>hostname</var> to an <var>ip-address</var>
 * <LI>try to get the TiVoConnect xml file at
 * <code>http://<var>ip-address</var>/TiVoConnect</code>
 * <LI>Check the TiVoConnect file for an hme App entry whose URL has a path that
 * starts with <var>path</var>, and transition to that App
 * <LI>If no app matches, or if there was no TiVoConnect file, attempt to
 * transition to the app at <code>http://<var>ip-address</var>:port/path</code>
 * </OL>
 * <h2>Media URLs</h2> Links that go directly to something other than a text or
 * web page are treated as media URLs. They are passed to the TiVo in hopes that
 * it can handle them. <h3>Pictures</h3> Supported formats are PNG, GIF
 * (including animated GIF), and JPEG.<BR>
 * Use RW or LEFT to return to the previous page. <h3>Music and Audio Files</h3>
 * Supported format is MP3.<BR>
 * Use RW or LEFT to return to the previous page and end the audio.<BR>
 * Use Pause and Play to stop and restart the audio. <h3>Video (TiVos Series 3
 * and later only)</h3> Supported formats are: MPEG, MPEG1, MPEG2, MPEG4 (h.264,
 * and 512KB or higher).<BR>
 * Use LEFT to return to the previous page and end the video.<BR>
 * Use Pause and Play to stop and restart the video.<BR>
 * Use RW and FF to adjust the Rewind and FastForward speed of the video.<BR>
 * If the video reaches the end of the in-progress download, you'll get a
 * "BUFFER END" message. Wait a moment for more to download, then press play
 * again.
 * 
 * @author David Blackledge
 * 
 */
public class WebBrowserApp extends V49BApplication {
	// gmail seems to keep doing about 1.2M for its cookie, but 20M slowed things to a crawl
	private static final int MAX_COOKIE_LENGTH = 2*1024*1024;

	static {
		// add support for the "hme:" protocol in URLs
		System.setProperty("java.protocol.handler.pkgs", //$NON-NLS-1$
				"com.blackledge.david.html"); //$NON-NLS-1$
		// turn on automatic cookie handling
		// have to use a custom CookieStore that loads/stores cookies per
		// TiVo simultaneous... for now one per Thread should do it, though that could end up with multiple per TiVo in theory
//		CookieHandler.setDefault(new CookieManager());
		CookieHandler.setDefault(new CookieManager(new ThreadLocalCookieStore(), null)); // COOKIES
	}
	
	private static CookieStore getCookieStore() {
		return ((CookieManager) CookieHandler.getDefault())
				.getCookieStore();
	}

	/**
	 * just expose the AppFactory where the default server expects to find it.
	 */
	public static class WebBrowserAppFactory extends com.blackledge.david.html.hme.WebBrowserAppFactory {
	}

	/**
	 * params TeDict key used in transitionBack call when browser closes. Value
	 * is the String URL of the page displayed at that time.
	 */
	public static final String WEBPAGE_URL = "WEBPAGE_URL"; //$NON-NLS-1$
	/**
	 * params TeDict key used in transitionBack call when browser closes. Value
	 * is the String URL of the icon for the page displayed at that time.
	 */
	public static final String WEBPAGE_TITLE = "WEBPAGE_TITLE"; //$NON-NLS-1$
	public static final String WEBPAGE_ICON = "WEBPAGE_ICON"; //$NON-NLS-1$
	// attributes: {
	// Cookie=id=5d7aa013befaf038e20e7b6873aca31cce0de228,
	// Host=192.168.0.20:7288,
	// User-Agent=TvHttpClient,
	// Connection=close,
	// tsn=65...C5
	// }
	// LOG: event 1.DEVICE_INFO(com.tivo.core.ds.MapThreadWrapper@184554050{
	// com.tivo.examine.idType.stationId=tivo,
	// platform=Gen06,
	// host=Bedroom,
	// brand=TiVo,
	// com.tivo.examine.showing=true,
	// com.tivo.examine.idType.contentId=tivo,
	// version=11.0k-01-2-652
	// })
	// LOG: event
	// 1.RESOLUTION_INFO(640x480-PAR=1/1,avail=[704x480-PAR=40/33,640x480-PAR=1/1,1280x720-PAR=1/1])
	// FIXME new bananas: set maxStackSize for auto-remove of old non-first
	// screens, calls "remove()" (vs. handleExit) (sets numScreensRemoved)
	static final String BROWSER_NAME = Messages.getString("WebBrowserApp.BROWSER_NAME"); //$NON-NLS-1$
	static final String BROWSER_VERSION = Messages.getString("WebBrowserApp.BROWSER_VERSION"); //$NON-NLS-1$
	static final String NOTICE = MessageFormat.format(Messages.getString("WebBrowserApp.NOTICE"),BROWSER_NAME) ; //$NON-NLS-1$

	/** the title presented to the TiVo */
	public static final String TITLE = BROWSER_NAME;
	/** the URI path used by the TiVo to access this application */
	public static final String URI = "webz"; //$NON-NLS-1$

	private static final String BOOKMARK_ENTRY_SEP = "\n"; //$NON-NLS-1$
	private static final String BOOKMARK_URL_TITLE_SEP = "\t"; //$NON-NLS-1$
	private static final String BOOKMARKS_KEY = "BOOKMARKS"; //$NON-NLS-1$
	private static final String LAST_URL_KEY = "LAST_URL"; //$NON-NLS-1$
	private static final String LAST_TITLE_KEY = "LAST_TITLE"; //$NON-NLS-1$

	private static final String METHOD_POST = "POST"; //$NON-NLS-1$
	private static final String METHOD_GET = "GET"; //$NON-NLS-1$

	/** Jsoup default is 3 seconds. not long enough for our purposes */
	private static final int CONNECTION_TIMEOUT = 15 * 1000;

	private static final String HTTP_HEADER_USER_AGENT = "User-Agent"; //$NON-NLS-1$
	private static final String HTTP_HEADER_COOKIE = "Cookie"; //$NON-NLS-1$
	private static final String HTTP_HEADER_SET_COOKIE = "Set-Cookie"; //$NON-NLS-1$
	/**
	 * If the field value is a relative URI, it SHOULD be interpreted relative
	 * to the Request-URI. The URI MUST NOT include a fragment.
	 */
	private static final String HTTP_HEADER_REFERER = "Referer"; //$NON-NLS-1$
	/**
	 * For 201 (Created) responses, the Location is that of the new resource
	 * which was created by the request. For 3xx responses, the location SHOULD
	 * indicate the server's preferred URI for automatic redirection to the
	 * resource. The field value consists of a single absolute URI.
	 */
	private static final String HTTP_HEADER_LOCATION = "Location"; //$NON-NLS-1$
	/** sent with 401 (Unauthorized) to define what is needed */
	private static final String HTTP_HEADER_WWW_AUTHENTICATE = "WWW-Authenticate"; //$NON-NLS-1$
	/** usually in response to a 401 */
	private static final String HTTP_HEADER_AUTHORIZATION = "Authorization"; //$NON-NLS-1$
	private static final byte[] MEMENTO_BOOKMARKS = "BOOKMARKS".getBytes(); //$NON-NLS-1$
	private static final byte[] MEMENTO_QUIT_ON_RETURN = "QUIT_ON_RETURN".getBytes(); //$NON-NLS-1$

	/** URL string arg when browser is launched */
	String startURL;
	/** whether bookmarks are allowed */
	private boolean disableBookmarks = false;
	/** current scale to use when rendering fonts */
	private float fontScale = 1.0f;
	/**
	 * Whether to apply Table Layout code (otherwise, table cells are treated as
	 * individual lines)
	 */
	private boolean layoutTables = true;

	private WebBrowserTheme theme;

	private BView pleaseWait;
	private TyPoScreen typoScreen;
	// private TyPo typo;

	private static DateFormat logdateformat = new SimpleDateFormat(
//			"yyyy-MM-dd'T'HH:mm:ss.SSS"
			"yyyy-MM-dd@HH:mm:ss"
			);
	public static void log(String ID, String where, String what, String[] details) {
		char sep = '\t';
		String time = logdateformat.format(new Date());
		StringBuffer output = new StringBuffer();
		output.append(ID);
		output.append(sep);
		output.append(time);
		output.append(sep);
		output.append(where);
		output.append(sep);
		output.append(what);
		if(details != null) {
			output.append('(');
			for(String detail : details) {
				output.append(sep);
				output.append(detail);
			}
			output.append(sep);
			output.append(')');
		}
		
		System.out.println(output);
	}
	
	public void log(String what, String[] details) {
		log(this.tivoID, this.getFactory().getAppName(), what, details);
	}
	
	private Date appStart = null;
	public void logAppStart(String what) {
		appStart = new Date();
		String stats = null;
		if(deviceInfo != null) stats = deviceInfo.toString();
		
		log("start:"+what, new String[] {stats} );
	}
	
	private String getAppEndDuration() {
		Date appEnd = new Date();
		long appTime = 0;
		if (appStart == null) {
			return "?";
		}
		appTime = appEnd.getTime() - appStart.getTime();
		String mins = String.valueOf(appTime / 1000.0 / 60.0);
		int dot = mins.indexOf('.');
		int dec = 3; // decimal + places
		if ((dot > -1) && ((dot + dec) < mins.length())) {
			mins = mins.substring(0, dot + dec);
		}
		String time = mins + " mins";
		return time;
	}
	
	public void logAppEnd(String what) {
		String time = getAppEndDuration();
		
		log("end:"+what, new String[] {time} );
	}

	public void logAppCrash(String error, String page, String state) {
		String time = getAppEndDuration();
		String options = "";
		log("end:CRASH", new String[] {time, error, page, state, options} );
	}
	
	public void logAppError(int code, String error, Integer resourceId) {
		log("appError", new String[] {String.valueOf(code), error, String.valueOf(resourceId)} );
	}
	
	public void logBookmark(String what, String url, String icon, String folder, String title) {
		folder = WebBrowserApp.folderToReadablePath(folder);
		log(what, new String[] {url, icon, folder, title});
	}
	
	@Override
	public boolean handleApplicationError(int errorCode, String errorText,
			Integer resourceId) {
		logAppError(errorCode, errorText, resourceId);
		return super.handleApplicationError(errorCode, errorText, resourceId);
	}
	
	public static void debugOut(Object output) {
		if(getDebugLevel() > 0)
			System.out.println(output);
	}
	
	@Override
	public void debug(String message) {
		WebBrowserApp.debugOut(message);
	}
	
	private static Integer debuglevel;
	public static int getDebugLevel() {
		if(debuglevel == null) {
			debuglevel = Integer.getInteger("com.tivo.hme.sdk.debug.level", 0);
		}
		return debuglevel;
	}
	
	private WebBrowserOptions options = new WebBrowserOptions(this);

	/**
	 * whether or not we want to try and lay out tables
	 * 
	 * @return
	 */
	boolean isLayingOutTables() {
		return layoutTables;
	}

	/**
	 * triggers {@link #saveOptions()}
	 */
	void setLayingOutTables(boolean b) {
		this.layoutTables = b;
	}

	/**
	 * triggers {@link #saveOptions()}
	 */
	void setAppearingMobile(boolean b) {
		options.setAppearingMobile(b);
	}
	
	boolean isAppearingMobile() {
		return options.isAppearingMobile();
	}

	/**
	 * triggers {@link #saveOptions()}
	 */
	void setMaximized(boolean b) {
		options.setMaximized(b);
		// adjust the shared displays
		if (options.isMaximized()) {
			if (this.pleaseWait != null && this.pleaseWait.getChildCount() == 1) {
				View child = this.pleaseWait.getChild(0);
				child.setLocation(child.getX(), 0);
			}
		} else {
			if (this.pleaseWait != null && this.pleaseWait.getChildCount() == 1) {
				View child = this.pleaseWait.getChild(0);
				child.setLocation(child.getX(), getSafeTitleVertical());
			}
		}
	}
	
	boolean isMaximized() {
		return options.isMaximized();
	}

	public Response followRedirects(Response resp, String referer) throws IOException {
		return followRedirects(resp, 1, referer);
	}

	public Response followRedirects(Response resp, int count, String referer)
			throws IOException {
		int status = resp.statusCode();
		boolean needsRedirect = false;
		if (status != HttpURLConnection.HTTP_OK) {
			if (status == HttpURLConnection.HTTP_MOVED_TEMP
					|| status == HttpURLConnection.HTTP_MOVED_PERM
					|| status == HttpURLConnection.HTTP_SEE_OTHER)
				needsRedirect = true;
		}
		if (!needsRedirect)
			return resp;
		if (count > 15) {
			throw new IOException(MessageFormat.format(
					Messages.getString("WebBrowserApp.too_many_redirects_exception"), //$NON-NLS-1$
					resp.url(), resp.header(HTTP_HEADER_LOCATION)));
		}
		// debugOut(String.format("REDIRECT %d URL %s -> %s", count, resp.url(),
		// resp.header(HTTP_HEADER_LOCATION)));
		debugOut("REDIRECT " + count + " URL " + resp.url() + "-->" //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				+ resp.header(HTTP_HEADER_LOCATION));
		String location = resp.header(HTTP_HEADER_LOCATION);
		if(location == null) return resp;
		URL redirectUrl = getURL(resp.url(), location);
		Connection con = Jsoupconnect(redirectUrl.toString())
				// always redirect with a get. any data param from original req are
				// dropped.
				.followRedirects(false).method(Method.GET) 
				;
		if(referer != null) {
			// not in spec, but general consensus is to maintain referer on redirects
			con.referrer(referer);
		}
		Response res = con.execute();
			

		return followRedirects(res, count + 1, referer);
	}

	private String getUserAgent() {
		String tivo = "TiVo"; //$NON-NLS-1$
		if (tivoVersion != null) {
			tivo += "/" + tivoVersion; //$NON-NLS-1$
		}
		//googlebot always includes something like this, so we will, too.
		String url = "+http://EnterWebz.tv/"; //$NON-NLS-1$
		String browser = BROWSER_NAME + "/" + BROWSER_VERSION; //$NON-NLS-1$
		String SEP = "; "; //$NON-NLS-1$
		String enterwebz = browser + SEP + tivo + SEP + url;
		
		// TiVo prefers 8 bit images, and has its own resolution
		int bits = 8;
		int width = 640;
		int height = 480;
		if(isResolutionSupported()) {
			width = getCurrentResolution().getWidth();
			height = getCurrentResolution().getHeight();
		}
		// often "U" (high security), I for weak, and N for none.
		// Since we downgrade some security, we'll call it "I" - but I don't know that's right.
		String security = "I";  //$NON-NLS-1$
		
		// drive language from the TiVo's settings!
		String language = getDeviceLanguage(); //"en-us"; //"en_us"; "en"; //$NON-NLS-1$
		// try to change format ("enUS") to be similar to useragent style
		if(language.length() > 2) {
			language = language.substring(0, 2) + "-" + language.substring(2); //$NON-NLS-1$
		}
		language = language.toLowerCase();
		
		String userAgent = "Mozilla/5.0 (compatible; " + enterwebz + ")"; //$NON-NLS-1$ //$NON-NLS-2$
		if (options.isAppearingMobile()) {
			MOBILE type = options.getMobileType();
			// samsung/docomo/ipad user agents adapted from googlebot's user-agent strings for mobile sites.
			// https://developers.google.com/webmasters/smartphone-sites/googlebot-mobile
			switch(type) {
			// our versions of what Google does:
			case SAMSUNG:
				userAgent = "SAMSUNG-SGH-E250/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0 (compatible" + SEP + language + SEP //$NON-NLS-1$
						+ enterwebz + ")"; //$NON-NLS-1$
				break;
			case DOCOMO:
				userAgent = "DoCoMo/2.0 N905i(c100;TB;W24H16) (compatible" + SEP + language + SEP //$NON-NLS-1$
						+ enterwebz + ")"; //$NON-NLS-1$
				break;
			case IPAD:
//				Mozilla/5.0 (iPhone; CPU iPhone OS 5_1_1 like Mac OS X) AppleWebKit/ 534.46 (KHTML, like Gecko) Version/5.1 Mobile/9B206 Safari/7534.48.3
//				Mozilla/5.0 (iPad; CPU OS 5_1_1 like Mac OS X) AppleWebKit/534.46 (KHTML, like Gecko) Version/5.1 Mobile/9B206 Safari/7534.48.3
//				AppleCoreMedia/1.0.0.9B176 (iPhone; U; CPU OS 5_1 like Mac OS X; en_us)
//				AppleCoreMedia/1.0.0.9B176 (iPad; U; CPU OS 5_1 like Mac OS X; en_us)
				userAgent = "Mozilla/5.0 (iPad; CPU OS 6_0 like Mac OS X) AppleWebKit/536.26 (KHTML, like Gecko) Version/6.0 Mobile/10A5376e Safari/8536.25 (compatible" + SEP + language + SEP //$NON-NLS-1$
						+ enterwebz + ")"; //$NON-NLS-1$
				break;
			// more options
			case ANDROID:
				userAgent = "Mozilla/5.0 (Linux; " + security + "; Android 2.1; " + language + "; Nexus One Build/ERD62) AppleWebKit/530.17 (KHTML, like Gecko) Version/4.0 Mobile Safari/530.17 (compatible; " //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
						+ enterwebz + ")"; //$NON-NLS-1$
				break;
			case BB:
				userAgent = "BlackBerry7100i/4.1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 VendorID/103 (compatible" + SEP + language + SEP //$NON-NLS-1$
						+ enterwebz + ")"; //$NON-NLS-1$
				break;
			case OPERA:
				userAgent = "Opera/9.50 (J2ME/MIDP; Opera Mini/4.0.10031/298; " + security + SEP + language + " ; compatible" + SEP //$NON-NLS-1$ //$NON-NLS-2$
						+ enterwebz + ")"; //$NON-NLS-1$
				break;
			case PALM:
				// based on Palm Centro phone
				// it had 16;320x320 at the end
				userAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows 98; PalmSource/Palm-D062; Blazer/4.5) " + bits + ";" + width + "x" + height + SEP + "(compatible" + SEP + language + SEP //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
						+ enterwebz + ")"; //$NON-NLS-1$
				break;
			case AVANTGO:
			default:
				// my original mobile user agent, works in many sites, stopped working correctly at Google, though.
				userAgent = "Mozilla/5.0 (compatible; AvantGo 3.2; compatible" + SEP + language + SEP //$NON-NLS-1$
						+ enterwebz + ") Mobile"; //$NON-NLS-1$
			}
		}
		return userAgent;
	}


	@Override
	protected void initBeforeResolutionSet(IContext context) {

		options.loadOptions();
		restoreSavedFontScale();

		theme = new WebBrowserTheme(this, this.themeURL);

		flush();
		// showFirstPage();

		if (isSDK141()) {
			// TODO probably too low, but might help the memory issues.
			setMaxStackDepth(10);
		}

		// WordList currently requires you call load before you can call
		// addWord.
		WordList wordList = WordList.getInstance();
		wordList.addWord("com/"); //$NON-NLS-1$
		wordList.addWord("org/"); //$NON-NLS-1$
		wordList.addWord("net/"); //$NON-NLS-1$
		wordList.addWord("google.com/"); //$NON-NLS-1$
		wordList.addWord("yahoo.com/"); //$NON-NLS-1$
		wordList.addWord("aol.com"); //$NON-NLS-1$
		wordList.addWord("gmail.com"); //$NON-NLS-1$
		wordList.addWord("html"); //$NON-NLS-1$
		wordList.addWord("http://"); //$NON-NLS-1$
		wordList.addWord("https://"); //$NON-NLS-1$
		wordList.addWord("www."); //$NON-NLS-1$
		// add bookmarks hosts, too.
		java.util.LinkedHashMap<String, URL[]> bookmarks = getBookmarks();
		if (bookmarks != null)
			for (URL[] url : bookmarks.values()) {
				wordList.addWord(url[0].getHost());
			}

		//COOKIES
		// that getBookmarks call also loaded cookies from the bookmarks...let's double-check
		CookieStore cookies = getCookieStore();
		for(java.net.URI uri : cookies.getURIs()) {
		List<HttpCookie> cookieSet = cookies.get(uri);
		debugOut("***cookieURI***"+uri);

		for (int i = 0; i < cookieSet.size(); ++i) {
			HttpCookie cookie = cookieSet.get(i);
			// the toString() includes domain, etc only if version is 1... and we keep convincing the system they're version 0 somehow.
			cookie.setVersion(1); // FIXME this is CHANGING the cookie for debug purposes!
			debugOut("***cookie***"+cookie);
		}
		}
		
	}
	
	@Override
	protected void destroyCleanup() {
		if(!this.cleanExit) {
			String page = null;
			if (getCurrentScreen() != null) {
				if (getCurrentScreen() instanceof WebScreen) {
					page = ((WebScreen)getCurrentScreen()).getURL().toString();
				} else if (getCurrentScreen() instanceof BookmarkScreen) {
					page = "bookmarks:"+((BookmarkScreen)getCurrentScreen()).folder;
				} else {
					if(getCurrentScreen().getClass() != null) {
						page = getCurrentScreen().getClass().toString();
					}
				}
			}
			//FIXME finish this
			String state = null;
			logAppCrash("dirtyExit", page, state);
		}
		
		// make sure all bookmarks have their latest cookies
		debugOut("**** refreshing all bookmarks");
		refreshBookmarks();

		debugOut("**** removing all cookies");
		getCookieStore().removeAll(); //COOKIES
	}

	protected void showFirstPage() {
		debugOut("firstPage - startURL: " + startURL); //$NON-NLS-1$

		logAppStart(startURL==null?null:startURL.replaceAll(Pattern.quote(BOOKMARK_FOLDER_SEPARATOR), "/"));
		
		Rectangle rootBounds = getRoot().getBounds();
		if (rootBounds.getHeight() > 480) {
			if (getTheme().getHDSkin() != null) {
				setSkin(getTheme().getHDSkin());
			}
		} else {
			if (getTheme().getSDSkin() != null) {
				setSkin(getTheme().getSDSkin());
			}
		}
		
		boolean showBookmarks = false;
		String folder = null;
		if (startURL != null) {
			showPleaseWait();
			try {
				URL url = new URL(startURL);
				if (url.getProtocol().toLowerCase().startsWith("hme")) { //$NON-NLS-1$
					debugOut("LOAD APP on init " + url); //$NON-NLS-1$
					this.loadApp(url);
				} else if (url.getProtocol().toLowerCase().startsWith("file")) { //$NON-NLS-1$
					debugOut("LOAD FOLDER on init " + url); //$NON-NLS-1$
					// allow local launch of URL arg using "/" notation,
					// although TiVoConnect will pass "\r" notation here.
					showBookmarks = true;
					folder = WebBrowserApp.readablePathToFolder(url.toString());
				} else {
					debugOut("LOAD url on init " + url); //$NON-NLS-1$
					WebScreen webScreen = WebScreen.newWebScreen(this);
					boolean pageSuccess = webScreen.prepare(url);
					if (!pageSuccess) {
						hidePleaseWait();
						webScreen.remove();
						showBookmarks = true;
					} else {
						push(webScreen, TRANSITION_FORWARD, url);
					}
				}
			} catch (MalformedURLException ex) {
				showBookmarks = true;
			}
		} else {
			showBookmarks = true;
		}
		
		// Start media AFTER we begin - startup URL may be an App passthrough or
		// other media content.
		if (!this.isStreamActive()) {
			playStartupStreamPIP(this.startMedia);
		}

		if(showBookmarks) {
			if(folder != null) {
				this.showBookmarks(true, folder);
			} else {
				showBookmarks(true);
			}
		}

	}

	public void setStartupStreamCustom(String url) {
		options.setShowMedia(url);
	}
	public void clearStartupStream() {
		setStartupStreamCustom(null);
	}
	public void setStartupStreamLiveTV() {
		setStartupStreamCustom(STREAM_LIVETV);
	}
	public String getStartupStreamCustomURL() {
		if(isStartupStreamLiveTV()) {
			return null;
		} else {
			return options.getMediaURL();
		}
	}
	public boolean isStartupStreamLiveTV() {
		return options.isShowingLiveTV();
//		return options.getMediaURL() != null && options.getMediaURL().equals(STREAM_LIVETV);
	}
	

	/** Is there any active stream type? */
	public boolean isStreamActive() {
		return isStreamTypeVideo() || isStreamTypeAudio();
	}
	/** always returns true if stream is audio */
	public boolean isStreamDisplayPIP() {
		return isStreamTypeAudio()
				|| (isStreamTypeVideo() && this.videoHandler.isPip());
	}
	/** always returns false if stream is audio */
	public boolean isStreamDisplayFS() {
		return isStreamTypeVideo() && !this.videoHandler.isPip();
	}
//	public boolean isStreamDisplayBackgrounded() {
//		//FIXME implement
////		isStreamActive() && 
//		return false;
//	}
	/** returns false if there is no active stream */
	public boolean isStreamTypeVideo() {
		return (this.videoHandler != null && this.videoHandler.isPlaying());
	}
	/** returns false if there is no active stream */
	public boolean isStreamTypeAudio() {
		return (this.audioHandler != null && this.audioHandler.isPlaying());
	}
	private String lastMediaURL;
	/** returns null if stream source is live tv */
	public String getStreamSourceCustomURL() {
		if(!isStreamSourceLiveTV()) {
			if (isStreamActive()) {
				return this.lastMediaURL;
			}
			return null;
		} else {
			return null;
		}
	}
	/** returns false if there is no active stream */
	public boolean isStreamSourceLiveTV() {
		return isStreamTypeVideo() && this.videoHandler.isShowingLiveTV();
	}

	/** may be called only when there is a POSSIBLE change, and might not get called for ALL changes */
	private void notifyWebScreenStreamChanged() {
		BScreen screen = getCurrentScreen();
		if(screen != null && screen instanceof WebScreen) {
			((WebScreen)screen).notifyStreamChanged();
		}
	}
	
	public boolean playStartupStreamPIP(String startupOverrideURL) {
		if (startupOverrideURL != null) {
			if (startupOverrideURL.equals(STREAM_LIVETV)) {
				return playStreamLiveTV(true);
			} else {
				return playStream(startupOverrideURL, null, true);
			}
		} else {
			if (isStartupStreamLiveTV()) {
				return playStreamLiveTV(true);
			} else if(getStartupStreamCustomURL() != null) {
				return playStream(getStartupStreamCustomURL(), null, true);
			}
		}
		return false;
	}
	public boolean playStreamVideo(URL url, String contentType, boolean PIP) {
		return playStreamVideo(url, contentType, PIP, null, null, null, -1);
	}
	public boolean playStreamAudio(URL url, URL referer, String contentType) {
		if (url != null) {
			this.lastMediaURL = url.toString();
		} else {
			this.lastMediaURL = null;
		}
		if (this.videoHandler != null) {
			this.videoHandler.close();
		}
		if (this.audioHandler == null) {
			Rectangle titleRegion = getWebTitleArea();
			int width = (int) (titleRegion.getWidth() / 3);
			width = Math.max(width, 250);
		//			this.audioHandler = new AudioHandlerView(this,
		//					(int) (titleRegion.getX() + titleRegion.getWidth() - width),
		//					(int) (titleRegion.getY() + titleRegion.getHeight()), // below title
		//					width,
		//					(int) titleRegion.getHeight(), true);
			this.audioHandler = new AudioHandlerView(this,
					(int) (titleRegion.getX() + titleRegion.getWidth() - width),
					(int) (titleRegion.getY()),
					width - 20, // space for thumztak
					(int) titleRegion.getHeight(), true);
		}
		this.audioHandler.startAudio(url, referer, contentType);

		notifyWebScreenStreamChanged();
		return true;
	}
	public boolean playStreamLiveTV(boolean PIP) {
		this.lastMediaURL = null;
		if(this.audioHandler != null) {
			this.audioHandler.close();
		}
		if(getCurrentScreen() != null) {
			if(getCurrentScreen() instanceof VideoBackgroundScreen) {
				((VideoBackgroundScreen)getCurrentScreen()).disposeBackground();
			}
		}
		if (this.videoHandler == null) {
			this.videoHandler = new VideoHandlerView(this, PIP, true);
		}
		this.videoHandler.setPip(PIP);
		if (!this.videoHandler.isShowingLiveTV()) {
			this.videoHandler.startLiveTV();
		}
		this.videoHandler.show();
		if(getCurrentScreen() != null) {
			if(getCurrentScreen() instanceof VideoBackgroundScreen) {
				((VideoBackgroundScreen)getCurrentScreen()).showBackground();
			}
		}
		notifyWebScreenStreamChanged();
		return true;
	}
	public boolean playStream(String mediaURL, URL referer, boolean PIP) {
		this.lastMediaURL = null; // will get set if a good start happens
		URL urlBase;
		try {
			urlBase = new URL(mediaURL);
		} catch (MalformedURLException e2) {
			return false;
		}
		if(YouTubeLauncher.isYouTubeVideo(urlBase)) {
			if(!YouTubeLauncher.launchVideo(urlBase, this, PIP)) {
				return false;
			} else {
				notifyWebScreenStreamChanged();
				return true;
			}
		}
		try {
			// just running this to GET the mimetype exc...if we don't get it,
			// it's not the kind of url we need.
			Response soupResp = getResponse(urlBase, referer);
		} catch (UnsupportedMimeTypeException mimeEx) {
			URL url;
			String m = mimeEx.getUrl();
			url = getURL(urlBase, m);
			if(url == null) {
				// this shouldn't happen, the url string came from a
				// full URL, but let's keep our best option in this
				// case.
				url = urlBase;
			}
			String contentType = mimeEx.getMimeType();
			if (contentType != null) {
				// strip off extra info
				int semicolon = contentType.indexOf(";");
				if (semicolon > 0) {
					contentType = contentType.substring(0, semicolon);
				}
				
				if(contentType.toLowerCase().startsWith("video/")) {
					if(!playStreamVideo(url, contentType, PIP)) {
						return false;
					} else {
						notifyWebScreenStreamChanged();
						return true;
					}
				} else if(contentType.toLowerCase().startsWith("audio/")) {
					if(!playStreamAudio(url, referer, contentType)) {
						return false;
					} else {
						notifyWebScreenStreamChanged();
						return true;
					}
				}
			}
		} catch (IOException e1) {
			return false;
		}
		return false;
	}
	public void closeStream() {
		this.lastMediaURL = null;
		if (this.videoHandler != null) {
			if(getCurrentScreen() != null) {
				if(getCurrentScreen() instanceof VideoBackgroundScreen) {
					((VideoBackgroundScreen)getCurrentScreen()).disposeBackground();
				}
			}
			this.videoHandler.close();
			if(getCurrentScreen() != null) {
				if(getCurrentScreen() instanceof VideoBackgroundScreen) {
					((VideoBackgroundScreen)getCurrentScreen()).showBackground();
				}
			}
		}
		notifyWebScreenStreamChanged();
	}
	public void backgroundStream() {
		if(this.videoHandler != null && this.videoHandler.isPlaying()) {
			this.videoHandler.hide();
		}
	}
	public void foregroundStream() {
		if(this.videoHandler != null && this.videoHandler.isPlaying()) {
			this.videoHandler.show();
		}
	}

	/**
	 * Check this variable during handleExit to find out of the exit is
	 * happening due to a "pop" (leaving this Screen permanently) instead of due
	 * to a "push" (going to a new Screen, will return to this one eventually).
	 */
	public boolean isPopping = false;

	@Override
	public void pop(Object arg) {
		isPopping = true;
		BScreen popped = getCurrentScreen();
		super.pop(arg);
		if (popped != this.typoScreen) {
			// do what removeOldScreens does
			popped.setVisible(false);
			popped.remove();
		}
		isPopping = false;
	}

	/* BEGIN END NEXT LINE HME 1.4.1e only */
	// @Override
	public void replaceCurrentScreen(BScreen newScreen, int transition,
			Object arg) {
		BScreen popped = getCurrentScreen();
		// super.replaceCurrentScreen(newScreen, transition, arg);
		super.pop();
		super.push(newScreen, transition, arg);

		// FIXME removed this for now... causing problems...why???
		// // do what removeOldScreens does
		// popped.setVisible(false);
		// popped.remove();
	}

	@Override
	protected void dispatchKeyEvent(Key ir) {
		// Allow override destination
		// But not to include CALLBACK keys
		if (ir.getCode() == WebScreen.REFRESH_CALLBACK_KEY_CODE
				|| ir.getCode() == WebScreen.SCREEN_TRANSITION_CALLBACK_KEY_CODE) {
			super.dispatchKeyEvent(ir);
		} else {
			if (this.videoHandler != null
					&& this.videoHandler.keyDispatchOverride(ir)) {
				// dispatched, that is an override, so don't do super impl
			} else if (this.audioHandler != null
					&& this.audioHandler.keyDispatchOverride(ir)) {
				// dispatched, that is an override, so don't do super impl
			} else {
				super.dispatchKeyEvent(ir);
			}
		}
	}

	@Override
	public boolean handleKeyPress(int code, long rawcode) {
		if (!super.handleKeyPress(code, rawcode)) {
			switch (code) {
			case KEY_CLEAR:
				logAppEnd("clear");
				closeBrowser();
				return true;
			case KEY_PLAY:
				if (!isBookmarksDisabled()
						&& getCurrentScreen() instanceof WebScreen) {
					showBookmarks();
					return true;
				}
				break;
			case KEY_PAUSE:
				if(isStreamDisplayPIP()) {
					pausePIP();
					return true;
//				} else if(isPlayingAudio()) { // handled in audioHandler.dispatchOverride
//					pauseAudio();
//					return true;
				}
				//TODO not sure we want to do this still
				logAppEnd("pause");
				closeBrowser(); return true;
//				return false;
			case KEY_SLOW:
				if(isStreamDisplayPIP()) {
					closeStream();
					return true;
//				} else if (isPlayingAudio()) { // handled in audioHandler.dispatchOverride
//					closeAudio();
//					return true;
				} else {
					playStreamLiveTV(true);
					return true;
				}
			case KEY_OPT_PIP: //Zoom/Aspect/Window/PIP
				if(isStreamDisplayPIP()) {
					zoomPIP();
					return true;
				}
				return false;
			}
			return false;
		}
		return true;
	}

	private boolean cleanExit = false;
	public void closeBrowser() {
		this.cleanExit = true;
		play(SOUND_SLOWDOWN1);
		
		// return something useful about the current browser state
		// mainly for use with Google Auth stuff, but also useful for restarting
		// where we left off.
		transitionBack(getReturnParams());
		// setActive(false);
	}

	private TeDict getReturnParams() {
		TeDict result = new TeDict();
		// use page they were on, not last visited unless we're not "on" a page.
		if (!(getCurrentScreen() instanceof WebScreen)) {
			URL url = getLastVisited();
			if (url != null) {
				result.add(WEBPAGE_URL, url.toString());
			} else {
				// ok, not even a lastvisited? nothing is worth returning then.
				return null;
			}
			String title = getLastVisitedTitle();
			if (title != null) {
				result.add(WEBPAGE_TITLE, title);
			}
		} else {
			WebScreen screen = (WebScreen) getCurrentScreen();
			if (screen == null)
				return null;
			URL url = screen.getURL();
			if (url != null) {
				result.add(WEBPAGE_URL, url.toString());
			}
			String title = screen.getTitle();
			if (title != null) {
				result.add(WEBPAGE_TITLE, title);
			}
			URL icon = screen.getIconURL();
			if (icon != null) {
				result.add(WEBPAGE_ICON, icon.toString());
			}
		}
		debugOut("RETURNING: " + result); //$NON-NLS-1$
		return result;
	}

	@Override
	public boolean handleKeyRelease(int code, long rawcode) {
		// Handle App Startup key, if so desired
		if (getCurrentScreen() == null) {
			switch (code) {
			case KEY_PLAY:
				debugOut("started with PLAY"); //$NON-NLS-1$
				break;
			case KEY_SELECT:
				debugOut("started with SELECT"); //$NON-NLS-1$
				break;
			case KEY_RIGHT:
				debugOut("started with RIGHT"); //$NON-NLS-1$
				break;
			}
		}
		return super.handleKeyRelease(code, rawcode);
	}

	public String getHmeURL(URL link) {
	
		// FIXME check out possible alternative "URL" for the apps:
		// at 204.176.49.116
		// Amazon: x-tivo:hme:uuid:35FE011C-3850-2228-FBC5-1B9EDBBE5863
		// Blockbuster: x-tivo:hme:uuid:63ED0C3D-D49C-9602-C322-E0A3D3EA5A3D
		// Browse Web Videos:
		// x-tivo:hme:uuid:19452283-D00B-C411-595D-447ABF62F37C
		// Browse Web Videos:
		// x-tivo:hme:uuid:6784571A-016C-8A46-DF2F-FD842D78006F
		// Fandango: x-tivo:hme:uuid:B9DDBECF-BC6D-5E33-388A-4CF840068D79
		// Music Choice: x-tivo:hme:uuid:7FDF1BEB-AF92-B8B6-6269-FAE44C8F887D
		// Netflix: x-tivo:hme:uuid:7edeb291-0db8-487f-b842-6b97bc71ad9a
		// One True Media: x-tivo:hme:uuid:D1AF7BED-325E-5E6E-B087-72381C92D077
		// Swivel: x-tivo:hme:uuid:2BD40EF7-D9D2-3CD4-0130-6C18855CE898
		// TiVoCast RSS: x-tivo:hme:uuid:863cb78f-efdd-4106-b572-51733983dc76
		// Youtube: x-tivo:hme:uuid:9AA364C9-CF8A-1E1D-B50F-CC65C40D4A96

		// It connects to port 80 and requests a file called TiVoConnect
		// http://209.97.196.52/TiVoConnect
		// which needs to return an xml file (described in the HMO docs I
		// believe)
		// apps.tv creates this on the fly based on the TiVo's ID which is sent
		// in the headers.

		// "lb._dns-sd._udp.0.0.168.192.in-addr.arpa."
		// 204.176.49.116, reverse it for this purpose
		// service+"116.49.176.204"+".in-addr.arpa."
		if (link == null)
			return null;

		String loc = null;
		try {
			// 204.176.49.116 main one
			// 204.176.49.123: web page titled
			// "TiVo Premiere: much more than a DVR - TiVo"
			// 208.73.181.192 - no luck... apparently jmdns heartbeat thing
			// "have just noticed a "heartbeat" connection to 208.73.181.192 on port 5223"
			// mdns > 224.0.0.251 // nothing
			// http > 204.176.49.2 // nothing
			// 206.112.115.224,225 (0 entries)
			// 216.235.91.x (Live365) nothing (also with :20000)
			/*
			 * I was able to figure out some ports by examing my firewall log
			 * for dropped messages. I added TCP ports 7287, 7288, and 8000 (to
			 * IPs 204.176.49.x) which got the menu items and their icons to
			 * appear. For Live365 to work, I added ports 20000 through 22000
			 * (to IPs 216.235.91.x).
			 */
			// convert host to IP since that's the way TiVo requests TiVoConnect
			// (and it matters in some cases, like apps.tv)
			String ip;
			try {
				ip = InetAddress.getByName(link.getHost()).getHostAddress();
			} catch (UnknownHostException uhe) {
				// not that it will do any good, but continue with just the host
				// name.
				ip = link.getHost();
			}
			Connection connection = Jsoupconnect("http://" + ip //$NON-NLS-1$
					+ "/TiVoConnect?Command=QueryContainer&Container=%2F&DoGenres=1"); //$NON-NLS-1$
			// from a premiere:
//			/TiVoConnect?Command=QueryContainer&Container=%2F&DoGenres=1
//			/192.168.0.11
//			User-Agent: TmkHttpRequest/1.0
//			Host: 192.168.0.20
//			TiVo_TCD_ID: 746000190AA690F
//			TiVo_SW_VER: 20.2.2.1-01-2			
			// FIXME should do proper redirects with followRedirects and
			// .followRedirects(false)
			String tivoID = this.tivoID;
			String tivoVersion = this.tivoVersion;
			// if(this.tivoVersion == null)
			// // tivoVersion = "7.2.1-oth-01-2";
			// tivoVersion = "11.0c-01-2";

			debugOut("app with tivo headers:" + tivoID + ":" + tivoVersion); //$NON-NLS-1$ //$NON-NLS-2$
			if (tivoID != null)
				connection.header(HTTP_HEADER_TIVO_ID, tivoID);
			if (tivoVersion != null)
				connection.header(HTTP_HEADER_TIVO_VERSION, tivoVersion);
			Document doc = connection.get();
//debugOut(connection.response().headers());
//debugOut(connection.response().body());
			// tivocontainer details
			// contenttype [x-container/tivo-server]
			// sourceformat [x-container/folder]
			// title
			// totalitems [int]

			// tivocontainer itemcount [int]
			// tivocontainer itemstart [int]

			// tivocontainer item
			Elements items = doc.select("tivocontainer item"); //$NON-NLS-1$
			for (Element item : items) {
				// details / contenttype [application/x-hme]
				// details / hidden [present-or-not boolean]
				boolean hidden = (item.select("details hidden").size() > 0); //$NON-NLS-1$
				// details / sourceformat [x-container/folder]
				// details / title
				String title = item.select("details title").text(); //$NON-NLS-1$
				// details / uuid [2BD40EF7-D9D2-3CD4-0130-6C18855CE898]
				String uuid = item.select("details uuid").text(); //$NON-NLS-1$
				// details / x-tivo-topleveldisplayorderhint [int]
				String orderHintText = item.select(
						"details x-tivo-topleveldisplayorderhint").text(); //$NON-NLS-1$
				// links / content / contenttype [application/x-hme]
				// links / content / url
				String contentUrlText = item.select("links content url").text(); //$NON-NLS-1$
				// links / customicon / url
				String iconUrlText = item.select("links customicon url").text(); //$NON-NLS-1$

//				debugOut((hidden ? "(hidden)" : "") + title + "[" //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
//						+ orderHintText + "]" + contentUrlText + " icon: " //$NON-NLS-1$ //$NON-NLS-2$
//						+ iconUrlText);

				if (contentUrlText != null
						&& contentUrlText.trim().length() > 0) {
					try {
						URL contentUrl = new URL(contentUrlText);
//						debugOut(contentUrl.getPath() + " vs. " //$NON-NLS-1$
//								+ link.getPath() + " of " + link); //$NON-NLS-1$
						if (link.getPath().trim().length() > 0) {
							if (contentUrl.getPath().startsWith(link.getPath())) {
								debugOut("matched " + link.getPath()); //$NON-NLS-1$
								loc = contentUrlText;
								break;
							}
						}
					} catch (MalformedURLException ex) {
						// just continue.
					}
//				} else {
//					if (contentUrlText != null) {
//						loc = contentUrlText;
//					}
				}
			}

			// Elements urls =
			// doc.select("tivocontainer item links content url");
			// debugOut(doc.toString());
			// debugOut("urls: "+urls);
			// if(urls != null && urls.size() > 0) {
			// loc = urls.get(0).text().trim();
			// }
			/*
			 * MY TIVO <tivocontainer> <details> <contenttype>
			 * x-container/tivo-server </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>TiVo Server</title>
			 * <totalitems> 27 </totalitems> </details> <itemcount> 27
			 * </itemcount> <itemstart> 0 </itemstart> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <hidden />
			 * <sourceformat> x-container/folder </sourceformat> <title>Credit
			 * Card Update (PCI enabled)</title> <uuid>
			 * 984BBCD1-F705-6F3C-8E1A-BA7F4C26B570 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 15
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.59:7287/CreditCard_20080912-
			 * 20080912_131340/1221250421/1289849840-1605209840/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/CreditCard_20080912
			 * -20080912_131340/1221250421/1289849840-1605209840/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Buy a TiVo
			 * Premiere</title> <uuid> 0F64DC01-096D-D7A9-1145-060E26DD0CE5
			 * </uuid> <x-tivo-topleveldisplayorderhint> 3
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.59:7287/TivoUpgrade-
			 * 20120424_122953/1335295796/1335399021-1650759021/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/TivoUpgrade
			 * -20120424_122953/1335295796/1335399021-1650759021/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Amazon v1.9
			 * (2010.10.25-0632)</title> <uuid>
			 * 35FE011C-3850-2228-FBC5-1B9EDBBE5863 </uuid> </details> <links>
			 * <content> <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/amazon-1-9.2011.03.16-0632-
			 * 20110316_154048/1300315250/1317939394-1633299394/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/amazon-1-9.2011.03.16-0632-
			 * 20110316_154048/1300315250/1317939394-1633299394/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>netflix 1.6</title>
			 * <uuid> 7EDEB291-0DB8-487F-B842-6B97BC71AD9A </uuid> </details>
			 * <links> <content> <contenttype> application/x-hme </contenttype>
			 * <url>
			 * https://204.176.49.65:7287/bundle-netflix-standalone.2011.08
			 * .10-1225-
			 * 20110810_150805/1313014088/1319001823-1634361823/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/bundle
			 * -netflix-standalone.2011.08.10-1225
			 * -20110810_150805/1313014088/1319001823-1634361823/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Order Domino's Pizza
			 * Now</title> <uuid> 6BA2A86B-619B-67A6-BFA3-0E137B167A5A </uuid>
			 * <x-tivo-topleveldisplayorderhint> 21
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176
			 * .49.65:7287/dominos.2009.05.07.r1021.logerror.signed-
			 * 20090507_174812/1241743696/1289849802-1605209802/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/dominos
			 * .2009.05.07.r1021.logerror.signed
			 * -20090507_174812/1241743696/1289849802-1605209802/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Browse and Buy Movie
			 * Tickets</title> <uuid> B9DDBECF-BC6D-5E33-388A-4CF840068D79
			 * </uuid> <x-tivo-topleveldisplayorderhint> 30
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/fandivo-1.1.2011.11.10-1645-
			 * 20111115_112508/1321385109/1347427227-1662787227/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/fandivo-1.1.2011.11.10-1645-
			 * 20111115_112508/1321385109/1347427227-1662787227/icon_SD.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Photos &amp;
			 * Slideshows</title> <uuid> BBC7824A-40C6-8B61-4D87-6A3D799F365B
			 * </uuid> <x-tivo-topleveldisplayorderhint> 50
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/hdphotos-ml_2010.09.13-1339-
			 * 20100913_134517/1284410719/1347904431-1663264431/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/hdphotos-ml_2010.09.13-1339-
			 * 20100913_134517/1284410719/1347904431-1663264431/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>TiVo Search 1.4 Actual
			 * App (2011.03.16-0112)</title> <uuid>
			 * 1D9DF84A-BDF7-421E-B1E9-9BA375C2EF0C </uuid>
			 * <x-tivo-topleveldisplayorderhint> 50
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/hdui-1.4.1.2011.03.16-0112-
			 * 20110316_154124/1300315286/1301509488-1616869488/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/hdui-1.4.1.2011.03.16-0112-
			 * 20110316_154124/1300315286/1301509488-1616869488/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Hme Down</title> <uuid>
			 * 9D99EC4B-B08C-191C-3255-40B58B1F5DAF </uuid> </details> <links>
			 * <content> <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/hmedown_20080317-
			 * 20080402_170823/1207181304/1240249987-1587405187/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/hmedown_20080317
			 * -20080402_170823/1207181304/1240249987-1587405187/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Guru Guides (3/08 -
			 * 1143)</title> <uuid> 403871C3-A324-21B8-1D8D-826834E758EB </uuid>
			 * </details> <links> <content> <contenttype> application/x-hme
			 * </contenttype> <url>
			 * https://204.176.49.65:7287/kidzone_v1.0-20100622-
			 * 20100622_141902/1277241543/1289849391-1605209391/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/kidzone_v1
			 * .0-20100622-20100622_141902/1277241543/1289849391-1605209391/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <hidden />
			 * <sourceformat> x-container/folder </sourceformat> <title>KidZone
			 * (3/8-1143)</title> <uuid> 5D524EE8-B977-1DC8-CD30-39BF60E7749C
			 * </uuid> </details> <links> <content> <contenttype>
			 * application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/kidzone_v1.0-20100622-
			 * 20100622_141902/1277241543/1289849349-1605209349/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/kidzone_v1
			 * .0-20100622-20100622_141902/1277241543/1289849349-1605209349/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>TiVo Search
			 * Beta</title> <uuid> AB306EFD-EB85-47C3-A38E-B29E52DB3C73 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 2
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/launcher-
			 * 1.3_2010.08.06-1858-20100806_190059/1281146460/1282091089-1597451089/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/launcher-
			 * 1.3_2010.08.06-1858-20100806_190059/1281146460/1282091089-1597451089/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Live365</title> <uuid>
			 * 9B26EF4C-BF08-A9A5-F18E-F898DA9ADEB6 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 30
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/live365-
			 * 1.0_2010.08.02-2340-20100802_234348/1280817829/1347904368-1663264368/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/live365-
			 * 1.0_2010.08.02-2340-20100802_234348/1280817829/1347904368-1663264368/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Music Videos from Music
			 * Choice</title> <uuid> 7FDF1BEB-AF92-B8B6-6269-FAE44C8F887D
			 * </uuid> <x-tivo-topleveldisplayorderhint> 49
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/musicchoice-1.0-2010.08.04-0632-
			 * 20100804_161353/1280963634/1328046275-1643406275/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/musicchoice-1.0-2010.08.04-0632-
			 * 20100804_161353/1280963634/1328046275-1643406275/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Rhapsody Music
			 * Service</title> <uuid> AAF73CE2-1AD4-304A-1272-EB8E817238A9
			 * </uuid> <x-tivo-topleveldisplayorderhint> 20
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/norhapsody.2011.08.15-1619-
			 * 20110815_162006/1313450407/1347904314-1663264314/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/norhapsody.2011.08.15-1619-
			 * 20110815_162006/1313450407/1347904314-1663264314/icon_SD.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Pandora</title> <uuid>
			 * 68AD6946-B063-C92F-091B-C3F769FA5B81 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 10
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/pandora-1.1.2011.05.24-1649-
			 * 20110524_165839/1306281520/1347904283-1663264283/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/pandora-1.1.2011.05.24-1649-
			 * 20110524_165839/1306281520/1347904283-1663264283/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Podcaster</title>
			 * <uuid> 6838E9A3-F968-683E-110E-6591066452A1 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 40
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/podcast-20100730-qbert-
			 * 20100730_180250/1280538174/1347904398-1663264398/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/podcast-20100730-qbert-
			 * 20100730_180250/1280538174/1347904398-1663264398/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>SameGame</title> <uuid>
			 * DC47F5CD-C97F-1C8F-EA91-CDDB4CFA1EFA </uuid>
			 * <x-tivo-topleveldisplayorderhint> 65
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/samegame_20071012_01-
			 * 20080402_173700/1207183021/1347427605-1662787605/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/samegame_20071012_01
			 * -20080402_173700/1207183021/1347427605-1662787605/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Skull &amp;
			 * Bones</title> <uuid> 1A73F688-60B2-561D-BBEA-354BB36D3DA4 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 80
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/skullbones_20071012-
			 * 20080402_173743/1207183066/1347427626-1662787626/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/skullbones_20071012
			 * -20080402_173743/1207183066/1347427626-1662787626/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Survey App</title>
			 * <uuid> 5A695917-238E-4218-8066-D4713A314063 </uuid> </details>
			 * <links> <content> <contenttype> application/x-hme </contenttype>
			 * <url> https://204.176.49.65:7287/survey_20080530-
			 * 01_signed-20080530_150815/1212185297/1289848835-1605208835/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/survey_20080530
			 * -01_signed-20080530_150815/1212185297/1289848835-1605208835/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <hidden />
			 * <sourceformat> x-container/folder </sourceformat> <title>Swivel
			 * 2.8 U.S. Jump Target (03/16/11-0631)</title> <uuid>
			 * 49C791F9-7D48-38AB-8177-9C756D4EE2C0 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 50
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595307-1651955307/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595307-1651955307/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Swivel 2.8
			 * (03/16/11-0631)</title> <uuid>
			 * 2BD40EF7-D9D2-3CD4-0130-6C18855CE898 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 50
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595232-1651955232/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595232-1651955232/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>TiVoCast 2.8
			 * (2011.03.16-0115)</title> <uuid>
			 * 19452283-D00B-C411-595D-447ABF62F37C </uuid> </details> <links>
			 * <content> <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/tivocast-2.8-2012-06-26-0603at563743-
			 * 20120626_120132/1340737293/1344881428-1660241428/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/tivocast-2.8-2012-06-26-0603at563743-
			 * 20120626_120132/1340737293/1344881428-1660241428/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Video Player</title>
			 * <uuid> 863CB78F-EFDD-4106-B572-51733983DC76 </uuid> </details>
			 * <links> <content> <contenttype> application/x-hme </contenttype>
			 * <url> https://204.176.49.65:7287/videoplayer-0023-release-sst-
			 * 20090716_122445/1247772287/1333658049-1649018049/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/videoplayer-0023-release-sst-
			 * 20090716_122445/1247772287/1333658049-1649018049/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Wordsmith</title>
			 * <uuid> 41731A91-6B5D-7E7D-C495-9A1F399965C7 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 70
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/wordsmith_20071012-
			 * 20080402_180020/1207184421/1347428154-1662788154/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/wordsmith_20071012
			 * -20080402_180020/1207184421/1347428154-1662788154/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>YouTube</title> <uuid>
			 * 9AA364C9-CF8A-1E1D-B50F-CC65C40D4A96 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 5
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/youtube-1.0-2010.07.27-1808-
			 * 20100727_181419/1280279661/1336773245-1652133245/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/youtube-1.0-2010.07.27-1808-
			 * 20100727_181419/1280279661/1336773245-1652133245/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>YouTube 1.0 (tcast jump
			 * 7/10)</title> <uuid> 06F36A5F-FE5D-4F03-99A0-64B92896B47F </uuid>
			 * <x-tivo-topleveldisplayorderhint> 50
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/youtube-1.0-2010.07.27-1808-
			 * 20100727_181419/1280279661/1282259262-1597619262/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/youtube-1.0-2010.07.27-1808-
			 * 20100727_181419/1280279661/1282259262-1597619262/icon.png </url>
			 * </customicon> </links> </item> </tivocontainer>
			 */

			//
			//
			//

			/*
			 * TIVO: <tivocontainer> <details> <contenttype>
			 * x-container/tivo-server </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>TiVo Server</title>
			 * <totalitems> 20 </totalitems> </details> <itemcount> 20
			 * </itemcount> <itemstart> 0 </itemstart> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <hidden />
			 * <sourceformat> x-container/folder </sourceformat> <title>Credit
			 * Card Update (PCI enabled)</title> <uuid>
			 * 984BBCD1-F705-6F3C-8E1A-BA7F4C26B570 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 15
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.59:7287/CreditCard_20080912-
			 * 20080912_131340/1221250421/1289849840-1605209840/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/CreditCard_20080912
			 * -20080912_131340/1221250421/1289849840-1605209840/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Buy a TiVo
			 * Premiere</title> <uuid> 0F64DC01-096D-D7A9-1145-060E26DD0CE5
			 * </uuid> <x-tivo-topleveldisplayorderhint> 3
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.59:7287/TivoUpgrade-
			 * 20120424_122953/1335295796/1335399021-1650759021/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/TivoUpgrade
			 * -20120424_122953/1335295796/1335399021-1650759021/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Amazon v1.9
			 * (2010.10.25-0632)</title> <uuid>
			 * 35FE011C-3850-2228-FBC5-1B9EDBBE5863 </uuid> </details> <links>
			 * <content> <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/amazon-1-9.2011.03.16-0632-
			 * 20110316_154048/1300315250/1317939394-1633299394/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/amazon-1-9.2011.03.16-0632-
			 * 20110316_154048/1300315250/1317939394-1633299394/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Order Domino's Pizza
			 * Now</title> <uuid> 6BA2A86B-619B-67A6-BFA3-0E137B167A5A </uuid>
			 * <x-tivo-topleveldisplayorderhint> 21
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176
			 * .49.65:7287/dominos.2009.05.07.r1021.logerror.signed-
			 * 20090507_174812/1241743696/1289849802-1605209802/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/dominos
			 * .2009.05.07.r1021.logerror.signed
			 * -20090507_174812/1241743696/1289849802-1605209802/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Browse and Buy Movie
			 * Tickets</title> <uuid> B9DDBECF-BC6D-5E33-388A-4CF840068D79
			 * </uuid> <x-tivo-topleveldisplayorderhint> 30
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/fandivo-1.1.2011.11.10-1645-
			 * 20111115_112508/1321385109/1343238702-1658598702/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/fandivo-1.1.2011.11.10-1645-
			 * 20111115_112508/1321385109/1343238702-1658598702/icon_SD.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Photos &amp;
			 * Slideshows</title> <uuid> BBC7824A-40C6-8B61-4D87-6A3D799F365B
			 * </uuid> <x-tivo-topleveldisplayorderhint> 47
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/hdphotos-ml_2010.09.13-1339-
			 * 20100913_134517/1284410719/1343239081-1658599081/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/hdphotos-ml_2010.09.13-1339-
			 * 20100913_134517/1284410719/1343239081-1658599081/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Hme Down</title> <uuid>
			 * 9D99EC4B-B08C-191C-3255-40B58B1F5DAF </uuid> </details> <links>
			 * <content> <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/hmedown_20080317-
			 * 20080402_170823/1207181304/1240249987-1587405187/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/hmedown_20080317
			 * -20080402_170823/1207181304/1240249987-1587405187/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Guru Guides (3/08 -
			 * 1143)</title> <uuid> 403871C3-A324-21B8-1D8D-826834E758EB </uuid>
			 * </details> <links> <content> <contenttype> application/x-hme
			 * </contenttype> <url>
			 * https://204.176.49.65:7287/kidzone_v1.0-20100622-
			 * 20100622_141902/1277241543/1289849391-1605209391/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/kidzone_v1
			 * .0-20100622-20100622_141902/1277241543/1289849391-1605209391/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <hidden />
			 * <sourceformat> x-container/folder </sourceformat> <title>KidZone
			 * (3/8-1143)</title> <uuid> 5D524EE8-B977-1DC8-CD30-39BF60E7749C
			 * </uuid> </details> <links> <content> <contenttype>
			 * application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/kidzone_v1.0-20100622-
			 * 20100622_141902/1277241543/1289849349-1605209349/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/kidzone_v1
			 * .0-20100622-20100622_141902/1277241543/1289849349-1605209349/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Live365</title> <uuid>
			 * 9B26EF4C-BF08-A9A5-F18E-F898DA9ADEB6 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 35
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/live365-
			 * 1.0_2010.08.02-2340-20100802_234348/1280817829/1343239177-1658599177/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/live365-
			 * 1.0_2010.08.02-2340-20100802_234348/1280817829/1343239177-1658599177/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Music Videos from Music
			 * Choice</title> <uuid> 7FDF1BEB-AF92-B8B6-6269-FAE44C8F887D
			 * </uuid> <x-tivo-topleveldisplayorderhint> 49
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/musicchoice-1.0-2010.08.04-0632-
			 * 20100804_161353/1280963634/1328046275-1643406275/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/musicchoice-1.0-2010.08.04-0632-
			 * 20100804_161353/1280963634/1328046275-1643406275/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Podcaster</title>
			 * <uuid> 6838E9A3-F968-683E-110E-6591066452A1 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 45
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/podcast-20100730-qbert-
			 * 20100730_180250/1280538174/1343239384-1658599384/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/podcast-20100730-qbert-
			 * 20100730_180250/1280538174/1343239384-1658599384/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>SameGame</title> <uuid>
			 * DC47F5CD-C97F-1C8F-EA91-CDDB4CFA1EFA </uuid>
			 * <x-tivo-topleveldisplayorderhint> 65
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/samegame_20071012_01-
			 * 20080402_173700/1207183021/1343239500-1658599500/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/samegame_20071012_01
			 * -20080402_173700/1207183021/1343239500-1658599500/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Skull &amp;
			 * Bones</title> <uuid> 1A73F688-60B2-561D-BBEA-354BB36D3DA4 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 80
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/skullbones_20071012-
			 * 20080402_173743/1207183066/1343239554-1658599554/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/skullbones_20071012
			 * -20080402_173743/1207183066/1343239554-1658599554/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Survey App</title>
			 * <uuid> 5A695917-238E-4218-8066-D4713A314063 </uuid> </details>
			 * <links> <content> <contenttype> application/x-hme </contenttype>
			 * <url> https://204.176.49.65:7287/survey_20080530-
			 * 01_signed-20080530_150815/1212185297/1289848835-1605208835/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/survey_20080530
			 * -01_signed-20080530_150815/1212185297/1289848835-1605208835/icon.png
			 * </url> </customicon> </links> </item> <item> <details>
			 * <contenttype> application/x-hme </contenttype> <hidden />
			 * <sourceformat> x-container/folder </sourceformat> <title>Swivel
			 * 2.8 U.S. Jump Target (03/16/11-0631)</title> <uuid>
			 * 49C791F9-7D48-38AB-8177-9C756D4EE2C0 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 50
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595307-1651955307/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595307-1651955307/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Swivel 2.8
			 * (03/16/11-0631)</title> <uuid>
			 * 2BD40EF7-D9D2-3CD4-0130-6C18855CE898 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 50
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595232-1651955232/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/swivel-2.8.3-2012-05-08-0603at553106-
			 * 20120508_094009/1336495211/1336595232-1651955232/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>TiVoCast 2.8
			 * (2011.03.16-0115)</title> <uuid>
			 * 19452283-D00B-C411-595D-447ABF62F37C </uuid> </details> <links>
			 * <content> <contenttype> application/x-hme </contenttype> <url>
			 * https://204.176.49.65:7287/tivocast-2.8-2012-06-26-0603at563743-
			 * 20120626_120132/1340737293/1344881428-1660241428/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/tivocast-2.8-2012-06-26-0603at563743-
			 * 20120626_120132/1340737293/1344881428-1660241428/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <hidden /> <sourceformat>
			 * x-container/folder </sourceformat> <title>Video Player</title>
			 * <uuid> 863CB78F-EFDD-4106-B572-51733983DC76 </uuid> </details>
			 * <links> <content> <contenttype> application/x-hme </contenttype>
			 * <url> https://204.176.49.65:7287/videoplayer-0023-release-sst-
			 * 20090716_122445/1247772287/1333658049-1649018049/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/videoplayer-0023-release-sst-
			 * 20090716_122445/1247772287/1333658049-1649018049/icon.png </url>
			 * </customicon> </links> </item> <item> <details> <contenttype>
			 * application/x-hme </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>Wordsmith</title>
			 * <uuid> 41731A91-6B5D-7E7D-C495-9A1F399965C7 </uuid>
			 * <x-tivo-topleveldisplayorderhint> 70
			 * </x-tivo-topleveldisplayorderhint> </details> <links> <content>
			 * <contenttype> application/x-hme </contenttype> <url>
			 * http://204.176.49.116:7288/wordsmith_20071012-
			 * 20080402_180020/1207184421/1343239627-1658599627/clientip_67.0.59.230/
			 * </url> </content> <customicon> <url>
			 * http://204.176.49.116:7288/wordsmith_20071012
			 * -20080402_180020/1207184421/1343239627-1658599627/icon.png </url>
			 * </customicon> </links> </item> </tivocontainer>
			 * 
			 * 
			 * 
			 * <!--?xml version="1.0" encoding="ISO-8859-1"?--> <html>
			 * <head></head> <body> <tivocontainer> <details> <contenttype>
			 * x-container/tivo-server </contenttype> <sourceformat>
			 * x-container/folder </sourceformat> <title>TiVo Server</title>
			 * <totalitems> 0 </totalitems> </details> <itemcount> 0
			 * </itemcount> <itemstart> 0 </itemstart> </tivocontainer> <!--
			 * Copyright (c) 2002-2009 TiVo, Inc. --> </body> </html>
			 */
			/*
			 * <html> <head></head> <body> <tivocontainer> <details>
			 * <contenttype> x-container/tivo-server </contenttype>
			 * <sourceformat> x-container/folder </sourceformat> <totalitems> 1
			 * </totalitems> <title>apps.tv HME Server</title> </details>
			 * <itemstart> 0 </itemstart> <itemcount> 1 </itemcount> <item>
			 * <details> <contenttype> application/x-hme </contenttype>
			 * <sourceformat> x-container/folder </sourceformat> <title>apps.tv
			 * Subscription Manager</title> </details> <links> <content> <url>
			 * http://209.97.196.52:2281/submanager/ </url> </content> </links>
			 * </item> </tivocontainer> </body> </html>
			 */
			/*
			 * ticketchannel: <html> <head></head> <body> <tivocontainer>
			 * <details> <contenttype> x-container/tivo-server </contenttype>
			 * <sourceformat> x-container/folder </sourceformat> <totalitems> 1
			 * </totalitems> <title>Ticket Channel (Beta)</title> </details>
			 * <itemstart> 0 </itemstart> <itemcount> 1 </itemcount> <item>
			 * <details> <contenttype> application/x-hme </contenttype>
			 * <sourceformat> x-container/folder </sourceformat> <title>Ticket
			 * Channel (Beta)</title> </details> <links> <content> <url>
			 * http://208.116.35.238:7288/hme/ </url> </content> </links>
			 * </item> </tivocontainer> </body> </html>
			 */
			/*
			 * mp3tunes: <html> <head></head> <body> <tivocontainer> <details>
			 * <contenttype> x-container/tivo-server </contenttype>
			 * <sourceformat> x-container/folder </sourceformat> <totalitems> 1
			 * </totalitems> <title>MP3tunes HME Server</title> </details>
			 * <itemstart> 0 </itemstart> <itemcount> 1 </itemcount> <item>
			 * <details> <contenttype> application/x-hme </contenttype>
			 * <sourceformat> x-container/folder </sourceformat> <title>MP3tunes
			 * Locker</title> </details> <links> <content> <url>
			 * http://168.143.122.40:7288/mp3tunes/ </url> </content> </links>
			 * </item> </tivocontainer> </body> </html>
			 */
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		URL httplink;
		try {
			httplink = new URL("http" //$NON-NLS-1$
				+ link.toString().substring(link.getProtocol().length()));
		} catch(MalformedURLException e) {
			e.printStackTrace();
			httplink = link;
		}

		if (loc == null) {
			//FIXME support https, too
			loc = httplink.toString();
		} else if (link.getQuery() != null) {
			loc = loc + "?" + link.getQuery(); //$NON-NLS-1$
		}
		
		// handle possible relative URLs
		try {
			loc = getSrc(httplink, loc);
		} catch(Exception e) {
			//TODO uh... this is a problem.
			e.printStackTrace();
		}
		return loc;
	}

	private TeDict getHMETeDict(URL link) {
		TeDict params = null;

		String q = link.getQuery();
		if (q != null) {
			if (q.startsWith("?"))// TODO this should be unnecessary...query //$NON-NLS-1$
									// doesn't include the ?
				q = q.substring(1);
			params = new TeDict();
			String[] nvps = q.split("&"); //$NON-NLS-1$
			for (String nvp : nvps) {
				String[] nameVal = nvp.split("="); //$NON-NLS-1$
				if (nameVal.length == 2) {
					try {
						String name = URLDecoder.decode(nameVal[0], "UTF-8"); //$NON-NLS-1$
						String val = URLDecoder.decode(nameVal[1], "UTF-8"); //$NON-NLS-1$
						params.add(name, val);
					} catch (UnsupportedEncodingException e) {
						e.printStackTrace();
					}
				}
			}
		}
		return params;
	}

	/**
	 * Load an hme:// url as an app.
	 * 
	 * @param link
	 */
	void loadApp(URL link) {
		
		String loc = getHmeURL(link);
	
		TeDict params = getHMETeDict(link);
		// if(loc.contains("videoplayer")) {
		// loc += "watch/";
		// }

		play(SOUND_SELECT);
		byte[] memento;
		URL start = null;
		try {
			start = new URL(startURL);
		} catch (MalformedURLException e) {
		}
		if (link.equals(start)) {
			// if we're loading an app as our start url, when that app returns,
			// we have to quit... act as a pass-through
			memento = MEMENTO_QUIT_ON_RETURN;
		} else {
			memento = createMemento();
		}
		debugOut("transition to hme app:" + loc + "  " //$NON-NLS-1$ //$NON-NLS-2$
				+ params + " MEMENTO:"+new String(memento)); //$NON-NLS-1$
		
		logAppEnd("startApp:"+ loc);
		this.cleanExit = true;
		this.transitionForward(
				loc, params,
				memento);
	}

	/**
	 * If the link has a query, converts it to a Map of name/value pairs,
	 * otherwise it returns null.
	 */
	public Map getHmeMap(URL link) {
		TeDict dict = getHMETeDict(link);
		if (dict != null) {
			Map params = new HashMap();
			TeIterator names = dict.getNames();
			while (names.hasNext()) {
				String name = (String) names.next();
				Object value = dict.getValue(name, 0);
				params.put(name, value);
			}
			return params;
		}
		return null;
//		Map params = null;
//		String q = link.getQuery();
//		if (q != null) {
//			if (q.startsWith("?"))// TODO this should be unnecessary...query //$NON-NLS-1$
//									// doesn't include the ?
//				q = q.substring(1);
//			params = new HashMap();
//			String[] nvps = q.split("&"); //$NON-NLS-1$
//			for (String nvp : nvps) {
//				String[] nameVal = nvp.split("="); //$NON-NLS-1$
//				if (nameVal.length == 2) {
//					try {
//						String name = URLDecoder.decode(nameVal[0], "UTF-8"); //$NON-NLS-1$
//						String val = URLDecoder.decode(nameVal[1], "UTF-8"); //$NON-NLS-1$
//						params.put(name, val);
//					} catch (UnsupportedEncodingException e) {
//						e.printStackTrace();
//					}
//				}
//			}
//		}
//		return params;
	}
	private byte[] createMemento() {
		if(getCurrentScreen() instanceof BookmarkScreen) {
			String folder = ((BookmarkScreen) getCurrentScreen()).folder;
			if (folder != null) {
				return folder.getBytes();
			} else {
				return MEMENTO_BOOKMARKS;
			}
		}
		URL url = null;
		if(getCurrentScreen() instanceof WebScreen) {
			url = ((WebScreen)getCurrentScreen()).getURL();
		}
		if(url == null) {
			url = getLastVisited();
		}
		if (url != null) {
			return url.toString().getBytes();
		}
		return null;
	}

	private void handleMemento(byte[] memento) {
		if (memento != null && memento.length > 0) {
			if (Arrays.equals(memento, MEMENTO_QUIT_ON_RETURN)) {
				logAppEnd("passthrough");
				closeBrowser();
				return;
			} else if (Arrays.equals(memento, MEMENTO_BOOKMARKS)) {
				// this is the default first page
				return;
			}
			String urlString = new String(memento);
			// try {
			// URL url = new URL(urlString);
			startURL = urlString;
			// } catch (MalformedURLException e) {
			// }
			debugOut("MEMENTO:" + startURL); //$NON-NLS-1$
		}
	}

	private void showBookmarks() {
		showBookmarks(false);
	}

	private void showBookmarks(boolean isFirstPage) {
		showBookmarks(isFirstPage, null);
	}
	
	private void showBookmarks(boolean isFirstPage, String folder) {

		if(!isFirstPage) {
			play(SOUND_TIVO);
		}
		
		BookmarkScreen screen = new BookmarkScreen(this);
		screen.isFirstPage = isFirstPage;
		if (isFirstPage) {
			/* BEGIN HME 1.4.1e only */
			if (isResolutionSupported()) {
				screen.setTargetResolution(this.getReceiverResolutionInfo()
						.getPreferredRenderingResolution());
			}
			/* END HME 1.4.1e only */
		}

		this.push(screen, TRANSITION_FADE, folder);
	}

	public boolean isBookmarksDisabled() {
		return disableBookmarks;
	}
	
	public void clearCookies() {
		debugOut("**** clearing all cookies");
		getCookieStore().removeAll(); //COOKIES
		refreshBookmarks();
	}

	public boolean saveBookmark(URL urlBase, String titleString, String folder, URL icon) {
		// apply folder to titlestring
		String oldFolder = getFolder(titleString);
		// remove old folder
		if (oldFolder != null) {
			titleString = titleString.substring(oldFolder.length());
		}
		if (folder.startsWith(BOOKMARK_FOLDER_PREFIX)) {
			folder = folder.substring(BOOKMARK_FOLDER_PREFIX.length());
		}
		// add new folder
		if (!folder.endsWith(BOOKMARK_FOLDER_SEPARATOR) && folder.length() > 0) {
			folder = folder + BOOKMARK_FOLDER_SEPARATOR;
		}
		logBookmark("thumztakedit", urlBase==null?null:urlBase.toString(), icon==null?null:icon.toString(), folder, titleString);
		titleString = folder + titleString;
		// save bookmark
		return saveBookmark(urlBase, titleString, icon);
	}
	
	public boolean saveBookmark(URL urlBase, String titleString, URL icon) {
		if (!isBookmarksDisabled()) {
			String bookmarkString = getContext().getPersistentData(
					BOOKMARKS_KEY);
			saveBookmark(urlBase, titleString, icon, bookmarkString);
			return true;
		}
		return false;
	}
	
	public String saveBookmark(URL urlBase, String titleString, URL icon, String bookmarkString) {
		if (!isBookmarksDisabled()) {
			if (bookmarkString == null) {
				bookmarkString = ""; //$NON-NLS-1$
			}
			if(bookmarkString.trim().length() == 0) {
				bookmarkString = addDefaultBookmarks(bookmarkString);
			}
			bookmarkString = addBookmark(bookmarkString, urlBase, titleString,
					icon);
			getContext().setPersistentData(BOOKMARKS_KEY, bookmarkString);
			return bookmarkString;
		} else {
			return bookmarkString;
		}
	}

	private String addDefaultBookmarks(String bookmarkString) {
		LinkedHashMap<String, URL[]> bookmarks = new LinkedHashMap<String, URL[]>();
		// oh... ok, add all the default bookmarks so they don't lose them.
		try {
			addDefaultWebsiteBookmarks(bookmarks);
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		for(String title : bookmarks.keySet()) {
			URL urls[] = bookmarks.get(title);
			if(urls == null || urls.length < 2)
				continue;
			URL url = urls[0];
			URL iconUrl = urls[1];
			bookmarkString = addBookmark(bookmarkString, url, title, iconUrl);
		}
		return bookmarkString;
	}

	public boolean removeBookmark(URL urlBase, String titleString, URL icon) {
		if (!isBookmarksDisabled()) {
			String bookmarkString = getContext().getPersistentData(
					BOOKMARKS_KEY);
			if (bookmarkString == null) {
				bookmarkString = ""; //$NON-NLS-1$
			}
			bookmarkString = removeBookmark(bookmarkString, urlBase,
					titleString);
			getContext().setPersistentData(BOOKMARKS_KEY, bookmarkString);
			return true;
		} else {
			return false;
		}
	}

	/**
	 * Use the returned string in any methods that require the bookmark string
	 * data as an argument when you want to use a cached copy to improve
	 * performance.
	 * 
	 * @param context
	 * @return
	 */
	public static String getBookmarkData(IContext context) {
		return context.getPersistentData(BOOKMARKS_KEY);
	}
	public LinkedHashMap<String, URL[]> getBookmarks() {
		return getBookmarks(null);
	}
	public LinkedHashMap<String, URL[]> getBookmarks(String folder) {
		return getBookmarks(folder, getContext());
	}
	public static LinkedHashMap<String, URL[]> getBookmarks(String folder, IContext context) {
		String bookmarkString = getBookmarkData(context);
		return getBookmarks(folder, bookmarkString);
	}
	/**
	 * Resulting titles have folder removed from the front.
	 * @param folder
	 * @param bookmarkString
	 * @return
	 */
	public static LinkedHashMap<String, URL[]> getBookmarks(String folder, String bookmarkString) {
		if(folder != null && folder.startsWith(BOOKMARK_FOLDER_PREFIX)) {
			folder = getFolder(folder);
		}
		LinkedHashMap<String, URL[]> result = new LinkedHashMap<String, URL[]>();
		if (bookmarkString != null) {
			getBookmarks(result, bookmarkString);
		}
		
		if(result.size() == 0) {
			LinkedHashMap<String, URL[]> bookmarks = getDefaultBookmarks();
			
			result.putAll(bookmarks);
		}
			ArrayList<String> subfolders = new ArrayList<String>();
			if(folder != null) {
				Iterator<Entry<String, URL[]>> entries = result.entrySet().iterator();
				while(entries.hasNext()) {
					Entry<String, URL[]> bookmark = entries.next();
					// strip entries that don't start with folder
					if(!bookmark.getKey().startsWith(folder)) {
						entries.remove();
						continue;
					}
					String subfolder = getFolder(bookmark.getKey().substring(folder.length()));
					// strip entries that are in a subfolder (just leave a folder entry behind)
					if(subfolder != null) {
						entries.remove();
						if(!subfolders.contains(subfolder))
							subfolders.add(subfolder);
						continue;
					}
				}
				LinkedHashMap<String, URL[]> nonFolders = result;
				result = new LinkedHashMap<String, URL[]>();
				if(subfolders.size() > 0) {
					// put subfolders at beginning
					for(String subfolder : subfolders) {
						//FIXME define urls for this case
						try {
							result.put(subfolder, new URL[] {new URL(BOOKMARK_FOLDER_PREFIX+folder+subfolder),null});
						} catch (MalformedURLException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					}
				}
				for(Entry<String, URL[]>bookmark : nonFolders.entrySet()) {
					result.put(bookmark.getKey().substring(folder.length()), bookmark.getValue());
				}
			}
		return result;
	}
	private static LinkedHashMap<String, URL[]> getDefaultBookmarks() {
		LinkedHashMap<String, URL[]> bookmarks = new LinkedHashMap<String, URL[]>();
		try {
			addDefaultWebsiteBookmarks(bookmarks);
			
//			addDemoBookmarks(bookmarks);
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return bookmarks;
	}

	public static void addDemoBookmarks(LinkedHashMap<String, URL[]> bookmarks)
			throws MalformedURLException {
		URL url;
		URL icon;
					url = new URL("hme://wmcbrine.com/reversi"); //$NON-NLS-1$
					icon = new URL("http://wmcbrine.com/images/reversi.png"); //$NON-NLS-1$
					bookmarks.put("Games"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch Reversi game by wmcbrine", new URL[] {url, icon}); //$NON-NLS-1$
					
		//			url = new URL("hme://168.143.122.49:7288/mp3tunes");
					url = new URL("hme://www.mp3tunes.com"); // points to .49 ip //$NON-NLS-1$
					icon = new URL("http://168.143.122.40:7288/mp3tunes/icon.png"); //$NON-NLS-1$
					bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+HMEItem.GENRE_MUSIC+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch ('hme://...') MP3Tunes App [:( unplugged 12/2012]", new URL[] {url, icon}); //$NON-NLS-1$
		
		//			url = new URL("http://sideload.com/#primarynav");
		//			icon = new URL("http://s.mp3tunes.com/images/locker/sideload_logo.gif");
		//			bookmarks.put("(temp)sideload.com - add free MP3s to MP3Tunes", new URL[] {url, icon});
		
					// ticketchannel.tv still serves TiVoConnect, but no app at pointed location
		//			url = new URL("hme://69.72.234.59:7288/hme");
		//			url = new URL("hme://69.72.234.62:7288/hme"); // listed in ticketchannel simulator jnlp launcher
		//			url = new URL("hme://ticketchannel.tv"); //points to .59 ip
		//			bookmarks.put("(temp)TicketChannel TiVo App", new URL[] {url, icon});
		
		//			// apps.tv configures based on TiVo id, we're not a tivo.
		//			// also, the website is auctioned off as of 9/12/12
		//			url = new URL("hme://209.97.196.52:7288/submanager");
		////			url = new URL("hme://ns.apps.tv"); // or mail.apps.tv or mkloop.com (convert graphic to 1-frame mpg!)
		//			// only mkloop.com exists as of 9/3/2012, and that won't give you TiVoConnect
		//			//however hme handler now converts host to ip address before it begins.
		//			// mkloop.com gone as of 9/6/2012
		//			// no names available for apps.tv, and app is gone, now, too
		//			bookmarks.put("(temp)launch apps.tv App", new URL[] {url, icon});
		
		//			url = new URL("hme://204.176.49.116:7288/CreditCard");
		//			icon = null;
		//			bookmarks.put("(temp)launch TiVo's (hidden) Credit Card Update (PCI enabled) App", new URL[] {url, icon});
		//			url = new URL("hme://204.176.49.116:7288/TivoUpgrade");
		//			icon = null;
		//			bookmarks.put("(temp)launch TiVo's Buy a TiVo Premiere App", new URL[] {url, icon});
					url = new URL("hme://204.176.49.116:7288/amazon"); //$NON-NLS-1$
					icon = null;
					bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"TiVo's Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch TiVo's (hidden) Amazon App", new URL[] {url, icon}); //$NON-NLS-1$
					
					url = new URL("hme://204.176.49.116:7288/bundle-netflix"); //$NON-NLS-1$
					icon = null;
					bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"TiVo's Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch TiVo's (hidden) netflix App", new URL[] {url, icon}); //$NON-NLS-1$
					
					url = new URL("hme://204.176.49.116:7288/dominos"); //$NON-NLS-1$
					icon = null;
					bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"TiVo's Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch TiVo's (hidden) Order Domino's Pizza Now App", new URL[] {url, icon}); //$NON-NLS-1$
		//			url = new URL("hme://204.176.49.116:7288/fandivo");
		//			icon = null;
		//			bookmarks.put("launch TiVo's Browse and Buy Movie Tickets App", new URL[] {url, icon});
		//			url = new URL("hme://204.176.49.116:7288/hdphotos");
		//			icon = null;
		//			bookmarks.put("launch TiVo's Photos & Slideshows App", new URL[] {url, icon});
					url = new URL("hme://204.176.49.116:7288/hdui"); //$NON-NLS-1$
					icon = null;
					bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"TiVo's Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch TiVo's (hidden) TiVo Search App (hdui)", new URL[] {url, icon}); //$NON-NLS-1$
		//			url = new URL("hme://204.176.49.116:7288/hmedown");
		//			icon = null;
		//			bookmarks.put("launch TiVo's (hidden) Hme Down App", new URL[] {url, icon});
		//			url = new URL("hme://204.176.49.116:7288/kidzone");
		//			icon = null;
		//			bookmarks.put("launch TiVo's (hidden) Guru Guides App", new URL[] {url, icon});
					// same basic url for both
		//			bookmarks.put("launch TiVo's (hidden) KidZone App", new URL[] {url, icon});
					url = new URL("hme://204.176.49.116:7288/launcher"); //$NON-NLS-1$
					icon = null;
					bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"TiVo's Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch TiVo's TiVo Search Beta App", new URL[] {url, icon}); //$NON-NLS-1$
					
					url = new URL("hme://204.176.49.116:7288/live365"); //$NON-NLS-1$
					icon = null;
					bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"TiVo's Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch TiVo's Live365 App", new URL[] {url, icon}); //$NON-NLS-1$
					
		//			url = new URL("hme://204.176.49.116:7288/musicchoice");
		//			icon = null;
		//			bookmarks.put("launch TiVo's Music Videos from Music Choice App", new URL[] {url, icon});
		//			url = new URL("hme://204.176.49.116:7288/norhapsody");
		//			icon = null;
		//			bookmarks.put("launch TiVo's Rhapsody Music Service App placeholder (norhapsody)", new URL[] {url, icon});
					
					url = new URL("hme://204.176.49.116:7288/pandora"); //$NON-NLS-1$
					icon = null;
					bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"TiVo's Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch TiVo's Pandora App", new URL[] {url, icon}); //$NON-NLS-1$
		//			url = new URL("hme://204.176.49.116:7288/podcast");
		//			icon = null;
		//			bookmarks.put("launch TiVo's Podcaster App", new URL[] {url, icon});
					url = new URL("hme://204.176.49.116:7288/samegame"); //$NON-NLS-1$
					icon = null;
					bookmarks.put("Games"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch TiVo's SameGame App", new URL[] {url, icon}); //$NON-NLS-1$
					url = new URL("hme://204.176.49.116:7288/skullbones"); //$NON-NLS-1$
					icon = null;
					bookmarks.put("Games"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch TiVo's Skull & Bones App", new URL[] {url, icon}); //$NON-NLS-1$
		//			url = new URL("hme://204.176.49.116:7288/survey");
		//			icon = null;
		//			bookmarks.put("launch TiVo's (hidden) Survey App", new URL[] {url, icon});
					url = new URL("hme://204.176.49.116:7288/swivel"); //$NON-NLS-1$
					icon = null;
					// two versions of this
					bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"TiVo's Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch TiVo's (hidden) Swivel App", new URL[] {url, icon}); //$NON-NLS-1$
					url = new URL("hme://204.176.49.116:7288/tivocast"); //$NON-NLS-1$
					icon = null;
					bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"TiVo's Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch TiVo's (hidden) TiVoCast App (video on demand)", new URL[] {url, icon}); //$NON-NLS-1$
		//			url = new URL("hme://204.176.49.116:7288/videoplayer");
		//			icon = null;
		//			bookmarks.put("launch TiVo's (hidden) Video Player App", new URL[] {url, icon});
					url = new URL("hme://204.176.49.116:7288/wordsmith"); //$NON-NLS-1$
					icon = null;
					bookmarks.put("Games"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch TiVo's WordSmith App", new URL[] {url, icon}); //$NON-NLS-1$
					url = new URL("hme://204.176.49.116:7288/youtube"); //$NON-NLS-1$
					icon = null;
					// two versions, second one labeled "tcast jump"
					bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"TiVo's Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"launch TiVo's (hidden) YouTube App", new URL[] {url, icon}); //$NON-NLS-1$
					
//					url = new URL("hme://204.176.49.116/flash/youtube_leanback");
//					icon = null;
//					bookmarks.put("(temp)launch FLASH version of TiVo's (hidden) YouTube App", new URL[] {url, icon});
					
		/*
		urls: <url>
		 https://204.176.49.59:7287/CreditCard_20080912-20080912_131340/1221250421/1289849840-1605209840/clientip_67.0.59.230/
		</url>
		<url>
		 https://204.176.49.59:7287/TivoUpgrade-20120424_122953/1335295796/1335399021-1650759021/clientip_67.0.59.230/
		</url>
		<url>
		 https://204.176.49.65:7287/amazon-1-9.2011.03.16-0632-20110316_154048/1300315250/1317939394-1633299394/clientip_67.0.59.230/
		</url>
		<url>
		 https://204.176.49.65:7287/dominos.2009.05.07.r1021.logerror.signed-20090507_174812/1241743696/1289849802-1605209802/clientip_67.0.59.230/
		</url>
		<url>
		 https://204.176.49.65:7287/fandivo-1.1.2011.11.10-1645-20111115_112508/1321385109/1343238702-1658598702/clientip_67.0.59.230/
		</url>
		<url>
		 https://204.176.49.65:7287/hdphotos-ml_2010.09.13-1339-20100913_134517/1284410719/1343239081-1658599081/clientip_67.0.59.230/
		</url>
		<url>
		 http://204.176.49.116:7288/hmedown_20080317-20080402_170823/1207181304/1240249987-1587405187/clientip_67.0.59.230/
		</url>
		<url>
		 https://204.176.49.65:7287/kidzone_v1.0-20100622-20100622_141902/1277241543/1289849391-1605209391/clientip_67.0.59.230/
		</url>
		<url>
		 https://204.176.49.65:7287/kidzone_v1.0-20100622-20100622_141902/1277241543/1289849349-1605209349/clientip_67.0.59.230/
		</url>
		<url>
		 https://204.176.49.65:7287/live365-1.0_2010.08.02-2340-20100802_234348/1280817829/1343239177-1658599177/clientip_67.0.59.230/
		</url>
		<url>
		 https://204.176.49.65:7287/musicchoice-1.0-2010.08.04-0632-20100804_161353/1280963634/1328046275-1643406275/clientip_67.0.59.230/
		</url>
		<url>
		 http://204.176.49.116:7288/podcast-20100730-qbert-20100730_180250/1280538174/1343239384-1658599384/clientip_67.0.59.230/
		</url>
		<url>
		 http://204.176.49.116:7288/samegame_20071012_01-20080402_173700/1207183021/1343239500-1658599500/clientip_67.0.59.230/
		</url>
		<url>
		 http://204.176.49.116:7288/skullbones_20071012-20080402_173743/1207183066/1343239554-1658599554/clientip_67.0.59.230/
		</url>
		<url>
		 https://204.176.49.65:7287/survey_20080530-01_signed-20080530_150815/1212185297/1289848835-1605208835/clientip_67.0.59.230/
		</url>
		<url>
		 https://204.176.49.65:7287/swivel-2.8.3-2012-05-08-0603at553106-20120508_094009/1336495211/1336595307-1651955307/clientip_67.0.59.230/
		</url>
		<url>
		 https://204.176.49.65:7287/swivel-2.8.3-2012-05-08-0603at553106-20120508_094009/1336495211/1336595232-1651955232/clientip_67.0.59.230/
		</url>
		<url>
		 https://204.176.49.65:7287/tivocast-2.8-2012-06-26-0603at563743-20120626_120132/1340737293/1344881428-1660241428/clientip_67.0.59.230/
		</url>
		<url>
		 https://204.176.49.65:7287/videoplayer-0023-release-sst-20090716_122445/1247772287/1333658049-1649018049/clientip_67.0.59.230/
		</url>
		<url>
		 http://204.176.49.116:7288/wordsmith_20071012-20080402_180020/1207184421/1343239627-1658599627/clientip_67.0.59.230/
		</url>			
		 */
	}

	public static void addDefaultWebsiteBookmarks(LinkedHashMap<String, URL[]> bookmarks)
			throws MalformedURLException {
		if(addDefaultWebsiteBookmarksFromFile(bookmarks)) {
			return;
		}
		
		URL url;
		URL icon;
		url = new URL("https://docs.google.com/document/pub?id=1o0jVDy2Ek-baZ7sm3v9OtTxZ9MksS-7RzLCY_1GU51w"); //$NON-NLS-1$
		icon = null;
		bookmarks.put("[About "+WebBrowserApp.BROWSER_NAME+"]", new URL[]{url, icon}); //$NON-NLS-1$

		if(WebBrowserApp.getDebugLevel() > 0) {
			url = new URL("http://192.168.0.20:80/EnterWebzTest");
			icon = null;
			bookmarks.put("(temp)Test HTML Page", new URL[] {url, icon});
		}
		/*
 "type":"uiNavigate",
 "uiDestinationType":"hme",
 "uri":"x-tivo:hme:uuid:863cb78f-efdd-4106-b572-51733983dc76",
 "parameters":{
  "title":"Title goes here",
  "subtitle":"Subtitle goes here",
  "description":"Description goes here",
  "uri":"http://192.168.10.198:9032/videos/movies/star_wars2.mpg?Format=video%2Fx-tivo-mpeg",
  "duration":8280
 }
		 * */

//			url = new URL("hme://192.168.0.20:7288/webz/?url=http://voice.google.com&test=blah");
//			icon = null;
//			bookmarks.put("(temp)Test HME Transition", new URL[] {url, icon});
		
		// TODO look up host name to get IP, THEN make request for IP/TiVoConnect... that works in the old apps.tv case

		url = new URL("http://hmedev.wikidot.com/enter-webz-links#main-content"); //$NON-NLS-1$
		icon = null;
		bookmarks.put("["+WebBrowserApp.BROWSER_NAME+" suggested links page]", new URL[] {url, icon}); //$NON-NLS-1$
		
		url = new URL("http://www.google.com"); //$NON-NLS-1$
		icon = new URL("http://www.google.com/images/google_favicon_128.png"); //$NON-NLS-1$
		bookmarks.put("Google.com", //$NON-NLS-1$
						new URL[] {url, icon});
		
		url = new URL("http://www.youtube.com"); //$NON-NLS-1$
		icon = new URL("http://s.ytimg.com/yts/img/favicon_32-vflWoMFGx.png"); //$NON-NLS-1$
		bookmarks.put("YouTube.com", new URL[] {url, icon}); //$NON-NLS-1$
		
//			
//url = new URL("http://feeds.feedburner.com/ICanHasCheezburger");
//icon = null;
//bookmarks.put("rss cheezburger",  new URL[]{url, icon});
//
//url = new URL("http://feeds.feedburner.com/AnimalGifs");
//icon = null;
//bookmarks.put("rss animal gifs",  new URL[]{url, icon});

		url = new URL("http://en.m.wikipedia.org"); //$NON-NLS-1$
		icon = new URL("http://en.wikipedia.org/apple-touch-icon.png"); //$NON-NLS-1$
		bookmarks.put("Wikipedia.org (mobile)", new URL[] {url, icon}); //$NON-NLS-1$
		
		url = new URL("http://m.wund.com/"); //$NON-NLS-1$
		icon = new URL("http://icons.wunderground.com/graphics/smalllogo.gif"); //$NON-NLS-1$
		bookmarks.put("(add zip, re-save)Weather Underground (mobile)", new URL[] {url, icon}); //$NON-NLS-1$
		
//			url = new URL("https://www.google.com/voice/m/i/voicemail");
		url = new URL("https://www.google.com/voice/m"); //$NON-NLS-1$
		icon = null;//new URL();
		bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"Google Voice", new URL[] {url, icon}); //$NON-NLS-1$
		
		url = new URL("http://mail.google.com/mail/x/"); //$NON-NLS-1$
		icon = new URL("http://mail.google.com/mail/images/2/mail_icon_32.png"); //$NON-NLS-1$
		bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"Gmail (mobile)", new URL[] {url, icon}); //$NON-NLS-1$
		
		url=new URL("http://mail.google.com/mail/x/?ui=html"); //$NON-NLS-1$
		icon = new URL("http://mail.google.com/mail/images/2/mail_icon_32.png"); //$NON-NLS-1$
		bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"Gmail (basic HTML)", new URL[] {url, icon}); //$NON-NLS-1$
		
		url = new URL("http://m.facebook.com/"); //$NON-NLS-1$
		icon = null;
		bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"Facebook.com (mobile)", new URL[] {url, icon}); //$NON-NLS-1$
		
		url = new URL("http://imdb.com"); //$NON-NLS-1$
		icon = new URL("http://i.media-imdb.com/images/SF0ae8798307d147d8ea59044184b4339e/mobile/icon_114x114.png"); //$NON-NLS-1$
		bookmarks.put("Internet Movie Database (IMDB.com)", new URL[] {url, icon});			 //$NON-NLS-1$

		url = new URL("http://archive.org/details/feature_films"); //$NON-NLS-1$
		icon = new URL("http://archive.org/images/glogo.jpg"); //$NON-NLS-1$
		bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+HMEItem.GENRE_VIDEO+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"Feature Films at Archive.org", new URL[] {url, icon}); //$NON-NLS-1$
		
		url = new URL("http://archive.org/details/etree"); //$NON-NLS-1$
		icon = new URL("http://archive.org/images/glogo.jpg"); //$NON-NLS-1$
		bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+HMEItem.GENRE_MUSIC+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"Live Concerts at Archive.org", new URL[] {url, icon}); //$NON-NLS-1$

		url = new URL("http://archive.org/details/classic_tv"); //$NON-NLS-1$
		icon = new URL("http://archive.org/images/glogo.jpg"); //$NON-NLS-1$
		bookmarks.put("Apps"+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+HMEItem.GENRE_VIDEO+WebBrowserApp.BOOKMARK_FOLDER_SEPARATOR+"Classic TV at Archive.org", new URL[] {url, icon}); //$NON-NLS-1$

		url = new URL("http://archive.org/details/americana"); //$NON-NLS-1$
		icon = new URL("http://archive.org/images/glogo.jpg"); //$NON-NLS-1$
		bookmarks.put("American Library texts at Archive.org", new URL[] {url, icon}); //$NON-NLS-1$

		url = new URL("http://tivocommunity.com"); //$NON-NLS-1$
		icon = new URL("http://www.tivocommunity.com/home/sites/default/files/tcflogonew5.png"); //$NON-NLS-1$
		bookmarks.put("TiVoCommunity.com", new URL[] {url, icon}); //$NON-NLS-1$
		
		url = new URL("https://mobile.twitter.com/TiVo"); //$NON-NLS-1$
		icon = new URL("https://ma.twimg.com/twitter-mobile/e85c3330835e527a4e9f0f9621fc53841a65c1b8/images/ic_favicon.png"); //$NON-NLS-1$
		bookmarks.put("Twitter.com: TiVo (mobile)", new URL[] {url, icon}); //$NON-NLS-1$
		
		url = new URL("http://xkcd.com"); //$NON-NLS-1$
		icon = new URL("http://imgs.xkcd.com/static/apple-touch-icon-precomposed.png"); //$NON-NLS-1$
		bookmarks.put("xkcd.com comics", new URL[] {url, icon}); //$NON-NLS-1$
		
//			url = new URL("http://icanhascheezburger.com/#MobileSearch");
//			icon = null;
//			bookmarks.put("BROKEN LOLcats - i can has cheezburger?", new URL[] {url, icon});
		
		url = new URL("http://david.blackledge.com"); //$NON-NLS-1$
		icon = null;
		bookmarks.put("David.Blackledge.com", new URL[] {url, icon}); //$NON-NLS-1$
		
		addDemoBookmarks(bookmarks);
	}
	
	private static boolean addDefaultWebsiteBookmarksFromFile(java.util.LinkedHashMap<String, URL[]> bookmarks) {
		String filename = System.getProperty("links", "default_links.txt");
		BufferedReader reader;
		try {
			reader = new BufferedReader(new FileReader(filename));
			for (String line = reader.readLine(); line != null; line = reader.readLine()) {
				if (line.startsWith("#") || line.trim().length() == 0)continue; //$NON-NLS-1$
				String parts[] = line.split("\t"); //$NON-NLS-1$
				if (parts.length <= 0)
					continue;
				String url_s = parts[0];
				String title = parts[1];
				title = title.replaceAll("\\\\r", "\r");
				String icon_s = null;
				if (parts.length > 2)
					icon_s = parts[2];
				try {
					URL url = new URL(url_s);
					URL icon = null;
					if (icon_s != null && icon_s.trim().length() > 0) {
						try {
							icon = new URL(url, icon_s);
						} catch (Exception e) {
							debugOut("Link icon Failed (" + icon_s + "): " + e);
							continue;
						}
					}

					bookmarks.put(title, new URL[] { url, icon });
					debugOut("Load Link: " + line); //$NON-NLS-1$
				} catch (Exception e) {
					debugOut("Link Failed (" + line + "): " + e);
					continue;
				}
			}
			reader.close();
			return true;
		} catch (FileNotFoundException e) {
			debugOut("load Links "+filename+": " + e.getMessage());
		} catch (IOException e) {
			debugOut("load Links "+filename+": " + e.getMessage());
		}
		return false;
	}

	static final String BOOKMARK_FOLDER_PREFIX = "file:";
	static final String BOOKMARK_FOLDER_SEPARATOR = "\r";

	static String getFolder(String bookmarkName) {
		if(bookmarkName.startsWith(BOOKMARK_FOLDER_PREFIX)) {
			bookmarkName = bookmarkName.substring(BOOKMARK_FOLDER_PREFIX.length());
			return bookmarkName+BOOKMARK_FOLDER_SEPARATOR;
		}
		int folderEnd = bookmarkName.indexOf(BOOKMARK_FOLDER_SEPARATOR);
		if(folderEnd < 0)
			return null;
		else
			++folderEnd;
		return bookmarkName.substring(0, folderEnd);
	}

	static String getFixedResourceSrc(String original) {
		if(original.startsWith("https://")) {
			return "http://" + original.substring("https://".length());
		}
		return original;
	}
	
	static String getSrc(URL urlBase, String src) {
		if(src == null) return null;
		try {
			// fix spaces in url
			src = src.trim().replaceAll(" ", "%20");
			return new URL(urlBase, src).toString();
		} catch (MalformedURLException e) {
			debugOut(e);
			return src;
		}
	}
	
	static URL getURL(URL urlBase, String src) {
		if(src == null) return null;
		try {
			src = src.trim().replaceAll(" ", "%20");
			return new URL(urlBase, src);
		} catch (MalformedURLException e) {
			debugOut(e);
			return null;
		}
	}

	private static void getBookmarks(LinkedHashMap<String, URL[]> result,
			String bookmarkString) {
		String[] bookmarks = bookmarkString.split(BOOKMARK_ENTRY_SEP);
		for (String bookmark : bookmarks) {
			String[] parts = bookmark.split(BOOKMARK_URL_TITLE_SEP);
			if (parts.length == 3 || parts.length == 4) {
				URL url;
				try {
					url = new URL(parts[0]);
				} catch (MalformedURLException e) {
					System.err.println(e.toString());
					continue;
				}
				URL iconurl = null;
				// backward compatibility
				if (parts.length == 4) {
					saveCookie(url, parts[2]);
					if (parts[1] != null && parts[1].trim().length() > 0) {
						iconurl = getURL(url, parts[1]);
						if(iconurl == null) {
							continue;
						}
					}
				} else
					saveCookie(url, parts[1]);
				result.put(parts[parts.length - 1], new URL[] { url, iconurl });
			}
		}
	}

	private String addBookmark(String bookmarkString, URL urlBase2,
			String titleString2, URL icon) {
		String iconString = getRelativeURL(urlBase2, icon);
		if (iconString == null) {
			iconString = ""; //$NON-NLS-1$
		} else if(iconString.endsWith(".html") || iconString.endsWith(".htm")) {
			//eliminate bogus entries
			iconString = ""; //$NON-NLS-1$
		} else if(iconString.lastIndexOf(".") < iconString.lastIndexOf("/")) { //$NON-NLS-1$ //$NON-NLS-2$
			//eliminate bogus entries (no suffix at end part of URL)
			iconString = ""; //$NON-NLS-1$
		} else
			debugOut("bookmark icon:" + iconString); //$NON-NLS-1$
		String bookmark = urlBase2.toString() + BOOKMARK_URL_TITLE_SEP
				+ iconString + BOOKMARK_URL_TITLE_SEP;
		String cookies = getSavedCookie(urlBase2);
		if (cookies != null) {
			bookmark += cookies;
		}
		bookmark += BOOKMARK_URL_TITLE_SEP + titleString2;
		if (bookmarkString.length() > 0) {
			return bookmarkString + BOOKMARK_ENTRY_SEP + bookmark;
		} else {
			return bookmark;
		}
	}

	public static String getRelativeURL(URL urlBase, URL icon) {
		if (icon == null)
			return null;
		if (urlBase.getProtocol().equals(icon.getProtocol())
				&& urlBase.getHost().equals(icon.getHost())
				&& urlBase.getPort() == icon.getPort()) {
			// TODO should be able to just check urlBase.getAuthority() to
			// include everything at once including userInfo, but I'm not
			// certain that's always set...?
			String base = urlBase.getFile();
			String rel = icon.getFile();
			String newRel = rel;
			int bi = base.indexOf("/"); //$NON-NLS-1$
			int ri = rel.indexOf("/"); //$NON-NLS-1$
			while (bi != -1 && bi == ri
					&& base.substring(0, bi).equals(rel.substring(0, ri))) {
				newRel = rel.substring(ri);
				bi = base.indexOf("/", bi + 1); //$NON-NLS-1$
				ri = rel.indexOf("/", ri + 1); //$NON-NLS-1$
			}
//			debugOut(newRel + " = " + icon + " - " + urlBase); //$NON-NLS-1$ //$NON-NLS-2$
			return newRel;
		}
		return icon.toString();
	}

	private String removeBookmark(String bookmarkString, URL urlBase,
			String titleString) {
		String result = null;
		if (bookmarkString != null) {
			String[] bookmarks = bookmarkString.split(BOOKMARK_ENTRY_SEP);
			for (String bookmark : bookmarks) {
				if (bookmark.startsWith(urlBase.toString()
						+ BOOKMARK_URL_TITLE_SEP)) {
					// skip it.
				} else {
					if (result != null && result.trim().length() != 0) {
						result = result + BOOKMARK_ENTRY_SEP + bookmark;
					} else {
						result = bookmark;
					}
				}
				// String[] parts = bookmark.split("\t");
				// if(parts.length == 2) {
				// }
			}
		}
		if (result == null) {
			return ""; //$NON-NLS-1$
		}
		return result;
	}
	
	void refreshBookmarks() {
		if(isBookmarksDisabled()) return;
		
		String bookmarkString = getContext().getPersistentData(
				BOOKMARKS_KEY);
		if(bookmarkString == null || bookmarkString.trim().length() == 0) {
			bookmarkString = addDefaultBookmarks("");
		}
		refreshBookmarks(bookmarkString);
	}
	
	String refreshBookmarks(String bookmarkString) {
		if(isBookmarksDisabled()) return bookmarkString;
		String result = "";
		if (bookmarkString == null) {
			bookmarkString = ""; //$NON-NLS-1$
		}
		
		String[] bookmarks = bookmarkString.split(BOOKMARK_ENTRY_SEP);
		for (String bookmark : bookmarks) {
			String[] parts = bookmark.split(BOOKMARK_URL_TITLE_SEP);
			if (parts.length == 3 || parts.length == 4) {
				URL url;
				try {
					url = new URL(parts[0]);
				} catch (MalformedURLException e) {
					System.err.println(e.toString());
					continue;
				}
				URL iconurl = null;
				// backward compatibility
				if (parts.length == 4) {
					if(parts[1] != null && parts[1].trim().length() > 0) {
						iconurl = getURL(url, parts[1]);
						if(iconurl == null) {
							continue;
						}
					}
				}
				String title = parts[parts.length - 1];
				
				// gets the most recent cookie when it adds the bookmark.
				result = addBookmark(result, url, title, iconurl);
			}
		}
		
		getContext().setPersistentData(BOOKMARKS_KEY, result);
		return result;
	}	

	public void setLastVisited(URL url, String title) {
		if (url == null) {
			return;
		}
		if (title == null) {
			title = url.toString();
		}
		getContext().setPersistentData(LAST_TITLE_KEY, title);
		getContext().setPersistentData(LAST_URL_KEY, url.toString());
	}

	URL getLastVisited() {
		String urlString = getContext().getPersistentData(LAST_URL_KEY);
		if (urlString != null) {
			// change to URL
			try {
				return new URL(urlString);
			} catch (MalformedURLException e) {
				return null;
			}
		}
		return null;
	}

	String getLastVisitedTitle() {
		String titleString = getContext().getPersistentData(LAST_TITLE_KEY);
		return titleString;
	}

	private static void saveCookie(URL urlBase, String cookie2) {
		if (cookie2 == null || urlBase == null || cookie2.length() == 0)
			return;
		// known degenerative case... giant cookies... 20k seems somewhat reasonable, but 20M isn't
		// that causes major slowdown that breaks other stuff.
		if(cookie2.length() > MAX_COOKIE_LENGTH) {
			debugOut("saveCookie: cookie arg too large to save for "+urlBase+"! "+cookie2.length());
			return;
		}

		java.net.URI uri;
		try {
			uri = urlBase.toURI();
		} catch (URISyntaxException e) {
			debugOut("CAN'T SAVE COOKIE FOR " + urlBase + ": " + e); //$NON-NLS-1$ //$NON-NLS-2$
			return;
		}
		CookieStore cookies = getCookieStore();
//debugOut("*** saveCookie for "+uri+"\n"+cookie2);
		try {
			List<HttpCookie> cookieSet = HttpCookie.parse(cookie2);
			for (HttpCookie cookie : cookieSet) {
				//COOKIES
				
	//			//force cookies to version 1 so we keep path/domain information!
	//			cookie.setVersion(1);
				
				// now that it parsed as version 1 to get multi-cookie, set to version 0 so it works properly on connections(?)
				cookie.setVersion(0);
				cookies.add(uri, cookie);
			}
		} catch(Exception e) {
			debugOut("Error with cookie \""+cookie2+"\" for "+urlBase+":\n"+e);
			return;
		}
	}

	private static String getSavedCookie(URL urlBase) {
		if (urlBase == null)
			return null;

		java.net.URI uri;
		try {
			uri = urlBase.toURI();
		} catch (URISyntaxException e) {
			debugOut("CAN'T get SAVED COOKIE FOR " + urlBase + ": " + e); //$NON-NLS-1$ //$NON-NLS-2$
			return null;
		}
		CookieStore cookies = getCookieStore();
		List<HttpCookie> cookieSet = cookies.get(uri);

		StringBuffer cookieString = new StringBuffer();
		for (int i = 0; i < cookieSet.size(); ++i) {
			if (i != 0) {
				cookieString.append(","); //$NON-NLS-1$
			}
			//COOKIES
			HttpCookie cookie = cookieSet.get(i);
			// the toString() includes domain, etc only if version is 1... and we keep convincing the system they're version 0 somehow.
//			cookie.setVersion(1);
			cookieString.append(cookie);
			// actually, setting it to version 1 doesn't help either...that uses $Path and $Domain which don't get parsed!
			// duplicating code from cookie's toString, but without the $'s
	        if (cookie.getPath() != null)
	        	cookieString.append(";Path=\"").append(cookie.getPath()).append('"');
	        if (cookie.getDomain() != null)
	        	cookieString.append(";Domain=\"").append(cookie.getDomain()).append('"');
	        if (cookie.getPortlist() != null)
				cookieString.append(";Port=\"").append(cookie.getPortlist()).append('"');
	        // we also need to remember some other things for storage
	        if (cookie.getMaxAge() != -1)
	        	cookieString.append(";Max-Age=\"").append(cookie.getMaxAge()).append('"');
	        if (cookie.getSecure())
	        	cookieString.append(";Secure");
		}
		// toString doesn't even include anything that parseCookie needs to figure out this is version 1
		if(cookieSet.size() > 0) {
			cookieString.append(";version=1");
		}
		
		if(cookieString.length() > MAX_COOKIE_LENGTH) {
			debugOut("getSavedCookie: cookie too large to return for "+urlBase+"! "+cookieString.length());
			return "";
		}
//debugOut("*** getSavedCookie for "+uri+"\n"+cookieString);
		
		return cookieString.toString();
	}

	private TeDict getSavedCookiesAsTeDict(URL urlBase) {
		if (urlBase == null)
			return null;

		java.net.URI uri;
		try {
			uri = urlBase.toURI();
		} catch (URISyntaxException e) {
			debugOut("CAN'T get SAVED COOKIE FOR " + urlBase + ": " + e); //$NON-NLS-1$ //$NON-NLS-2$
			return null;
		}
		CookieStore cookies = getCookieStore();
		List<HttpCookie> cookieSet = cookies.get(uri);

		TeDict result = new TeDict();
		for (HttpCookie cookie : cookieSet) {
			//FIXME getValue probably isn't the entire cookie spec..
			//   might have to use toString and trim off the "name="
			String cookieString = cookie.toString();
			//FIXME simulator is doc'd to not support quoted strings which this gives you.
			String cookieVal = cookieString.substring(cookieString.indexOf("=")+1); //$NON-NLS-1$
			//cookie.toString());
//			cookie.getValue());
			
			result.add(cookie.getName(), cookieVal);
		}
		return result;
	}
	
	private View screenBlanker = null;
	@Override
	public boolean handleIdle(boolean isIdle) {
		if (isIdle && getCurrentScreen() != null
				&& getCurrentScreen() instanceof WebScreen
				&& (!this.allowTimeout)) {
			acknowledgeIdle(true);
			// if we're displaying a PIP video, make it full screen
			if (isStreamTypeVideo()) {
				foregroundStream();
				if (isStreamDisplayPIP()) {
					zoomPIP();
				}
			} else {
				blankScreen();
			}
			return true;
		}
		if(!isIdle) {
			// undo any idle handling user can't do on their own.
			// (in other words, leave video full screen, but fix other stuff)
			unblankScreen();
		}
		return super.handleIdle(isIdle);
	}

	private void blankScreen() {
		if (screenBlanker != null) {
			if (screenBlanker.getResource() != null) {
				screenBlanker.getResource().remove();
			}
			screenBlanker.remove();
		}
		screenBlanker = new View(getAbove(), 0, 0, getAbove().getWidth(), getAbove().getHeight());
		screenBlanker.setResource(Color.BLACK);
		screenBlanker.setTransparency(1.0f);
		screenBlanker.setTransparency(0.1f, getResource("*2000"));
	}

	private void unblankScreen() {
		if(screenBlanker != null) {
			Resource anim = getResource("*500");
			screenBlanker.setTransparency(1.0f, anim);
			screenBlanker.setVisible(false, anim);
		}
	}

	private boolean allowTimeout = true;
	
	public void setAllowIdleTimeout(boolean allow) {
		this.allowTimeout = allow;
	}

	/* BEGIN JSoup impl */
	public Response doPost(String submitAction, String encoding,
			ArrayList<String[]> formSubmission, URL referer) {
		Connection soupCon = Jsoupconnect(submitAction)
				.method(Method.POST);
		if (formSubmission != null) {
			for(String[] submission : formSubmission) {
				if(submission[1] == null) {
					debugOut("Null value for "+submission[0]+" not submitted");
					continue;
				}
				soupCon.data(submission[0],submission[1]);
			}
		}
		String referrer = null;
		if (referer != null) {
			referrer = referer.toString();
		}
		soupCon.referrer(referrer);
		
		debugOut("POST:" + submitAction + "?" + formSubmission); //$NON-NLS-1$ //$NON-NLS-2$
		Response res;
		try {
			soupCon.followRedirects(false);
			res = soupCon.execute();
			res = followRedirects(res, referrer);
		} catch (IOException e) {
			// this throws IOException only on a real error (not http error, and
			// doesn't parse so not contenttype).
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
		return res;
	}

	/**
	 * perform {@link Jsoup#connect(String)} and do some standard configuration
	 * (timeout, ignoreHttpErrors, and userAgent)
	 * 
	 * @param connectURL
	 * @return
	 */
	Connection Jsoupconnect(String connectURL) {
		//TODO find a way to add application/vnd.wap.xhtml+xml at beginning of "accept" to improve results
		return Jsoup.connect(connectURL)				
				.timeout(CONNECTION_TIMEOUT) // override the 3 second default
				.ignoreHttpErrors(true) // show errors as a page
				.userAgent(getUserAgent());
	}

	public Response getResponse(URL urlBase, URL referer) throws IOException {
		return getResponse(urlBase, referer, false);
	}
	
	public Response getResponse(URL urlBase, URL referer, boolean ignoreContentType) throws IOException {
		// This was just a stopgap, now JSoup throws
		// UnsupportedMimeTypeException
		// which gives the final content type and url without downloading stream
		// String contentGuess = guessContentType(urlBase);
		// // if we know this isn't expected to be a webpage, return null
		// if(contentGuess == null || contentGuess.startsWith("text/")) {

		Connection con = Jsoupconnect(urlBase.toString())
				// TODO could allow HTTP Exception instead and show as a popup
//				.ignoreHttpErrors(false)
				;
		
		// special handling to do a TiVo passthrough for TiVoConnect URLs
		if(urlBase.getPath().equals("/TiVoConnect")) {
			debugOut("/TiVoConnect: passing tivoID and tivoVersion in HTTP headers");
			con.header(V49IHmeProtocol.HTTP_HEADER_TIVO_ID, this.tivoID)
			.header(V49IHmeProtocol.HTTP_HEADER_TIVO_VERSION, this.tivoVersion);
		}
		
		con.ignoreContentType(ignoreContentType);
		
		String referrer = null;
		if (referer != null) {
			referrer = referer.toString();
			con.referrer(referrer);
		}
		// this throws IOException only on a real error (not http error, and
		// doesn't parse so not contenttype).
		// it also throws UnsupportedMimeTypeException and
		// SocketTimeoutException
		con.followRedirects(false);
		Response result = con.execute();
		result = followRedirects(result, referrer);

		return result;
		// } else {
		// return null;
		// }
	}

	public Response doGet(String submitAction, String encoding,
			ArrayList<String[]> formSubmission, URL referer) {

		Connection soupCon = Jsoupconnect(submitAction)
				.method(Method.GET);
		if (formSubmission != null) {
			for(String[] submission : formSubmission) {
				if(submission[1] == null) {
					debugOut("Null value for "+submission[0]+" not submitted");
					continue;
				}
				soupCon.data(submission[0],submission[1]);
			}
		}
		String referrer = null;
		if (referer != null) {
			referrer = referer.toString();
		}
		soupCon.referrer(referrer);

		debugOut("GET:" + submitAction + "?" + formSubmission); //$NON-NLS-1$ //$NON-NLS-2$
		Response res;
		try {
			soupCon.followRedirects(false);
			res = soupCon.execute();
			res = followRedirects(res, referrer);
		} catch (IOException e) {
			// this throws IOException only on a real error (not http error, and
			// doesn't parse so not contenttype).
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
		return res;
	}

	/**
	 * {@link HttpURLConnection#guessContentTypeFromName(String)} plus some
	 * additional guesses
	 * 
	 * @param urlBase
	 * @return
	 */
	static String guessContentType(URL urlBase) {
		String contentGuess = HttpURLConnection
				.guessContentTypeFromName(urlBase.getPath());
		if (contentGuess == null) {
			if (urlBase.getPath() != null) {
				String path = urlBase.getPath().toLowerCase();
				if (path.endsWith(".mp4")) { //$NON-NLS-1$
					contentGuess = "video/mp4"; //$NON-NLS-1$
				} else if (path.endsWith(".mp3")) { //$NON-NLS-1$
					contentGuess = "audio/mpeg"; //$NON-NLS-1$
				}
			}
		}
		// debugOut("guess: "+contentGuess+" "+urlBase.getPath()
		// +" --- "+urlBase);
		return contentGuess;
	}

	public Pattern redirectErrorPattern = Pattern
			.compile("^HTTP Error 30[12]\\.\\s*(.+)\\s*$"); //$NON-NLS-1$

	// public boolean handleStreamRedirectError(final BView view, HmeEvent
	// event,
	// String errorText, String contentType) {
	// if (errorText != null) {
	// Matcher m = redirectError.matcher(errorText);
	// if (m.matches()) {
	// debugOut("Matched redirect error... "+m.group(1));
	// try {
	// //unfortunately, this url isn't from the error, it's the original one
	// String url = m.group(1);
	// if (url != null) {
	// URL resURL = new URL(url.trim());
	// URL newresURL = resolveRedirects(resURL, null);
	// if(!resURL.equals(newresURL)) {
	// Resource newres = view.createStream( newresURL.toString(), contentType,
	// true);
	// // Resource newres = view.getResource(newresURL);
	// if(newres != null) {
	// newres.addHandler(this);
	// view.setResource(newres);
	//
	// Resource res = this.getResource(event.getID());
	// if(res != null) {
	// res.removeHandler(this);
	// }
	// return true;
	// }
	// }
	// }
	// } catch (MalformedURLException e) {
	// // give up and continue with regular error display
	// }
	// }
	// }
	// return false;
	// }

	/**
	 * tries to go through all the redirects, including with cookies. If the
	 * result we don't get anywhere, returns null. Caller should check if result
	 * matches starting arg.
	 * 
	 * @param newresURL
	 * @param referer
	 * @return
	 */
	public URL resolveRedirects(URL newresURL, URL referer) {
		boolean redirect = true;
		while (redirect) {
			URLConnection c;
			try {

				// FIXME replace withJSoup version! and add Referer to JSoup
				// version if that's correct to do!
				// TODO ok, did that, sortof...haven't really checked my work, though
				// FIXME this is only used by VideoWatcher currently
				String referrer = null;
				if (referer != null) {
					referrer = referer.toString();
				}
				Connection connection = Jsoupconnect(newresURL.toString()).followRedirects(false);
				if(referrer != null) {
					connection.referrer(referrer);
				}
				Response resp = followRedirects(connection.execute(), referrer);
				return resp.url();
				// c = newresURL.openConnection();
				// if(c instanceof HttpURLConnection) {
				// HttpURLConnection h = (HttpURLConnection) c;
				// h.setInstanceFollowRedirects(false);
				// if(referer != null) {
				// h.addRequestProperty(HTTP_HEADER_REFERER,
				// referer.toString());
				// }
				// try {
				// h.connect();
				// int respcode = h.getResponseCode();
				// if(respcode == 301 || respcode == 302) {
				// String newString = h.getHeaderField(HTTP_HEADER_LOCATION);
				// debugOut("Redirect "+newresURL+" to "+newString);
				// if(newString == null || newString.trim().length() == 0) {
				// // give up and return what we have.
				// return newresURL;
				// }
				// newresURL = new URL(newresURL, newString.trim());
				// } else {
				// debugOut("not redirect "+respcode+" "+h.getResponseMessage());
				// redirect = false;
				// }
				// } finally {
				// h.disconnect();
				// }
				// }
			} catch (UnsupportedMimeTypeException e) {
				// this is normal... we were just resolving redirects for a
				// media url, this proves that we found it!
				try {
					return new URL(e.getUrl());
				} catch (MalformedURLException e1) {
					debugOut("resolving redirects failed. "+e);
					return newresURL;
				}
			} catch (IOException e) {
				debugOut("resolving redirects failed. "+e);
				// return the best we have.
				return newresURL;
			}
		}
		return newresURL;
	}

	/* END JSoup impl */

	private Map<String, Object> resourceDetail = Collections
			.synchronizedMap(new HashMap<String, Object>());
	private URL themeURL = null;
	private String startMedia;

	public Object getResourceCache(String src) {
		synchronized (resourceDetail) {			
			return resourceDetail.get(getFixedResourceSrc(src));
		}
	}

	public void putResourceCache(String src, Object obj) {
		synchronized (resourceDetail) {			
			resourceDetail.put(getFixedResourceSrc(src), obj);
		}
	}

	@Override
	protected void rootBoundsChangedBeforeFirstPage(Rectangle rootBounds) {
		debugOut("ROOT BOUNDS CHANGED "+getReceiverResolutionInfo());
	}
	
//	@Override
//	public ResolutionInfo getReceiverResolutionInfo() {
//		// this method is used by push/pop to decide whether to set the screen's target res.
//		// we don't get an event if receiver did something on its own sometimes.
//		// so we ALWAYS report different info.
//		ResolutionInfo info = super.getReceiverResolutionInfo();
//		Resolution realRes = info.getRenderingResolution();
//		Resolution fakeRes = new Resolution(realRes.getWidth(), realRes.getHeight(), realRes.getPixelAspectNumerator()+1, realRes.getPixelAspectDenominator()+1);
//		return new ResolutionInfo(fakeRes,info.getAvailableRenderingResolutions());
//	}
	
	public WebBrowserTheme getTheme() {
		return theme;
	}

	private Map deviceInfo;
	/** examples: <pre>
	zoneinfo=America/Kentucky/Monticello,
	com.tivo.examine.idType.stationId=tivo,
	platform=Gen07,
	host=DVR-9A72,
	has-recording-capability=true,
	active-ui-mode=flash,
	has-season-pass-capability=true,
	credential-manager-id-mac=001BD7838CE2,
	vod-session-capable=false,
	version=20.3.7.1a-01-2-746,
	country=US,
	has-recording-storage=true,
	credential-manager-id-ccid=47838CE2,
	brand=TiVo,
	language=enUS,
	com.tivo.examine.showing=true,
	com.tivo.examine.idType.contentId=tivo
	</pre>
	*/
	public String getDeviceInfo(String key, String def) {
		if(deviceInfo != null && deviceInfo.get(key) != null) {
			return (String) deviceInfo.get(key);
		} else {
			return def;
		}
	}
	/**
	 * @return defaults to "America"
	 */
	public String getDeviceZone() {
		return getDeviceInfo("zoneinfo", "America");
	}
	/**
	 * @return defaults to "TiVo"
	 */
	public String getDeviceBrand() {
		return getDeviceInfo("brand", "TiVo");
	}
	/**
	 * @return defaults to "en"
	 */
	public String getDeviceLanguage() {
		return getDeviceInfo("language", "en");
	}
	/**
	 * @return defaults to "US"
	 */
	public String getDeviceCountry() {
		return getDeviceInfo("country", "US");
	}
	
	public boolean handleEvent(HmeEvent event) {

		if (event.getOpCode() == EVT_INIT_INFO) {
			// use our memento we stored when we transitioned to another app
			HmeEvent.InitInfo info = (HmeEvent.InitInfo) event;
			handleMemento(info.getMemento());
			debugOut("PARAMS:" + info.getParams()); //$NON-NLS-1$
		}
		else if (event.getOpCode() == EVT_DEVICE_INFO) {
			deviceInfo = ((DeviceInfo) event).getMap();
		}
		
		boolean result = super.handleEvent(event);
		// ...

		return result;
	}


	@Override
	protected void setContext(IContext context, int version) {
		super.setContext(context, version);
		
		// context.getConnectionAttribute(HTTP_HEADER_TIVO_ID);
		// tivoVersion is in DEVICE_INFO event under "version"
		// this.tivoVersion =
		// context.getConnectionAttribute(HTTP_HEADER_TIVO_VERSION);

		// try {
		// debugOut("headers from tivo: "+
		// context.getConnectionAttribute("Host"));
		// debugOut(Jsoup.connect("http://"+
		// context.getConnectionAttribute("Host")).ignoreHttpErrors(true).
		// execute().headers().toString());
		// } catch (IOException e) {
		// // TODO Auto-generated catch block
		// e.printStackTrace();
		// }
		// debugOut(HTTP_HEADER_TIVO_ID+": "+tivoID);
		// debugOut(HTTP_HEADER_TIVO_VERSION+": "+tivoVersion);

		// NOTE: for some reason all url-arg connection attributes have their
		// key's lowercased
		WebBrowserApp app = this;
		String instanceStartURL = context.getConnectionAttribute("url"); //$NON-NLS-1$
		if (instanceStartURL != null) {
			app.startURL = instanceStartURL;
			debugOut("CONNECTION ATTRIBUTE:" + app.startURL); //$NON-NLS-1$
		}
		String instanceStartMedia = context.getConnectionAttribute(WebBrowserOptions.URL_MEDIA);
		if(instanceStartMedia != null) {
			app.startMedia = instanceStartMedia;
		}
		String theme = context
				.getConnectionAttribute(WebBrowserOptions.URL_THEME); //$NON-NLS-1$
		if(theme != null) {
			try {
				app.themeURL  = new URL(theme);
			} catch(Exception e) {
				//FIXME log this error
				debugOut("theme URL failed: "+e);
			}
		}
		String disableBookmarks = context
				.getConnectionAttribute(WebBrowserOptions.URL_APPMODE); //$NON-NLS-1$
		app.disableBookmarks = (disableBookmarks != null);
		// FIXME implement domain limiting code
		// String restrictDomain =
		// context.getConnectionAttribute("domainlimit");
		// ((WebBrowserApp)application).domainLimit = domainLimit;
		String font = context.getConnectionAttribute(WebBrowserOptions.URL_FONTSCALE); //$NON-NLS-1$
		if (font != null) {
			try {
				app.fontScale = Float.parseFloat(font);
			} catch (Exception e) {
				WebBrowserApp.debugOut(e);
				// just don't set it.
			}
		}
		String mobile = context.getConnectionAttribute(WebBrowserOptions.URL_MOBILE); //$NON-NLS-1$
		if (mobile != null) {
			if(mobile.length() == 0 || mobile.equalsIgnoreCase("true") || mobile.equals("1") || mobile.equalsIgnoreCase("yes")) {
				this.setAppearingMobile(true);
			} else {
				this.setAppearingMobile(false);
			}
		}
		String style = context.getConnectionAttribute(WebBrowserOptions.URL_STYLE); //$NON-NLS-1$
		if (style != null) {
			try {
				MEDIA mediaStyle = MEDIA.valueOf(style.toUpperCase());
				this.setMediaStyleActive(mediaStyle);
			} catch (IllegalArgumentException e) {
				debugOut("style argument \""+style+"\" is Illegal.");
			}
		}
		String tables = context.getConnectionAttribute(WebBrowserOptions.URL_TABLES); //$NON-NLS-1$
		if (tables != null) {
			if(tables.length() == 0 || tables.equalsIgnoreCase("true") || tables.equals("1") || tables.equalsIgnoreCase("yes")) {
				this.setLayingOutTables(true);
			} else {
				this.setLayingOutTables(false);
			}
		}

	}

	public float getFontScaleRaw() {
		return fontScale;
	}

	public float getFontScale() {
		return getHDAdjustedFontScale(fontScale);
	}

	private float getHDAdjustedFontScale(float originalFontScale) {
		float ratio = ((float) getHeight()) / 480f;
		// make the used increase (amount over 1.0) a fraction of the ratio's
		// increase
		float increaseRate = .5f;
		float hdIncrease = 1.0f + (increaseRate * (ratio - 1.0f));
		// debugOut("hdincrease: "+hdIncrease +" ... "+getHeight()+" v 480");
		if (hdIncrease <= 1.0f) {
			return originalFontScale;
		} else {
			return originalFontScale * hdIncrease;
		}
	}

	public void setFontScale(float fontScale) {
		this.fontScale = fontScale;
	}
	
	/**
	 * revert to font scale last saved with {@link #setFontKey(int)}
	 */
	public void restoreSavedFontScale() {
		float scale = options.getFontScale();
		if(scale > 0f) {
			this.fontScale = scale;
		}
	}
	
	public int getSavedFontKey() {
		float scale = options.getFontScale();
		return getFontScaleKey(scale);
	}

	private Map<String, FontInfo> fontInfos = Collections
			.synchronizedMap(new HashMap<String, HmeEvent.FontInfo>());

	public Map<String, FontInfo> getFontInfos() {
		return fontInfos;
	}
	
	private STATUS pleaseWaitStatus;

	public TeDict getCookieTeDict(URL urlBase, URL referer) {
		if (urlBase == null)
			return null;
		
		//FIXME TeDict turned off for now... it apparently causes reboots when it's wrong
		debugOut("(disabled getCookieTeDict)"); //$NON-NLS-1$
		if(true) return null;
		
		TeDict result = new TeDict();
		// "Invalid parameter list"

		// try to get any set cookies and transfer them via the TeDict
		HttpURLConnection hconn = null;
		try {
			URLConnection connection = urlBase.openConnection();
			if (connection instanceof HttpURLConnection) {
				hconn = (HttpURLConnection) connection;

				// hconn.setRequestMethod("HEAD");//FIXME better, but could
				// prevent proper connection if server coded bad
				hconn.connect();
				hconn.disconnect();
			}
		} catch (Exception e) {
		}

		String headerValue = getSavedCookie(urlBase);
		if (headerValue != null) {
//			result.add(HTTP_HEADER_COOKIE, headerValue);
//			result.add(HTTP_HEADER_SET_COOKIE, headerValue); //THIS CAUSES A CRASH for vid stream... good sign, sort of!
			// options: 
			// break multi-cookie into multiple Set-Cookie entries
			// set cookie with a TeDict containing cookie name/value pairs
//			result.add(HTTP_HEADER_COOKIE.toLowerCase(), headerValue);
//			result.add(HTTP_HEADER_SET_COOKIE.toLowerCase(), headerValue);
		}
		
//		result.add(HTTP_HEADER_SET_COOKIE, "testSet=CookieSet");
		
		TeDict headers = new TeDict();
		TeDict cookies = getSavedCookiesAsTeDict(urlBase);
		if(urlBase != null && urlBase.toString().indexOf("EnterWebz")>-1) { //$NON-NLS-1$
			cookies.add("test", "TEST VALUE"); //$NON-NLS-1$ //$NON-NLS-2$
			if(referer == null)
				try {
					referer = new URL("http://referer.fake.net/");
				} catch (MalformedURLException e) { }
		}
		if(cookies != null) {
			result.add(HTTP_HEADER_SET_COOKIE, cookies); // DIDN'T CRASH (on vid stream)! YAY! (crashed when I passed a string header-content)
			// but it DID crash when I also set "COOKIE" and "cookie" header names with string value.
			// ummm... ok, it crashed once on just an image... but cookies was empty... but that was done for other images on same page, too
			result.add(HTTP_HEADER_COOKIE, cookies);
			headers.add(HTTP_HEADER_COOKIE, cookies);
		}
		if(referer != null) {
			headers.add(HTTP_HEADER_REFERER, referer.toString());
			result.add(HTTP_HEADER_REFERER, referer.toString());
			result.add(HTTP_HEADER_REFERER.toLowerCase(), referer.toString());
		}
//		result.add("Request-Headers", headers);
//		result.add("Headers", headers);
//		result.add("HTTP-Headers", headers);
//		result.add("HTTP_Headers", headers);
//		result.add("HTTP-Header", headers);
//		result.add("HTTP_Header", headers);
//		result.add("Request", headers);
//		result.add("HTTP-Request", headers);
//		result.add("request", headers);
//		result.add("http-request", headers);
//		result.add("HTTP_Request", headers);
//		result.add("http_request", headers);
//		result.add("HTTP_REQUEST", headers);
//		result.add("HTTP-REQUEST", headers);

 debugOut(String.valueOf(result));
		return result;
		// TeDict result2 = new TeDict();
		// result2.add("HTTP-Header", result);
		// result2.add("Header", result);
		// result2.add("Headers", result);
		// result2.add("HTTP-Headers", result);
		// result2.add("HTTP-HEADER", result);
		// result2.add("HTTP_HEADER", result);
		// result2.add("HTTP-HEADERS", result);
		// result2.add("HTTP_HEADERS", result);
		// result2.add("HEADER", result);
		// result2.add("HEADERS", result);
		// result2.add("http-header", result);
		// result2.add("http_header", result);
		// result2.add("http-headers", result);
		// result2.add("http_headers", result);
		// result2.add("header", result);
		// result2.add("headers", result);
		// // try space instead of - also
		// result2.add("http", result);
		// result2.add("HTTP", result);
		// System.out.println(result2);
		// return result2;
	}

	/**
	 * Present TyPo keyboard for data entry (puts any PIP in the
	 * background first).
	 * 
	 * @return the TyPo reference for further configuration
	 */
	public TyPo showTyPo() {
		backgroundStream();
		// set up a global top-level keyboard for use throughout the app.
		if (this.typoScreen == null) {
			TyPo.setUserWordListAllowed(false);
			this.typoScreen = new TyPoScreen(this, this.protocolVersion);
			// this.typo = this.typoScreen.getTyPo();
			this.setTyPoSettings();
		}
		// try to look consistent with the source screen
		this.typoScreen
				.setResource(getCurrentScreen().getBelow().getResource());

		push(this.typoScreen, TRANSITION_NONE);
		return this.typoScreen.getTyPo();
	}

	/**
	 * Pops the TyPo screen if it's showing and resets most configuration of
	 * TyPo. (restores any backgrounded PIP first)
	 */
	public void closeTyPo() {
		foregroundStream();
		if (getCurrentScreen() instanceof TyPoScreen)
			pop();
		// pop(((TyPoScreen)getCurrentScreen()).getTyPo().getValue());
		setTyPoSettings();
	}

	private void setTyPoSettings() {
		this.typoScreen.getTyPo().setKeyboard(Keyboard.DEFAULT);
		this.typoScreen.getTyPo().setActions(null, null);
		this.typoScreen.getTyPo().setActivateOnFocus(true);
		// this.typoScreen.getTyPo().setExitOptions(TyPo.EXIT_CANCEL,
		// TyPo.EXIT_FINISHED, true, false, false, false);
		this.typoScreen.getTyPo().setUseCompletions(true);
		// this.typoScreen.getTyPo().setValue("");
		
		this.typoScreen.getBelow().setResource("0x000033");
	}

	public static enum STATUS {
		CONNECTING, CONNECTING_STREAM, PARSING, PARSING_XML, PARSING_CSS, PARSING_HTML, REDIRECTING, COMPLETE
	};
	public void setLoadingStatus(STATUS status) {
		if(this.pleaseWait != null) {
			synchronized(this.pleaseWait) {
				this.pleaseWaitStatus = status;
				int statusTotal = STATUS.values().length;
				int percentInt = this.pleaseWaitStatus.ordinal()+1;
				float percent = (float)percentInt / (float)statusTotal;
				showProgress(percent);
			}
		}
	}

	private void showProgress(float percent) {
		if(this.pleaseWait.getChildCount() == 0) {
			if(isMaximized()) {
				new BView(this.pleaseWait, getSafeTitleHorizontal(), 0, 
						this.pleaseWait.getWidth()-2*getSafeTitleHorizontal(), 20);
			} else {
				new BView(this.pleaseWait, getSafeTitleHorizontal(), getSafeTitleVertical(), 
						this.pleaseWait.getWidth()-2*getSafeTitleHorizontal(), 20);
			}
		}
		BView prog = (BView) this.pleaseWait.getChild(0);
		prog.setSize((int) ((this.pleaseWait.getWidth()-2*getSafeTitleHorizontal())*percent), prog.getHeight());
		String statusResource = getTheme().getProgress(this.pleaseWaitStatus);
		prog.setResource(statusResource, RSRC_HALIGN_LEFT | RSRC_VALIGN_CENTER | RSRC_IMAGE_BESTFIT);
	}
	
	public void setLoadingStatus(int progress, int maxProgress) {
		if(this.pleaseWait == null) return;
		synchronized(this.pleaseWait) {
			int statusTotal = STATUS.values().length;
			int percentInt = this.pleaseWaitStatus.ordinal()+1;
			float percent = (float)percentInt / (float)statusTotal;
			float partPercent = (float)progress / (float)maxProgress;
			percent += partPercent*(1f/(float)statusTotal); 
			showProgress(percent);
		}
	}
	
	public void showPleaseWait() {
		if (this.pleaseWait == null) {
			// set up a global top-level please-wait for use throughout the app.

			this.pleaseWait = new BView(getAbove(), 0, 0,
					getAbove().getWidth(), getAbove().getHeight(), false);
			this.pleaseWait.setResource(getTheme().getPleaseWait(),
					RSRC_HALIGN_CENTER | RSRC_VALIGN_CENTER);
		}
		if (this.pleaseWait != null) {
			this.pleaseWait
					.setLocation((getNormal().getWidth() - this.pleaseWait
							.getWidth()) / 2,
							(getNormal().getHeight() - this.pleaseWait
									.getHeight()) / 2);
			this.pleaseWait.setVisible(true);
		}
	}

	public void hidePleaseWait() {
		if (this.pleaseWait != null)
			this.pleaseWait.setVisible(false);
	}

	HashMap<String, FontInfo> localFontInfos = new HashMap<String, FontInfo>();
	private AudioHandlerView audioHandler;
	static final float TEXT_SCALE_9 = 2.0f;
	static final float TEXT_SCALE_8 = 1.75f;
	static final float TEXT_SCALE_7 = 1.5f;
	static final float TEXT_SCALE_6 = 1.25f;
	static final float TEXT_SCALE_4 = .9f;
	static final float TEXT_SCALE_3 = .8f;
	static final float TEXT_SCALE_2 = .7f;
	static final float TEXT_SCALE_1 = .6f;
	static final float TEXT_SCALE_5 = 1.0f;

	/**
	 * Download a url's content and return as one big String. First tries JSoup
	 * with ignoreContentType, then just tries a direct connection (with no
	 * headers set) - which will probably never happen, actually.
	 * 
	 * @param urlBase
	 * @return
	 */
	public String getRawText(URL urlBase) {
		return getRawText(urlBase, null);
	}
	
	public String getRawText(URL urlBase, URL referer) {
		try {
			// first try JSoup with ignoreContentType
			Response response = getResponse(urlBase, referer, true);
			return response.body();
		} catch (Exception e1) {
			
			try {
				URLConnection connection = urlBase.openConnection();
				//FIXME set headers!
				InputStream stream = connection.getInputStream();
				BufferedReader reader = new BufferedReader(new InputStreamReader(
						stream));
				StringBuffer result = new StringBuffer();
				for (String line = reader.readLine(); line != null; line = reader
						.readLine()) {
					result.append(line).append("\n"); //$NON-NLS-1$
				}
				stream.close();
				return result.toString();
			} catch (IOException e) {
				debugOut("getRawText("+urlBase+"): "+e);
				return null;
			}
		}
	}

	private static float[] text_scales = {WebBrowserApp.TEXT_SCALE_1, WebBrowserApp.TEXT_SCALE_2, WebBrowserApp.TEXT_SCALE_3, WebBrowserApp.TEXT_SCALE_4, WebBrowserApp.TEXT_SCALE_5, WebBrowserApp.TEXT_SCALE_6, WebBrowserApp.TEXT_SCALE_7, WebBrowserApp.TEXT_SCALE_8, WebBrowserApp.TEXT_SCALE_9};
	
	/**
	 * triggers {@link #saveOptions()}, unlike other variations.
	 */
	public void setFontKey(int key) {
		setFontScale(getFontScale(key));
		options.setFontScale(getFontScaleRaw());
	}
	
	public float getFontScale(int key) {
		if(key <= 0 || key >= text_scales.length+1)
			key = 5;
		return(text_scales[key-1]);
	}
	
	public int getFontScaleKey() {
		float scale = getFontScaleRaw();
		return getFontScaleKey(scale);
	}

	private int getFontScaleKey(float scale) {
		if(scale == WebBrowserApp.TEXT_SCALE_1)
			return 1;
		else if(scale == WebBrowserApp.TEXT_SCALE_2)
			return 2;
		else if(scale == WebBrowserApp.TEXT_SCALE_3)
			return 3;
		else if(scale == WebBrowserApp.TEXT_SCALE_4)
			return 4;
		else if(scale == WebBrowserApp.TEXT_SCALE_5)
			return 5;
		else if(scale == WebBrowserApp.TEXT_SCALE_6)
			return 6;
		else if(scale == WebBrowserApp.TEXT_SCALE_7)
			return 7;
		else if(scale == WebBrowserApp.TEXT_SCALE_8)
			return 8;
		else if(scale == WebBrowserApp.TEXT_SCALE_9)
			return 9;
		else return 5;
	}

	public static enum MEDIA {TV, SCREEN, HANDHELD};
	public static enum MOBILE {AVANTGO, DOCOMO, SAMSUNG, IPAD, ANDROID, BB, OPERA, PALM};

	public boolean isMediaStyleActive(MEDIA type) {
		return options.isMediaStyleActive(type);
	}
	public MEDIA getMediaStyle() {
		return options.getMediaStyle();
	}
	/**
	 * triggers {@link #saveOptions()}
	 */
	public void setMediaStyleActive(MEDIA type) {
		options.setMediaStyleActive(type);
	}
	
	public boolean isMobileTypeActive(MOBILE type) {
		return options.isMobileTypeActive(type);
	}
	public MOBILE getMobileType() {
		return options.getMobileType();
	}
	/**
	 * triggers {@link #saveOptions()}
	 */
	public void setMobileTypeActive(MOBILE type) {
		options.setMobileType(type);
	}

	public void handleMenuAction(String action) {
		if(action.startsWith(WebMenuScreen.MENU_FONT_PREFIX)) {
			int fontnum = Integer.parseInt(action.substring(WebMenuScreen.MENU_FONT_PREFIX.length()));
			this.setFontKey(fontnum);
		} else if(action.equals(WebMenuScreen.MENU_TABLES)) {
			this.setLayingOutTables(!this.isLayingOutTables());
		} else if(action.equals(WebMenuScreen.MENU_MAXIMIZE)) {
			this.setMaximized(!this.isMaximized());
		} else if(action.equals(WebMenuScreen.MENU_LEFT_BACK)) {
			this.setLeftSameAsBack(!this.isLeftSameAsBack());
		} else if(action.equals(WebMenuScreen.MENU_MOBILE)) {
			this.setAppearingMobile(!this.isAppearingMobile());
		} else if(action.startsWith(WebMenuScreen.MENU_STYLE_PREFIX)) {
			String style = action.substring(WebMenuScreen.MENU_STYLE_PREFIX.length());
			try {
				this.setMediaStyleActive(MEDIA.valueOf(style.toUpperCase()));
			} catch(Exception e) {
				this.setMediaStyleActive(MEDIA.TV);
			}
		} else if(action.startsWith(WebMenuScreen.MENU_MODE_PREFIX)) {
			String mode = action.substring(WebMenuScreen.MENU_MODE_PREFIX.length());
			try {
				this.setMobileTypeActive(MOBILE.valueOf(mode.toUpperCase()));
			} catch(Exception e) {
				this.setMobileTypeActive(MOBILE.PALM);
			}
		}
	}

	public boolean isLeftSameAsBack() {
		return options.isLeftSameAsBack();
	}
	
	/**
	 * triggers {@link #saveOptions()}
	 */
	public void setLeftSameAsBack(boolean leftSameAsBack) {
		options.setLeftSameAsBack(leftSameAsBack);
	}

	public boolean isShaded() {
		return options.isShaded();
	}

	/**
	 * triggers {@link #saveOptions()}
	 */
	public void setShaded(boolean shade) {
		options.setShaded(shade);
	}

	public List<String> getBookmarkFolders() {
		LinkedHashMap<String, URL[]> bookmarks = getBookmarks();
		ArrayList<String> folders = new ArrayList<String>();
		for(Entry<String, URL[]>bookmark : bookmarks.entrySet()) {
			int folderEnd = bookmark.getKey().lastIndexOf(BOOKMARK_FOLDER_SEPARATOR);
			debugOut(bookmark.getKey());
			while(folderEnd > 0) {
				String folder = bookmark.getKey().substring(0, folderEnd+1);
				if(!folders.contains(folder))
					folders.add(folder);
				folderEnd = bookmark.getKey().lastIndexOf(BOOKMARK_FOLDER_SEPARATOR, folderEnd-1);
			}
		}
		for (String folder : new String[] {
				"Apps" + BOOKMARK_FOLDER_SEPARATOR,
				"Apps" + BOOKMARK_FOLDER_SEPARATOR + HMEItem.GENRE_MUSIC + BOOKMARK_FOLDER_SEPARATOR,
				"Apps" + BOOKMARK_FOLDER_SEPARATOR + HMEItem.GENRE_VIDEO + BOOKMARK_FOLDER_SEPARATOR,
				"Apps" + BOOKMARK_FOLDER_SEPARATOR + HMEItem.GENRE_PHOTOS + BOOKMARK_FOLDER_SEPARATOR }) {
			if(!folders.contains(folder))
				folders.add(folder);
		}
		debugOut("Folders: "+folders);
		return folders;
	}

	/**
	 * Convert internal folder or title format to a "folder/folder/title" string
	 * @param folder
	 * @return
	 */
	public static String folderToReadablePath(String folder) {
		if (folder == null)
			return "";
		if (folder.startsWith(BOOKMARK_FOLDER_PREFIX)) {
			folder = folder.substring(BOOKMARK_FOLDER_PREFIX.length());
		}
		return folder.replaceAll(Pattern.quote(BOOKMARK_FOLDER_SEPARATOR), "/");
	}
	
	public static String readablePathToFolder(String path) {
		if (path == null)
			return "";
		return path.replaceAll(Pattern.quote("/"), BOOKMARK_FOLDER_SEPARATOR);
	}

	public static class WebBrowserAd {
		public String title;
		public String image;
		public String url;
		public String options;
		public boolean isApp;
		public int appPriority;
		//...
		
		public WebBrowserAd(String source) {
			String[] parts = source.split("\t");
			if(parts.length > 0) {
				url = parts[0];
				if(parts.length > 1) {
					title = parts[1];
					if(parts.length > 2) {
						image = parts[2];
						if(parts.length > 3) {
							setOptions(parts[3]);
							if(parts.length > 4) {
								try {
									Integer appPriority = Integer.parseInt(parts[4]);
									this.appPriority = appPriority;
									isApp = true;
								} catch(Exception e) {
									isApp = false;
								}
							}
						}
					}
				}
			}
		}

		private void setOptions(String optionstring) {
			WebBrowserOptions o = new WebBrowserOptions(null);
			o.loadOptions(optionstring);
			options = o.getURLOptions();
		}
	}
		
	private static Vector<WebBrowserAd> ads = new Vector<WebBrowserAd>();
	private static long adRefresh = 0;
	
	/**
	 * 
	 * @return ?String title?, URL url, ?String icon?, Integer priority
	 */
	public static Vector<Object[]> getAppAds() {
		Vector<Object[]> result = new Vector<Object[]>();
		synchronized(ads) {
			loadAds(ads);
			for(WebBrowserAd ad : ads) {
				if(ad.isApp) {
					try {
						Object[] item = getAdItem(ad);

						result.add(item);

					} catch (MalformedURLException e) {
						debugOut("ad URL error: " + e.getMessage());
					}
				}
			}
		}
		return result;
	}

	/**
	 * 
	 * @return ?String title?, URL url, ?String icon?, ?appPriority?
	 */
	private static Object[] getAdItem(WebBrowserAd ad)
			throws MalformedURLException {
		Object[] item = new Object[5];
		if (ad.title != null && ad.title.length() > 0) {
			item[0] = ad.title;
		}
		if (ad.url != null && ad.url.length() > 0) {
			item[1] = new URL(ad.url);
		}
		if (ad.image != null && ad.image.length() > 0) {
			item[2] = ad.image;
		}
		if (ad.isApp) {
			item[3] = new Integer(ad.appPriority);
		}
		if(ad.options != null && ad.options.length() > 0) {
			item[4] = ad.options;
		}
		return item;
	}
	/**
	 * 
	 * @return ?String title?, URL url, ?String icon?
	 */
	public static Object[] getRandomAd() {
		synchronized(ads) {
			loadAds(ads);

			if(ads.size() > 0) {
				double rand = Math.random(); // number from 0.0 to LESS THAN 1.0
				// rand is less than 1, and floor rounds down if not an integer, so this
				// is guaranteed to be less than size
				int index = (int) Math.floor(rand*ads.size()); 

				if(index < 0 || index >= ads.size()) 
					index = 0;

				WebBrowserAd ad = ads.get(index);

				try {
					Object[] result = getAdItem(ad);

					return result;
				} catch (MalformedURLException e) {
					debugOut("ad URL error: " + e.getMessage());
				}
			}
		}
		
		try {
			return new Object[] {
					"<"+WebBrowserApp.BROWSER_NAME+" suggested links page>",
					new URL("http://hmedev.wikidot.com/enter-webz-links#main-content"),
					null};
		} catch (MalformedURLException e) {
			return new Object[] {
					"Have a Nice Day!",null,null
			};
		}
	}
	private static void loadAds(Vector<WebBrowserAd> ads) {
		long now = new Date().getTime();
		if (ads.size() > 0 && (now - adRefresh) < 60*60*1000) {
			return;
		}
		adRefresh  = now;
		ads.clear();
		
		String filename = System.getProperty("ads", "ads.txt");
		BufferedReader reader;
		try {
			reader = new BufferedReader(new FileReader(filename));
			for (String line = reader.readLine(); line != null; line = reader.readLine()) {
				if(line.startsWith("#") || line.trim().length() == 0) continue;
				ads.add(new WebBrowserAd(line));
				debugOut("Load Ad: "+line);
			}
			reader.close();
			return;
		} catch (FileNotFoundException e) {
			debugOut("load Ads "+filename+": " + e.getMessage());
		} catch (IOException e) {
			debugOut("load Ads "+filename+": " + e.getMessage());
		}

		// make sure the list isn't empty
		if(ads.size() == 0) {
			ads.add(new WebBrowserAd(
					"http://hmedev.wikidot.com/enter-webz-links#main-content"
							+ "\t" +
							"[" + WebBrowserApp.BROWSER_NAME + " suggested links]"
							+ "\t" +
							""
							+ "\t" +
							"false"
					));
		}
	}

	public boolean moveBookmark(String folder, int index, int newIndex, String newTitle) {
		String bookmarkString = getBookmarkData(getContext());
		// normalize the folder
		if (folder == null)
			folder = "";
		java.util.LinkedHashMap<String, URL[]> bookmarks = getBookmarks(folder, bookmarkString);
debugOut(folder+":"+bookmarks.size());
		if(folder != null && folder.startsWith(BOOKMARK_FOLDER_PREFIX)) {
			folder = getFolder(folder);
		}
		// find the bookmark at "index"
		int targeti = 0;
		String targettitle = null;
		URL targeturl = null;
		URL targeticon = null;
		for (Entry<String, URL[]> entry : bookmarks.entrySet()) {
			if (targeti == index) {
				targettitle = folder + entry.getKey();
				targeturl = entry.getValue()[0];
				targeticon = null;
				if (entry.getValue().length > 1)
					targeticon = entry.getValue()[1];
				break;
			}
			++targeti;
		}
		// if we didn't find it, we can't move it.
		if(targettitle == null) {
			return false;
		}
		
		// pre-remove the one we're moving so we don't accidentally remove it from its new location
		bookmarkString = removeBookmark(bookmarkString, targeturl, targettitle);
		
		// make sure new title and folder are set up correctly before we use it.
		if (newTitle == null) {
			newTitle = targettitle;
		} else {
			if (newTitle.indexOf(BOOKMARK_FOLDER_SEPARATOR) < 0) {
				// need to include original folder in newTitle
				newTitle = folder + newTitle;
			}
		}
		
		// move all of this folder to the end of the bookmarks one at a time,
		// moving our target while we go through them.
		int i = 0;
		for(Entry<String, URL[]> entry : bookmarks.entrySet()) {
			String title = entry.getKey();
			if (!title.startsWith(BOOKMARK_FOLDER_PREFIX)) {
				title = folder + title;
			}
			URL url = entry.getValue()[0];
			URL icon = null;
			if(entry.getValue().length > 1)
				icon = entry.getValue()[1];
			// remove the old one. (target item already removed, don't remove it from new location)
			if(i != index)
				bookmarkString = removeBookmark(bookmarkString, url, title);
			// place the target at its new location before the current entry at that location.
			if(i == newIndex) {
				debugOut("place target: "+newTitle);
				bookmarkString = addBookmark(bookmarkString, targeturl, newTitle, targeticon);
			}
			// add each old one at the end except the moved one.
			if (i != index
					&& !(url.toString().startsWith(BOOKMARK_FOLDER_PREFIX)
							|| title.endsWith(BOOKMARK_FOLDER_SEPARATOR))) {
				debugOut("place: "+title);
				bookmarkString = addBookmark(bookmarkString, url, title, icon);
			}
			++i;
		}
		// new index was too high, just add entry at end
		if(i <= newIndex) {
			debugOut("place target at end: "+newTitle);
			bookmarkString = addBookmark(bookmarkString, targeturl, newTitle, targeticon);
		}
		
		//save the bookmarks
		getContext().setPersistentData(BOOKMARKS_KEY, bookmarkString);
	
		return true;
	}

	/**
	 * get an HME font specification based on an HTMLStyleChunk and the current
	 * theme's font translations
	 * 
	 * @param styleChunk
	 * @param fontSizePercent
	 * @return
	 */
	public String getFontString(HTMLStyleChunk styleChunk, float fontSizePercent) {
		String fontFamily = getValidFontName(styleChunk);

		String style = null;
		if(styleChunk.isBold && styleChunk.isItalic) {
			style = "bolditalic";
		} else if(styleChunk.isBold) {
			style = "bold";
		} else if(styleChunk.isItalic) {
			style = "italic";
		}
		int size = styleChunk.fontSize;
//		System font shows up a little larger than default font.
		if(fontFamily.equals("system") && size > 3) {
			size -= 3;
		}
		if(style != null) {
			return fontFamily+"-"+(int)(size*fontSizePercent)+"-"+style+".font";
		} else {
			return fontFamily+"-"+(int)(size*fontSizePercent)+".font";
		}
	}

	private HashMap<String, Resource> urlFonts = new HashMap<String, Resource>();
	private String getValidFontName(HTMLStyleChunk styleChunk) {
		String fontFamily1 = String.valueOf(styleChunk.font).toLowerCase();
		//TODO handle quotes
//		debugOut("FONT-FAMILY:"+fontFamily1);
		String translated;
		translated = theme.getFontTranslation(fontFamily1);
		if (translated == null) {
			// default translation
			//TODO "arial" is common.
			//TODO "inherit"
			String sans = "default";
			String mono = "system";
			String cursive = "default";
			String fantasy = "system";
			String serif = "default";
			if (fontFamily1 == null)
				translated = serif;
			else if (fontFamily1.equals("sans-serif"))
				translated = sans;
			else if(fontFamily1.equals("monospace"))
				translated = mono;
			else if(fontFamily1.equals("cursive")) 
				translated = cursive;
			else if(fontFamily1.equals("fantasy"))
				translated = fantasy;
			else if(fontFamily1.equals("serif"))
				translated = serif;
			else if(fontFamily1.equals("system"))
				translated = "system";
			else
				translated = serif;
		}
		String fontFamily = translated;
		
		// can have a URL font, but using it as a font string will just result in a streamresource, not a font.
		int slashes = fontFamily.indexOf("://");
		if (slashes > 0) {
			String resourceName = null;
			synchronized (urlFonts) {
				Resource tt = urlFonts.get(fontFamily);
				if(tt == null) {
					if (fontFamily.endsWith(".ttf")) {
						tt = createTrueType(fontFamily);
					} else {
						tt = createTrueType(fontFamily+".ttf");
					}
					// we have to store the actual resource, or GC will tell TiVo to remove it.
					urlFonts.put(fontFamily, tt);
				}
				// we can only access this cached resource by its id
				resourceName = String.valueOf(tt.getID());
			}
			fontFamily = resourceName;
		}
		return fontFamily;
	}

	public void advanceAudio() {
		if(this.audioHandler!=null) {
			this.audioHandler.skip();
		}
	}

	public void pauseAudio() {
		if(this.audioHandler!=null) {
			this.audioHandler.pause();
		}
	}

	public void closeAudio() {
		if(this.audioHandler!=null) {
			this.audioHandler.close();
		}
	}

	private VideoHandlerView videoHandler;

	public void zoomPIP() {
		if (this.videoHandler != null) {
			this.videoHandler.setPip(! this.videoHandler.isPip());
		}
	}

	public void pausePIP() {
		if (this.videoHandler != null) {
			this.videoHandler.pause();
		}
	}

	/**
	 * Show a video by launching this HME app specification
	 * @param PIP 
	 * @param originURL 
	 * @return true if launch worked.
	 */
	boolean playStreamVideoApp(String hmeURL, Map hmeMap, boolean PIP, String originURL) {
		this.lastMediaURL = originURL;
		if(this.audioHandler != null) {
			this.audioHandler.close();
		}
		if(this.videoHandler == null) {
			this.videoHandler = new VideoHandlerView(this, PIP, true);
		}
		//FIXME don't do PIP if this is SD mode, and prevent going PIP on exit/zoom of FS
		this.videoHandler.setPip(PIP);
		this.videoHandler.startAppVideo(hmeURL, hmeMap, PIP);
		
		return true;
	}

	/**
	 * Show a video by launching the videoplayer with these details.
	 * @param PIP 
	 * @return true if launch worked.
	 */
	public boolean playStreamVideo(URL videoURL, String contentType, boolean PIP, String title, String subtitle, String description, int duration) {
		String videoUrl = videoURL.toString();
		try {
			if (title == null) {
				title = videoURL.getFile();
				int lastslash = title.lastIndexOf("/");
				if(lastslash >= 0 && lastslash < (title.length()-1)) {
					title = title.substring(lastslash + 1);
				}
				if (subtitle == null) {
					subtitle = videoURL.getHost();
				}
			} else if (subtitle == null) {
				subtitle = "";
			}
			if (description == null) {
				description = "\n"+videoURL.toString();
			}
			String durationString = ""; //$NON-NLS-1$
			if (duration > 0) {
				durationString = "&duration=" + duration; //$NON-NLS-1$
			}
	
			URL url = new URL("hme://204.176.49.116:7288/videoplayer?" //$NON-NLS-1$
					+ "title="+title //$NON-NLS-1$
					+ "&" //$NON-NLS-1$
					+ "subtitle="+subtitle //$NON-NLS-1$
					+ "&" //$NON-NLS-1$
					+ "description="+description //$NON-NLS-1$
					+ "&" //$NON-NLS-1$
					+ "uri="+URLEncoder.encode(videoUrl, "UTF-8") //$NON-NLS-1$ //$NON-NLS-2$
					+ durationString
					);
			return this.playStreamVideoApp(getHmeURL(url), getHmeMap(url), PIP, videoUrl);
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MalformedURLException e) {
			// FIXME Auto-generated catch block
			e.printStackTrace();
		}
		
		return false;
	}

	public Rectangle getWebTitleArea() {
		Rectangle renderArea = getWebRenderArea();
		if (this.isMaximized()) {
			return new Rectangle((int) renderArea.getX(), 0,
					(int) renderArea.getWidth(), this.getSafeActionVertical());
		} else {
			return new Rectangle((int) renderArea.getX(),
					getSafeActionVertical(), (int) renderArea.getWidth(),
					getSafeTitleVertical() - getSafeActionVertical());
		}
	}
	
	public Rectangle getWebStatusArea() {
		Rectangle renderArea = getWebRenderArea();
		if (isMaximized()) {
			return new Rectangle((int) renderArea.getX(), this.getHeight()
					- (getSafeActionVertical()), (int) renderArea.getWidth(),
					getSafeActionVertical());
		} else {
			return new Rectangle((int) renderArea.getX(), this.getHeight()
					- (getSafeTitleVertical()), (int) renderArea.getWidth(),
					getSafeTitleVertical() - getSafeActionVertical());
		}
	}
	
	public Rectangle getWebRenderArea() {
		WebBrowserApp wba = this;
		int renderAreaHInset;
		int scrollbarHInset;
		int scrollbarWidth = getWebScrollbarWidth();
		
		if(wba.isMaximized()) {
			// maximized = horizontal only leaves room for scrollbar, vertical
			// statuses go against edge
			renderAreaHInset = wba.getSafeActionHorizontal()/2;
			scrollbarHInset = Math.max(0,renderAreaHInset + scrollbarWidth);
			return new Rectangle(
					renderAreaHInset, wba.getSafeActionVertical(), 
					this.getWidth() - renderAreaHInset - scrollbarHInset,
					this.getHeight() - wba.getSafeActionVertical() * 2);
		} else {
			renderAreaHInset = wba.getSafeTitleHorizontal();
			scrollbarHInset = Math.max(0,renderAreaHInset + scrollbarWidth);
			return new Rectangle(
					renderAreaHInset, wba.getSafeTitleVertical(), 
					this.getWidth() - renderAreaHInset - scrollbarHInset,
					this.getHeight() - wba.getSafeTitleVertical() * 2);
		}
	}

	public int getWebScrollbarWidth() {
		WebBrowserApp wba = this;
		int min = 20;
		try {
			min = wba.getSkin().get(H_PAGEDOWN).getWidth();
		} catch(Exception e) {}
		int scrollbarWidth = min*2;
		int max = 100;
		try {
			max = wba.getSkin().get("scroll_bar").getWidth();
		} catch(Exception e) {}
		max = Math.min(wba.getSafeActionHorizontal(), max);
		scrollbarWidth = Math.min(max, scrollbarWidth);
		scrollbarWidth = Math.max(min, scrollbarWidth);
		return scrollbarWidth;
	}

}
