package com.blackledge.david.html.hme;

import java.awt.Color;
import java.awt.Rectangle;
import java.text.MessageFormat;
import java.util.ArrayList;

import com.blackledge.david.html.hme.WebBrowserApp.MEDIA;
import com.blackledge.david.html.hme.WebBrowserApp.MOBILE;
import com.blackledge.david.tivo.V49IHmeProtocol;
import com.blackledge.david.tivo.widgets.ActionButton;

import com.tivo.hme.bananas.BApplication;
import com.tivo.hme.bananas.BEvent;
import com.tivo.hme.bananas.BHighlight;
import com.tivo.hme.bananas.BScreen;
import com.tivo.hme.bananas.BSkin;
import com.tivo.hme.bananas.BSkin.Element;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.sdk.StreamResource;
import com.tivo.hme.sdk.View;

public class WebMenuScreen extends BScreen implements VideoBackgroundScreen {

	public static final String MENU_PREFIX = "menu_"; //$NON-NLS-1$
	public static final String MENU_FONT_PREFIX = MENU_PREFIX + "font"; //$NON-NLS-1$
	public static final String MENU_STYLE_PREFIX = MENU_PREFIX+"style_"; //$NON-NLS-1$
	public static final String MENU_MODE_PREFIX = MENU_PREFIX+"mode_"; //$NON-NLS-1$
	public static final String MENU_PIP = MENU_PREFIX + "pip"; //$NON-NLS-1$
	public static final String MENU_NO_PIP = MENU_PREFIX + "no_pip"; //$NON-NLS-1$
	public static final String MENU_PIP_MEDIA = MENU_PREFIX + "pip_media"; //$NON-NLS-1$
	public static final String MENU_TABLES = MENU_PREFIX + "tables"; //$NON-NLS-1$
	public static final String MENU_MOBILE = MENU_PREFIX + "mobile"; //$NON-NLS-1$
	public static final String MENU_MAXIMIZE = MENU_PREFIX + "maximize"; //$NON-NLS-1$
	public static final String MENU_LEFT_BACK = MENU_PREFIX + "left_back"; //$NON-NLS-1$
	public static final String MENU_LINK_THUMBTACK = MENU_PREFIX + "link_thumbtack"; //$NON-NLS-1$
	public static final String MENU_BRIGHTNESS = MENU_PREFIX + "brightness"; //$NON-NLS-1$
	public static final String MENU_EDIT_LINK = MENU_PREFIX + "edit_bookmark"; //$NON-NLS-1$
	private WebScreen webScreen;
//	private BView linkLabel;
	private BView brightnessCheck;
	private BView mobileCheck;
	private BView tableCheck;
	private BView[] fontCheck = new BView[9];
	private FormSelect style_select;
	private ActionButton linkButton;
	private BView pipNoneCheck;
	private BView pipCheck;
	private BView pipCustomCheck;
	private int y;
	private BView buttonArea;
	private BView header;
	private BView icon;
	private BView maximizeCheck;
	private BView leftBackCheck;
	private static final int CLEAR_COOKIES_CLICKS = 3;
	private int clearClicked = 0;
	private String media;
	private java.util.LinkedHashMap<String, String> style_select_list;
	private FormSelect mode_select;
	private java.util.LinkedHashMap<String, String> mode_select_list;
	private String buttonFont;

	public WebMenuScreen(WebScreen webScreen, String media) {
		this(webScreen.getBApp(), media);
		
		this.webScreen = webScreen;
		
		BView firstView = null;
		int rowpadding = 15;
//		int labelGap = 7;
		int x = 0;
		ActionButton button;
//		BView label;
		Element skinBar = webScreen.getBApp().getSkin().get(BSkin.H_BAR);
		int minButtonWidth = skinBar.getInt("padh", 10)*2+skinBar.getInt("cap", 30); //$NON-NLS-1$ //$NON-NLS-2$
		int buttonWidth = buttonArea.getWidth()/3;
		buttonWidth = Math.max(minButtonWidth, buttonWidth);
		int buttonHeight = 24;
		buttonHeight = webScreen.getBApp().getSkin().get(BSkin.H_BAR).getHeight();
		buttonFont = "default-15.font"; //$NON-NLS-1$
		buttonFont = "default-"+skinBar.getHeight()/3+".font"; //$NON-NLS-1$ //$NON-NLS-2$
		rowpadding = 0;
		
		y+=rowpadding;
//		label = makeLabel(buttonArea, x, y,"Web pages too bright for TV?");
//		y += label.getHeight();
//		y+= labelGap;
		button = new ActionButton(buttonArea, x, y, buttonWidth, buttonHeight, MENU_BRIGHTNESS);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "cancel", null, "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		brightnessCheck = newCheckView(button);
		firstView = button;

		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.Dimmer"))); //$NON-NLS-1$
		y += button.getHeight();
		y+=rowpadding;
		
		//move this to top
		y=0;
		button = new ActionButton(buttonArea, x, y, buttonArea.getWidth(), buttonHeight, MENU_LINK_THUMBTACK);
		button.setBarAndArrows(BAR_DEFAULT, BAR_HANG, "cancel", null, null, "down", false); //$NON-NLS-1$ //$NON-NLS-2$
		// content of this button will be left-aligned, so move it to the right as needed.
		button.setTranslation(skinBar.getInt("padh", 10), 0); //$NON-NLS-1$
		linkButton = button;
		linkButton.setResource(createText("default-12.font", Color.white, BookmarkScreen.BOOKMARK_NAME+" link:")); //$NON-NLS-1$ //$NON-NLS-2$
		y += button.getHeight();
//		y+= labelGap;
//		label = makeLabel(buttonArea, x, y, "(none)");
//		linkLabel = label;
//		y += label.getHeight();
		y+=rowpadding;
		
		this.setFocusDefault(firstView);
	}

	public WebMenuScreen(BApplication bApp, String media) {
		/* BEGIN HME 1.4.1e only */
		super(bApp, bApp.getReceiverResolutionInfo().getPreferredRenderingResolution());
		/* END HME 1.4.1e only */
		WebBrowserApp wba = (WebBrowserApp) bApp;
		this.media = media;
		Rectangle titleRegion = wba.getTitleRegion();
		BView headerArea = new BView(getNormal(), titleRegion.x, titleRegion.y, titleRegion.width, titleRegion.height);
		headerArea.setResource(headerArea.createText("default-30.font", Color.yellow, Messages.getString("WebMenuScreen.Title")), RSRC_VALIGN_TOP | RSRC_HALIGN_CENTER); //$NON-NLS-1$ //$NON-NLS-2$
		int titleHeight = 30;
		header = new BView(headerArea, 0, titleHeight, headerArea.getWidth(), headerArea.getHeight()-titleHeight);
//		wba.getLogoRegion(); - instead, take a little larger area allowing for odd icon shapes to cover logo
		icon = new BView(getNormal(), getSafeActionHorizontal(), getSafeTitleVertical(),
				wba.getSafeLogoToScrollTitle()+getSafeTitleHorizontal()-getSafeActionHorizontal(), wba.getSafeTitleToScrollTop());
		
		BView firstView = null;
		int textTitleHeight = 25;
		BView text = new BView(getNormal(), getSafeActionHorizontal(), 
				getSafeTitleVertical() + wba.getSafeTitleToScrollTop(),
				180,
				getNormal().getHeight() - getSafeTitleVertical() * 2
						- wba.getSafeTitleToScrollTop()
						- wba.getSafeTitleToScrollBottom()
						- textTitleHeight
						);
		int defaultTextZoom = wba.getSavedFontKey();
		WebScreen.setLeftHints(text, null, null, null, Color.yellow);

		// put the keyboard hint next to the last main hint
		int keyboardX = text.getX()-text.getWidth();
		try {
			keyboardX = keyboardX + text.getChild(text.getChildCount()-1).getX();
		} catch(Exception e) {
		}
		BView keyboardHint = new BView((BView) text.getParent(), keyboardX, text.getY(), text.getWidth(), 
				text.getHeight());
		
		WebScreen.setLeftHints(null, null, null, keyboardHint, Color.white);

		// add a title.
		new BView((BView) text, 0, -textTitleHeight, text.getWidth(), 
				textTitleHeight).setResource(
						text.createText("system-10-italic.font", Color.yellow, Messages.getString("WebMenuScreen.CONTROL_HINT_TITLE")), //$NON-NLS-1$ //$NON-NLS-2$
						RSRC_HALIGN_RIGHT | RSRC_VALIGN_TOP | RSRC_TEXT_WRAP);
		text.setBounds(text.getX(),  text.getY(), text.getWidth(), text.getHeight()+textTitleHeight);
		text.setTranslation(0, textTitleHeight);
		
		// add a title.
		new BView((BView) keyboardHint, 0, -textTitleHeight, keyboardHint.getWidth(), 
				textTitleHeight).setResource(
						keyboardHint.createText("system-10-italic.font", Color.white, Messages.getString("WebScreen.CONTROL_HINT_TITLE_TEXT")), //$NON-NLS-1$ //$NON-NLS-2$
						RSRC_HALIGN_RIGHT | RSRC_VALIGN_TOP | RSRC_TEXT_WRAP);
		keyboardHint.setBounds(keyboardHint.getX(), keyboardHint.getY(), keyboardHint.getWidth(), keyboardHint.getHeight()+textTitleHeight);
		keyboardHint.setTranslation(0, textTitleHeight);

		buttonArea = new BView(getNormal(), text.getX()+text.getWidth(),
				getSafeTitleVertical()
						+ wba.getSafeTitleToScrollTop(),
				(getNormal().getWidth() - getSafeActionHorizontal() * 2)-text.getWidth(),
				getNormal().getHeight() - getSafeActionVertical() * 2
						- wba.getSafeTitleToScrollTop()
						- wba.getSafeTitleToScrollBottom());
		y = 0;
		int rowpadding = 15;
		int labelGap = 10;
		int x = 0;
		ActionButton button;
		BView label;
		int buttonWidth = buttonArea.getWidth()/3;
		Element skinBar = wba.getSkin().get(BSkin.H_BAR);
		int minButtonWidth = skinBar.getInt("padh", 10)*2+skinBar.getInt("cap", 30); //$NON-NLS-1$ //$NON-NLS-2$
		buttonWidth = Math.max(minButtonWidth, buttonWidth);
		int buttonHeight = 24;
		buttonHeight = skinBar.getHeight();
		buttonFont = "default-15.font"; //$NON-NLS-1$
		buttonFont = "default-"+skinBar.getHeight()/3+".font"; //$NON-NLS-1$ //$NON-NLS-2$
		String buttonFontEmphasized = "default-"+(skinBar.getHeight()/3+1)+"-bolditalic.font"; //$NON-NLS-1$ //$NON-NLS-2$
		int selectHeight = buttonHeight*1/2;
		rowpadding = 0;
		labelGap = 2;
		y = rowpadding+buttonHeight; // make room for one row above everything here (the "current link" row)
		
		label = makeLabel(buttonArea, x, y, MessageFormat.format(Messages.getString("WebMenuScreen.text_zoom_label"),defaultTextZoom)); //$NON-NLS-1$
		int numButtonWidth =  Math.max(minButtonWidth, 45);
		y += label.getHeight();
		y+= labelGap;
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+1);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "cancel", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.1"))); //$NON-NLS-1$
		fontCheck[0] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+2);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.2"))); //$NON-NLS-1$
		fontCheck[1] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+3);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.3"))); //$NON-NLS-1$
		fontCheck[2] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+4);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.4"))); //$NON-NLS-1$
		fontCheck[3] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+5);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFontEmphasized, Color.white, Messages.getString("WebMenuScreen.5"))); //$NON-NLS-1$
		fontCheck[4] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+6);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.6"))); //$NON-NLS-1$
		fontCheck[5] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+7);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.7"))); //$NON-NLS-1$
		fontCheck[6] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+8);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.8"))); //$NON-NLS-1$
		fontCheck[7] = newCheckView(button);
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, numButtonWidth, buttonHeight, MENU_FONT_PREFIX+9);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", null, "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.9"))); //$NON-NLS-1$
		fontCheck[8] = newCheckView(button);
		x = 0;
		y += button.getHeight();
		y+=rowpadding;
//		label = makeLabel(buttonArea, x, y, "Ask for mobile versions of pages");
//		y += label.getHeight();
//		y+= labelGap;
		button = new ActionButton(buttonArea, x, y, buttonWidth, buttonHeight, MENU_MOBILE);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "cancel", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.Mobile_Mode"))); //$NON-NLS-1$
		mobileCheck = newCheckView(button);
		firstView = button;
		x += button.getWidth();
		
		mode_select = new FormSelect(null, "mode", buttonArea, x, y, Math.max(minButtonWidth, 90), selectHeight);//$NON-NLS-1$
		mode_select.setAction(MENU_MODE_PREFIX);
		mode_select_list = new java.util.LinkedHashMap<String, String>();
		for(MOBILE mode : MOBILE.values()) {
			String action = MENU_MODE_PREFIX+mode.name().toLowerCase();
			mode_select_list.put(action, mode.name());//$NON-NLS-1$
		}
		ArrayList<Integer> selectedModeIndices = new ArrayList<Integer>();
		mode_select.updateSelect(mode_select_list, selectedModeIndices, Color.white, buttonFont);
		x += mode_select.getWidth();
		
		style_select = new FormSelect(null, "style", buttonArea, x, y, Math.max(minButtonWidth, 90), selectHeight);//$NON-NLS-1$
		style_select.setAction(MENU_STYLE_PREFIX);
		style_select_list = new java.util.LinkedHashMap<String, String>();
		for(MEDIA mode : MEDIA.values()) {
			String action = MENU_STYLE_PREFIX+mode.name().toLowerCase();
			style_select_list.put(action, mode.name().toLowerCase());
		}
		ArrayList<Integer> selectedIndices = new ArrayList<Integer>();
		style_select.updateSelect(style_select_list, selectedIndices, Color.white, buttonFont);
		x += style_select.getWidth();
		
		x=0;
		y += button.getHeight();
		y+=rowpadding;
//		label = makeLabel(buttonArea, x, y, "Not laying out right? Try flattening tables");
//		y += label.getHeight();
//		y+= labelGap;
		button = new ActionButton(buttonArea, x, y, buttonWidth, buttonHeight, MENU_MAXIMIZE);
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.Maximize_Mode"))); //$NON-NLS-1$
		maximizeCheck = newCheckView(button);		
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "cancel", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, buttonWidth, buttonHeight, MENU_TABLES);
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.Table_Layout_Mode"))); //$NON-NLS-1$
		tableCheck = newCheckView(button);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, buttonWidth, buttonHeight, MENU_LEFT_BACK);
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.Left_Is_Back"))); //$NON-NLS-1$
		leftBackCheck = newCheckView(button);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", null, "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		x = 0;
		y += button.getHeight();
		
		y += rowpadding;
		label = makeLabel(buttonArea, x, y, MessageFormat.format(Messages.getString("WebMenuScreen.clear_cookies_label"),CLEAR_COOKIES_CLICKS)); //$NON-NLS-1$
		y+= labelGap;
		x = 0;
		
		y += label.getHeight();
		y+=rowpadding;
		button = new ActionButton(buttonArea, x, y, buttonWidth, buttonHeight, MENU_NO_PIP);
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.No_PIP_Mode"))); //$NON-NLS-1$
		pipNoneCheck = newCheckView(button);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "cancel", "right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		x += button.getWidth();
		button = new ActionButton(buttonArea, x, y, buttonWidth, buttonHeight, MENU_PIP);
		button.setResource(createText(buttonFont, Color.white, Messages.getString("WebMenuScreen.Live_TV_PIP_Mode"))); //$NON-NLS-1$
		pipCheck = newCheckView(button);
		button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", this.media==null?null:"right", "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		x += button.getWidth();
		WebBrowserApp app = (WebBrowserApp) getBApp();
		if (this.media != null) {
			String mediaType = "Media";
			if (app.isStreamTypeAudio()) {
				mediaType = "Audio";
			} else if (app.isStreamTypeVideo()) {
				mediaType = "Video";
			}
			button = new ActionButton(buttonArea, x, y, buttonWidth, buttonHeight, MENU_PIP_MEDIA);
			button.setResource(createText(buttonFont, Color.white, 
					MessageFormat.format(Messages.getString("WebMenuScreen.Custom_PIP_Mode"),mediaType,this.media)), //$NON-NLS-1$
					RSRC_HALIGN_LEFT|RSRC_VALIGN_CENTER); 
			pipCustomCheck = newCheckView(button);
			button.setBarAndArrows(BAR_DEFAULT, BAR_DEFAULT, "left", null, "up", "down", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		}
		x = 0;
		y += button.getHeight();
		// show the saved stream if it's different from available-to-select (pipCustomCheck) stream
		if (app.getStartupStreamCustomURL() != null && !app.getStartupStreamCustomURL().equals(this.media)) {
			label = makeLabel(buttonArea, x, y, MessageFormat.format(Messages.getString("WebMenuScreen.Custom_PIP"),app.getStartupStreamCustomURL())); //$NON-NLS-1$
			y += label.getHeight();
		}
		
		this.setFocusDefault(firstView);
	}

	private BView makeLabel(BView buttonArea, int x, int y, String text) {
		BView label;
		label = new BView(buttonArea, x, y, buttonArea.getWidth(), 15);
		label.setResource(createText("default-15-bolditalic.font", Color.cyan, text), RSRC_HALIGN_LEFT | RSRC_VALIGN_BOTTOM); //$NON-NLS-1$
		return label;
	}
	
	private BView newCheckView(ActionButton button) {
		int wid = button.getHeight()/2;
		int hei = wid;
		int padh = getBApp().getSkin().get(H_BAR).getInt("padh", 10); //$NON-NLS-1$
		int padding = padh/2;
		//TODO getting lazy here... uncheck is just always shown, hidden by the check
		String uncheck = ((WebBrowserApp)getBApp()).getTheme().getPrefUnchecked();
		BView unview = null;
		if(uncheck != null) {
			unview  = new BView(button, button.getWidth()-wid-padding, button.getHeight()/2-hei/2, wid+padding, hei);
		}
		BView view = new BView(button, button.getWidth()-wid-padding, button.getHeight()/2-hei/2, wid+padding, hei);
		view.setTranslation(-padding, 0);
		String check = ((WebBrowserApp)getBApp()).getTheme().getPrefChecked();
		if (check == null) {
			view.setResource(createText("system-30-bold.font",Color.green, "*"), RSRC_HALIGN_RIGHT | RSRC_VALIGN_CENTER); //$NON-NLS-1$ //$NON-NLS-2$
		} else {
			view.setResource(check, RSRC_HALIGN_RIGHT | RSRC_VALIGN_CENTER | RSRC_IMAGE_BESTFIT);
		}
		if (uncheck != null && unview != null) {
			unview.setResource(uncheck, RSRC_HALIGN_RIGHT | RSRC_VALIGN_CENTER | RSRC_IMAGE_BESTFIT);
		}
		return view;
	}
	
	@Override
	public boolean handleKeyPress(int code, long rawcode) {
		switch(code) {
		case KEY_INFO:
		case V49IHmeProtocol.KEY_OPT_ACTION_B:
			getBApp().pop();
			return true;
		case KEY_THUMBSDOWN:
			++clearClicked;
			if (clearClicked >= CLEAR_COOKIES_CLICKS) {
				((WebBrowserApp) getBApp()).clearCookies();
				getBApp().play(WebBrowserApp.SOUND_ALERT);
				getBApp().pop();
			} else {
				getBApp().play(WebBrowserApp.SOUND_THUMBSDOWN);
			}
			return true;
		case KEY_NUM1:
		case KEY_NUM2:
		case KEY_NUM3:
		case KEY_NUM4:
		case KEY_NUM5:
		case KEY_NUM6:
		case KEY_NUM7:
		case KEY_NUM8:
		case KEY_NUM9:
			int num = code - KEY_NUM0;
			postEvent(new BEvent.Action(fontCheck[num-1], MENU_FONT_PREFIX+num));
			break;
		case KEY_NUM0:
			int defaultTextSize = ((WebBrowserApp)getBApp()).getSavedFontKey();
			postEvent(new BEvent.Action(fontCheck[4], MENU_FONT_PREFIX+defaultTextSize));
			break;
		case KEY_CHANNELDOWN:
			//FIXME focus on bottom control
		case KEY_CHANNELUP:
			//FIXME focus on top control
		case KEY_ADVANCE:
			//FIXME focus on bottom, else top control
		}
		return super.handleKeyPress(code, rawcode);
	}
	
	@Override
	public boolean handleKeyRepeat(int code, long rawcode) {
		// support keyrepeat for navigation (handled by individual focusable elements)
		if(getFocus() != null) {
			switch (code) {
			case KEY_LEFT:
			case KEY_RIGHT:
			case KEY_UP:
			case KEY_DOWN:
				return getFocus().handleKeyPress(code, rawcode);
			}
		}
		return super.handleKeyRepeat(code, rawcode);
	}
	
	public void showBackground() {
//		if(((WebBrowserApp)getBApp()).isStreamTypeVideo()) {
			Object resource = new Color(0, 0, 80);
			try {
				resource = getBApp().getSkin().get("setup").getResource();
			} catch (Exception e) {}
			getBelow().setResource(resource, RSRC_IMAGE_BESTFIT);
//		} else {
//			StreamResource videoLoop = createStream(WebBrowserApp.STREAM_LOOP_BLUE_SETUP, "video/mpeg", true); //$NON-NLS-1$
//			getBelow().setResource(videoLoop);
//			flush();
//		}
	}
	public void disposeBackground() {
		if(getBelow().getResource() != null && getBelow().getResource() instanceof StreamResource 
				&& ((StreamResource)getBelow().getResource()).getURI().equals(WebBrowserApp.STREAM_LOOP_BLUE_SETUP)) {
			getBelow().getResource().remove();
			getBelow().clearResource();
			flush();
		}
	}

	@Override
	public boolean handleEnter(Object arg, boolean isReturn) {
		showBackground();
		String headerText = 
				WebBrowserApp.BROWSER_NAME;
		if(webScreen != null) {
			headerText = 
					webScreen.getTitle()+"\n"+ //$NON-NLS-1$
					webScreen.getURL();
			icon.setResource(webScreen.getIconURL(), RSRC_HALIGN_RIGHT | RSRC_VALIGN_BOTTOM | RSRC_IMAGE_BESTFIT);
		}
		header.setResource(header.createText("system-15-italic.font", Color.white, headerText), RSRC_HALIGN_LEFT | RSRC_VALIGN_TOP); //$NON-NLS-1$
		
		WebBrowserApp web = ((WebBrowserApp)getBApp());
		if(tableCheck != null)
		tableCheck.setVisible(web.isLayingOutTables());
		if(maximizeCheck != null)
		maximizeCheck.setVisible(web.isMaximized());
		if(mobileCheck != null)
		mobileCheck.setVisible( web.isAppearingMobile());
		if(style_select != null) {
			for(int i = 0 ; i < MEDIA.values().length ; ++i) {
				if(web.isMediaStyleActive(MEDIA.values()[i]))
					style_select.selectedIndices.add(new Integer(i));
				else
					style_select.selectedIndices.remove(new Integer(i));
			}
			style_select.updateSelect(style_select_list, style_select.selectedIndices, Color.white, buttonFont);
		}
		
		if(mode_select != null) {
			for(int i = 0 ; i < MOBILE.values().length ; ++i) {
				if(web.isMobileTypeActive(MOBILE.values()[i]))
					mode_select.selectedIndices.add(new Integer(i));
				else
					mode_select.selectedIndices.remove(new Integer(i));
			}
			mode_select.updateSelect(mode_select_list, mode_select.selectedIndices, Color.white, buttonFont);
			
			if(!web.isAppearingMobile()) {
				mode_select.setTransparency(0.7f);
				mode_select.setFocusable(false);
			}
		}
		
		if(pipNoneCheck != null)
		pipNoneCheck.setVisible( !web.isStartupStreamLiveTV() && web.getStartupStreamCustomURL() == null );
		if(pipCheck != null)
		pipCheck.setVisible( web.isStartupStreamLiveTV() );
		if(pipCustomCheck != null)
		pipCustomCheck.setVisible( web.getStartupStreamCustomURL() != null && web.getStartupStreamCustomURL().equals(this.media));
		if(leftBackCheck != null)
		leftBackCheck.setVisible( web.isLeftSameAsBack());
		if(brightnessCheck != null)
		brightnessCheck.setVisible(web.isShaded());
		for(int i = 0 ; i < fontCheck.length ; ++i) {
			if(fontCheck[i]!=null)
			fontCheck[i].setVisible(false);
		}
		int fontIndex = web.getFontScaleKey()-1;
		if(fontIndex < fontCheck.length && fontIndex >= 0) {
			if(fontCheck[fontIndex]!=null)
			fontCheck[fontIndex].setVisible(true);
		}
		
		// update bookmark information if we are not a webscreen menu and got a bookmark in arg
		if(webScreen == null && arg != null) {
			// create the bookmark edit button if it doesn't exist yet.
			if(linkButton == null) {
				int buttonHeight = 24;
				Element skinBar = getBApp().getSkin().get(BSkin.H_BAR);
				buttonHeight = skinBar.getHeight();
				//move this to top
				int x=0;
				int y=0;
				ActionButton button = new ActionButton(buttonArea, x, y, buttonArea.getWidth(), buttonHeight, MENU_EDIT_LINK);
				button.setBarAndArrows(BAR_DEFAULT, BAR_HANG, "cancel", MENU_EDIT_LINK, null, "down", false); //$NON-NLS-1$ //$NON-NLS-2$
				// content of this button will be left-aligned, so move it to the right as needed.
				button.setTranslation(skinBar.getInt("padh", 10), 0); //$NON-NLS-1$
				linkButton = button;
			}
			String text = String.valueOf(arg);
			// hide link controls if there isn't a valid current one.
			setLinkButtonText(text, Messages.getString("WebMenuScreen.Edit_Link"), Color.yellow);
			if (!isReturn && text != null) {
				setFocus(linkButton);
				return true;
			}
		}
		// hide bookmark link button if there is no arg
		if(webScreen == null && linkButton != null && arg == null) {
			linkButton.setVisible(false);
			linkButton.getHighlights().setVisible(BHighlight.H_BAR, BHighlight.H_VIS_FALSE);
		}
		
		// update webscreen information if we're a webscreen menu
		if(webScreen != null && linkButton != null 
//				&& linkLabel != null
				) {
			String text = webScreen.getFocusedLinkText();
			// hide link controls if there isn't a valid current one.
			setLinkButtonText(text, Messages.getString("WebMenuScreen.Save_Link"), Color.white);
			if (!isReturn && text != null) {
				setFocus(linkButton);
				return true;
			}
		}
		// super implementation focuses on focusDefault
		return super.handleEnter(arg, isReturn);
	}

	private void setLinkButtonText(String text, String message,
			Color color) {
		Element skinBar = getBApp().getSkin().get(BSkin.H_BAR);
//		linkLabel.setVisible(text!=null);
		linkButton.setVisible(text!=null);
		linkButton.getHighlights().setVisible(BHighlight.H_BAR, text!=null?BHighlight.H_VIS_TRUE:BHighlight.H_VIS_FALSE);
//		URL url = webScreen.getFocusedLinkURL(null);
//		if(text!= null && text.equals(url.toString())) {
//			text = text+" ("+url+")";
//		}
		if(text != null) {
			if(linkButton.getResource() != null)
				linkButton.getResource().remove();
			String linkButtonFont = "default-"+skinBar.getHeight()/3+".font"; //$NON-NLS-1$ //$NON-NLS-2$
			linkButton.setResource(createText(linkButtonFont, color,
					MessageFormat.format(message, BookmarkScreen.BOOKMARK_NAME, text)),     //$NON-NLS-1$
					RSRC_HALIGN_LEFT | RSRC_VALIGN_CENTER);
//			linkLabel.setResource(createText("default-20-bolditalic.font", Color.yellow, text), RSRC_HALIGN_LEFT |RSRC_VALIGN_CENTER);
		}
	}
	
	@Override
	public boolean handleExit() {
		disposeBackground();
		removeTextResources(this);
		return super.handleExit();
	}
	
	private void removeTextResources(WebMenuScreen webMenuScreen) {
		removeAllChildren(webMenuScreen.getNormal());
	}
	private void removeAllChildren(View parent) {
		// collect the views before removing them, otherwise the getChild call
		// gets thrown by the remove calls.
		ArrayList<View> children = new ArrayList<View>();
		for(int i = 0 ; i < parent.getChildCount() ; ++i) {
			 children.add( parent.getChild(i));
		}
		
		for(View child : children) {
			removeAllChildren(child);
			if(child.getResource() != null) {
				if(child.getResource().getClass().getName().contains("Text")) { //$NON-NLS-1$
					child.getResource().remove();
				}
			}
			child.clearResource(); // resource's own finalize will remove itself from tivo
			// make sure focus gets cleared if the one we're removing has it.
			if(child.hasFocus()) {
				this.setFocus(null);
			}
			child.remove();
		}
	}
	
	@Override
	public boolean handleAction(BView view, Object action) {
		if( super.handleAction(view, action)) {
			return true;
		} else if (action.equals(H_UP) || action.equals(H_DOWN)
				|| action.equals(H_LEFT) || action.equals(H_RIGHT)) {
			// if super didn't handle it, it couldn't find a match.
			return false;
		} else if (action.equals("cancel")) { //$NON-NLS-1$
			getBApp().pop();
			return true;
		} else if (action.equals(MENU_STYLE_PREFIX)) {
			if(style_select.selectedIndices.size() == 1) {
				String style_action = (String) style_select_list.keySet()
						.toArray()[style_select.selectedIndices.get(0)];
				getBApp().pop(style_action);
				return true;
			} else {
				return false;
			}
		} else if (action.equals(MENU_MODE_PREFIX)) {
			if(mode_select.selectedIndices.size() == 1) {
				String mode_action = (String) mode_select_list.keySet()
						.toArray()[mode_select.selectedIndices.get(0)];
				getBApp().pop(mode_action);
				return true;
			} else {
				return false;
			}
		} else {
			getBApp().pop(action);
			return true;
		}
	}

}
