package com.blackledge.david.html.hme;

import java.net.URL;
import java.util.List;
import java.util.Map;

public class WebProxy {

	public static final String URI_PREFIX = "webproxy/";
	
	public URL original;
	public URL referer;
	public Map<String, List<String>> headers;
	public String contentType;
	public boolean forceProxy;

	private String proxyUri;
	
	public WebProxy(URL original, URL referer, Map<String, List<String>> headers, String contentType, boolean forceProxy) {
		this.original = original;
		this.referer = referer;
		this.headers = headers;
		this.contentType = contentType;
		this.forceProxy = forceProxy;
		
		this.proxyUri = createProxyUri(original);
	}

	private String createProxyUri(URL original) {
		String originalSuffix = original.getPath();
		int lastSlash = originalSuffix.lastIndexOf("/");
		if (lastSlash > 0) {
			originalSuffix = originalSuffix.substring(lastSlash + 1);
		}
		String random = String.valueOf(Math.random());
		return URI_PREFIX + random + "/" + originalSuffix;
	}
	
	public String getProxyUri() {
		return proxyUri;
	}

	public static boolean isStreamProxyUri(String uri) {
		return uri.indexOf( WebProxy.URI_PREFIX ) >= 0;
	}

}
